;(function(){

	window._w.increments = {

		ti : null,
		itemId : null,

		onTemplateReady : function( template, event, eventData )
		{
			_w.increments.ti = _t[template];

			_w.increments.initGrid();

			// Increment grid
			if (null == App.API.taskContract('gridIncrement'))
			{
				App.API.getTask(
						'gridIncrement', 'Auction', 'Increment.List', null,
						{}, _w.increments.loadIncrementGrid, _w.taskContractError
						);
			}
			else
			{
				_w.increments.loadIncrementGrid( null, {}, {} );
			}
			if (null == App.API.taskContract('addIncrement'))
			{
				App.API.getTask(
						'addIncrement', 'Auction', 'Increment.Create', null,
						{}, function () {}, _w.taskContractError
						);
			}
		},

		onTemplatePublished : function( template, event, eventData )
		{
			_w.increments.ti.hydrateParam('from', {
				type  : 'input',
				id    : 'from',
				title : 'From',
				value : ''
			});
			_w.increments.ti.hydrateParam('to', {
				type  : 'input',
				id    : 'to',
				title : 'To',
				value : ''
			});
			_w.increments.ti.hydrateParam('amount', {
				type  : 'input',
				id    : 'amount',
				title : 'Amount',
				value : ''
			});
			_w.increments._setupValidation();
			$('#btnNew').click(function() {
				_w.increments.itemId = null;
				$('#from').val('');
				$('#to').val('');
				$('#amount').val('');
				$('#btnSave').html(' Add ');
			});
		},

		initGrid : function()
		{

			_w.increments.ti.hydrate({
				// Increment grid
				'gridIncrementTitle': 'Manage increments',
				'gridIncrementColumnHeaders': {
					constructor: 'GridColumnHeader',
					items: {
						From: {
							id: 'gridIncrementColumn_From',
							title: 'FROM'
						},
						To: {
							id: 'gridIncrementColumn_To',
							title: 'TO'
						},
						Amount: {
							id: 'gridIncrementColumn_Amount',
							title: 'AMOUNT'
						}
					}
				},
				'gridIncrementRowRepeater': {}
			});

		},

		loadIncrementGrid : function( contract, data, options )
		{
			App.API.execTask(
					'gridIncrement', data, options,
					_w.increments._onIncrementGridDataReceived, _w.taskExecError
					);
		},

		_onIncrementGridDataReceived : function( response )
		{
			_w.increments.ti.hydrateParam('gridIncrementRowRepeater', {});
			var gridData = [];
			for (var i = 0; i < response.Data.length; i++)
			{
				var row = response.Data[i];
				gridData.push({
					prepend: {
						Amount  : 'R '
					},
					rowId : row.id,
					onClick : function(meta) {
						_w.increments.itemId = meta.rowId;
						$('#from').val(meta.items.From);
						$('#to').val(meta.items.To);
						$('#amount').val(meta.items.Amount);
						$('#btnSave').html(' Update ');
					},
					items: {
						'id'     : row.id,
						'From'   : row.from ? row.from : '',
						'To'     : row.to ? row.to : '',
						'Amount' : row.amount ? row.amount : ''
					}
				});
			}
			_w.increments.ti.hydrateParam('gridIncrementRowRepeater', {
				constructor : 'GridDataRow',
				items       : gridData
			});
		},

		_setupValidation : function ()
		{
			$('#frmIncrementView').validate({
				"rules": {
					name: "required",
					from: {digits: true, required: true},
					to: {digits: true, required: true},
					amount: {number: true, required: true}
				},
				messages: {
					name : "This field is required."
				},
				submitHandler: function( form ) {
					$('#btnSave').prop('disabled', true);
					var data = {
							Increment: {
								from: $('#from').val(),
								to: $('#to').val(),
								amount: $('#amount').val()
							}
					};
					if (null == _w.increments.itemId)
					{
						App.API.execTask(
								'addIncrement', data, {},
								function() {
									$('#from').val('');
									$('#to').val('');
									$('#amount').val('');
									_w.increments.loadIncrementGrid( null, {}, {} );
									$('#btnSave').prop('disabled', false);
									$('#btnSave').html(' Add ');
								}, _w.taskExecError
							);
					}
					else
					{
						App.API.getTask(
								'updateIncrement' + _w.increments.itemId, 'Auction', 'Increment.Update', null,
								{id: _w.increments.itemId}, function () {
									App.API.execTask(
											'updateIncrement' + _w.increments.itemId, data, {},
											function() {
												$('#from').val('');
												$('#to').val('');
												$('#amount').val('');
												_w.increments.loadIncrementGrid( null, {}, {} );
												$('#btnSave').prop('disabled', false);
												$('#btnSave').html(' Add ');
											}, _w.taskExecError
										);
								}, _w.taskContractError
								);
					}
				}
			});
			$('#btnSave').prop('disabled', false);
		}

	};

})();