;(function(){

	window._w.viewuserpermissions = {

		itemId : null,
		itemData : null,
		formMeta : null,
		ti : null,

		onTemplateReady : function( template, event, eventData )
		{
			_w.viewuserpermissions.ti = _t[template];

			_w.viewuserpermissions.setPermissionsViewFormMeta();
			_w.viewuserpermissions.ti.hydrate(_w.viewuserpermissions.formMeta);

			// Retrieve initial view data.
			_w.viewuserpermissions.itemId = App.Util.getUrlParam('id');
			App.API.getTask(
				'updatePermissions:' + _w.viewuserpermissions.itemId, 'User', 'Permissions.Update', null,
				{'id':_w.viewuserpermissions.itemId},
				$.proxy( _w.viewuserpermissions._onPermissionsViewDataReceived, this ),
				_w.taskContractError
			);
		},

		onTemplatePublished : function( template, event, eventData )
		{
			_w.viewuserpermissions.ti = _t[template];
		},

		_routeToActive : function()
		{
			App.API.directRoute(
				'routePermissionsActive:' + _w.viewuserpermissions.itemId, 'Permissions', 'Workflow.MoveToActive',
				_w.viewuserpermissions.itemId, {}, _w.viewuserpermissions._onPermissionsUpdated, _w.taskExecError
			);
		},

		_routeToSuspended : function()
		{
			App.API.directRoute(
				'routePermissionsSuspended:' + _w.viewuserpermissions.itemId, 'Permissions', 'Workflow.MoveToSuspended',
				_w.viewuserpermissions.itemId, {}, _w.viewuserpermissions._onPermissionsUpdated, _w.taskExecError
			);
		},

		_routeToArchived : function()
		{
			App.API.directRoute(
				'routePermissionsArchive:' + _w.viewuserpermissions.itemId, 'Permissions', 'Workflow.MoveToArchive',
				_w.viewuserpermissions.itemId, {}, _w.viewuserpermissions._onPermissionsUpdated, _w.taskExecError
			);
		},

		setPermissionsViewFormMeta : function( data )
		{
			if (!data)
			{
				data = {};
			}
			_w.viewuserpermissions.formMeta = {
				'name': data.name ? data.name : '',
				'accessPortalModule' : {
					type  : 'checkbox',
					id    : 'accessPortalModule',
					title : 'Portal access',
					value : data.accessPortalModule ? true : false,
					onChange : function() {
						$('#portalPagesSection input').prop('disabled', !$(this).prop('checked'));
						$('#portalPagesSection .control-group').toggleClass('warning', !$(this).prop('checked'));
						$('#suAccessSection input').prop('disabled', !$(this).prop('checked'));
						$('#suAccessSection .control-group').toggleClass('warning', !$(this).prop('checked'));
						$('#settingsPageSection input').prop('disabled', !$(this).prop('checked'));
						$('#settingsPageSection .control-group').toggleClass('warning', !$(this).prop('checked'));
						$('#valuationPageSection input').prop('disabled', !$(this).prop('checked'));
						$('#valuationPageSection .control-group').toggleClass('warning', !$(this).prop('checked'));
						$('#pgPageSection input').prop('disabled', !$(this).prop('checked'));
						$('#pgPageSection .control-group').toggleClass('warning', !$(this).prop('checked'));
						$('#auctionPageSection input').prop('disabled', !$(this).prop('checked'));
						$('#tcPageSection input').prop('disabled', !$(this).prop('checked'));
						$('#stockPageSection input').prop('disabled', !$(this).prop('checked'));
						$('#stockPageSection .control-group').toggleClass('warning', !$(this).prop('checked'));
						if ($(this).prop('checked'))
						{
							$('#valuationView').change();
							$('#pgView').change();
							$('#stockView').change();
							$('#settingsPage').change();
							$('#valuationPage').change();
							$('#pgPage').change();
							$('#auctionPage').change();
							$('#stockPage').change();
							$('#suAccess').change();
						}
					}
				},
				'suAccess' : {
					type  : 'checkbox',
					id    : 'suAccess',
					title : 'Super user access',
					value : data.suAccess ? true : false,
					onChange : function() {
						$('#suAccessSection input').prop('disabled', !$(this).prop('checked'));
						$('#suAccessSection .control-group').toggleClass('warning', !$(this).prop('checked'));
					}
				},
				'settingsPage' : {
					type  : 'checkbox',
					id    : 'settingsPage',
					title : 'Settings page',
					value : data.settingsPage ? true : false,
					onChange : function() {
						$('#settingsPageSection input').prop('disabled', !$(this).prop('checked'));
						$('#settingsPageSection .control-group').toggleClass('warning', !$(this).prop('checked'));
					}
				},
				'valuationPage' : {
					type  : 'checkbox',
					id    : 'valuationPage',
					title : 'Valuation page',
					value : data.valuationPage ? true : false,
					onChange : function() {
						$('#valuationPageSection input').prop('disabled', !$(this).prop('checked'));
						$('#valuationPageSection .control-group').toggleClass('warning', !$(this).prop('checked'));
						if ($(this).prop('checked'))
						{
							$('#valuationView').change();
						}
					}
				},
				'pgPage' : {
					type  : 'checkbox',
					id    : 'pgPage',
					title : 'Price guide page',
					value : data.pgPage ? true : false,
					onChange : function() {
						$('#pgPageSection input').prop('disabled', !$(this).prop('checked'));
						$('#pgPageSection .control-group').toggleClass('warning', !$(this).prop('checked'));
						if ($(this).prop('checked'))
						{
							$('#pgView').change();
						}
					}
				},
				'stockPage' : {
					type  : 'checkbox',
					id    : 'stockPage',
					title : 'Stock page',
					value : data.stockPage ? true : false,
					onChange : function() {
						$('#stockPageSection input').prop('disabled', !$(this).prop('checked'));
						$('#stockPageSection .control-group').toggleClass('warning', !$(this).prop('checked'));
						if ($(this).prop('checked'))
						{
							$('#stockView').change();
						}
					}
				},
				'auctionPage' : {
					type  : 'checkbox',
					id    : 'auctionPage',
					title : 'Auction page',
					value : data.auctionPage ? true : false,
							onChange : function() {
								$('#auctionPageSection input').prop('disabled', !$(this).prop('checked'));
								$('#auctionPageSection .control-group').toggleClass('warning', !$(this).prop('checked'));
							}
				},
				'tcPage' : {
					type  : 'checkbox',
					id    : 'tcPage',
					title : 'Trade Center page',
					value : data.tcPage ? true : false,
							onChange : function() {
								$('#tcPageSection input').prop('disabled', !$(this).prop('checked'));
								$('#tcPageSection .control-group').toggleClass('warning', !$(this).prop('checked'));
							}
				},
				'suGroupFull' : {
					type  : 'checkbox',
					id    : 'suGroupFull',
					title : 'Group filtering',
					value : data.suGroupFull ? true : false
				},
				'suDivisionFull' : {
					type  : 'checkbox',
					id    : 'suDivisionFull',
					title : 'Division filtering',
					value : data.suDivisionFull ? true : false
				},
				'suCompanyFull' : {
					type  : 'checkbox',
					id    : 'suCompanyFull',
					title : 'Company filtering',
					value : data.suCompanyFull ? true : false
				},
				'settingsUser' : {
					type  : 'checkbox',
					id    : 'settingsUser',
					title : 'User management',
					value : data.settingsUser ? true : false
				},
				'settingsClub' : {
					type  : 'checkbox',
					id    : 'settingsClub',
					title : 'Club management',
					value : data.settingsClub ? true : false
				},
				'settingsMembership' : {
					type  : 'checkbox',
					id    : 'settingsMembership',
					title : 'Membership management',
					value : data.settingsMembership ? true : false
				},
				'settingsRetail' : {
					type  : 'checkbox',
					id    : 'settingsRetail',
					title : 'Retail management',
					value : data.settingsRetail ? true : false
				},
				'settingsReport' : {
					type  : 'checkbox',
					id    : 'settingsReport',
					title : 'Reports',
					value : data.settingsReport ? true : false
				},
				'settingsHpiReport' : {
					type  : 'checkbox',
					id    : 'settingsHpiReport',
					title : 'HPI Reports',
					value : data.settingsHpiReport ? true : false
				},
				'settingsGridExport' : null,
				'settingsDealership' : {
					type  : 'checkbox',
					id    : 'settingsDealership',
					title : 'Update dealership details',
					value : data.settingsDealership ? true : false
				},
				'settingsPersonal' : {
					type  : 'checkbox',
					id    : 'settingsPersonal',
					title : 'Update personal details',
					value : data.settingsPersonal ? true : false
				},
				'settingsResetPin' : {
					type  : 'checkbox',
					id    : 'settingsResetPin',
					title : 'Reset pin',
					value : data.settingsResetPin ? true : false
				},
				'valuationView' : {
					type  : 'checkbox',
					id    : 'valuationView',
					title : 'View valuation',
					value : data.valuationView ? true : false,
					onChange : function() {
						$('#valuationViewSection input').prop('disabled', !$(this).prop('checked'));
						$('#valuationViewSection .control-group').toggleClass('warning', !$(this).prop('checked'));
					}
				},
				'valuationGridExport' : {
					type  : 'checkbox',
					id    : 'valuationGridExport',
					title : 'Export valuation data',
					value : data.valuationGridExport ? true : false
				},
				'valuationIsSales' : {
					type  : 'checkbox',
					id    : 'valuationIsSales',
					title : 'Is a sales person',
					value : data.valuationIsSales ? true : false
				},
				'valuationIsValuator' : {
					type  : 'checkbox',
					id    : 'valuationIsValuator',
					title : 'Is a valuator',
					value : data.valuationIsValuator ? true : false
				},
				'valuationCreateNew' : {
					type  : 'checkbox',
					id    : 'valuationCreateNew',
					title : 'Create valuation and save as New',
					value : data.valuationCreateNew ? true : false
				},
				'valuationCreateSales' : {
					type  : 'checkbox',
					id    : 'valuationCreateSales',
					title : 'Create valuation and send to Valuator(s)',
					value : data.valuationCreateSales ? true : false
				},
				'valuationCreatePending' : {
					type  : 'checkbox',
					id    : 'valuationCreatePending',
					title : 'Create valuation and save as Pending',
					value : data.valuationCreatePending ? true : false
				},
				'valuationCreatePriceguide' : {
					type  : 'checkbox',
					id    : 'valuationCreatePriceguide',
					title : 'Create valuation and send to Price Guide',
					value : data.valuationCreatePriceguide ? true : false
				},
				'valuationCreateComplete' : {
					type  : 'checkbox',
					id    : 'valuationCreateComplete',
					title : 'Create valuation and send to Sales',
					value : data.valuationCreateComplete ? true : false
				},
				'valuationCreateStock' : {
					type  : 'checkbox',
					id    : 'valuationCreateStock',
					title : 'Create valuation and send to Stock',
					value : data.valuationCreateStock ? true : false
				},
				'valuationUpdate' : {
					type  : 'checkbox',
					id    : 'valuationUpdate',
					title : 'Update a valuation',
					value : data.valuationUpdate ? true : false
				},
				'valuationUpdateDamages' : {
					type  : 'checkbox',
					id    : 'valuationUpdateDamages',
					title : 'Update damages',
					value : data.valuationUpdateDamages ? true : false
				},
				'valuationUpdateCoverReceived' : {
					type  : 'checkbox',
					id    : 'valuationUpdateCoverReceived',
					title : 'Update cover received',
					value : data.valuationUpdateCoverReceived ? true : false
				},
				'valuationUploadPhotos' : {
					type  : 'checkbox',
					id    : 'valuationUploadPhotos',
					title : 'Upload photos',
					value : data.valuationUploadPhotos ? true : false
				},
				'valuationPricingDetails' : {
                    type  : 'checkbox',
                    id    : 'valuationPricingDetails',
                    title : 'Full pricing details',
                    value : data.valuationPricingDetails ? true : false
                },
                'valuationCalendar' : {
                    type  : 'checkbox',
                    id    : 'valuationCalendar',
                    title : 'Enable Valuation Calendar',
                    value : data.valuationCalendar ? true : false
                },
				'valuationRoutePending' : {
					type  : 'checkbox',
					id    : 'valuationRoutePending',
					title : 'Update and send to Pending',
					value : data.valuationRoutePending ? true : false
				},
				'valuationRouteComplete' : {
					type  : 'checkbox',
					id    : 'valuationRouteComplete',
					title : 'Update and send to Sales',
					value : data.valuationRouteComplete ? true : false
				},
				'valuationRouteStock' : {
					type  : 'checkbox',
					id    : 'valuationRouteStock',
					title : 'Update and send to Stock',
					value : data.valuationRouteStock ? true : false
				},
				'valuationRoutePriceguide' : {
					type  : 'checkbox',
					id    : 'valuationRoutePriceguide',
					title : 'Update and send to Price Guide',
					value : data.valuationRoutePriceguide ? true : false
				},
				'valuationRouteDealDone' : {
					type  : 'checkbox',
					id    : 'valuationRouteDealDone',
					title : 'Update and send to Deal Done',
					value : data.valuationRouteDealDone ? true : false
				},
				'valuationRouteDealNotDone' : {
					type  : 'checkbox',
					id    : 'valuationRouteDealNotDone',
					title : 'Update and send to Deal Not Done',
					value : data.valuationRouteDealNotDone ? true : false
				},
				'valuationArchive' : {
					type  : 'checkbox',
					id    : 'valuationArchive',
					title : 'Archive valuation',
					value : data.valuationArchive ? true : false
				},
				'valuationUnarchive' : {
					type  : 'checkbox',
					id    : 'valuationUnarchive',
					title : 'Unarchive valuation',
					value : data.valuationUnarchive ? true : false
				},
				'valuationPrint' : {
					type  : 'checkbox',
					id    : 'valuationPrint',
					title : 'Print valuation',
					value : data.valuationPrint ? true : false
				},
				'valuationB4cReport' : {
					type  : 'checkbox',
					id    : 'valuationB4cReport',
					title : 'Request B4C Report',
					value : data.valuationB4cReport ? true : false
				},
				'valuationBmw' : {
					type  : 'checkbox',
					id    : 'valuationBmw',
					title : 'Request BMW Report',
					value : data.valuationBmw ? true : false
				},
				'pgGridExport' : {
					type  : 'checkbox',
					id    : 'pgGridExport',
					title : 'Export price guide data',
					value : data.pgGridExport ? true : false
				},
				'pgView' : {
					type  : 'checkbox',
					id    : 'pgView',
					title : 'View price guide entry',
					value : data.pgView ? true : false,
					onChange : function() {
						$('#pgViewSection input').prop('disabled', !$(this).prop('checked'));
						$('#pgViewSection .control-group').toggleClass('warning', !$(this).prop('checked'));
					}
				},
				'pgB4cReport' : {
					type  : 'checkbox',
					id    : 'pgB4cReport',
					title : 'Request B4C Report',
					value : data.pgB4cReport ? true : false
				},
				'pgMakeOffer' : {
					type  : 'checkbox',
					id    : 'pgMakeOffer',
					title : 'Make an offer',
					value : data.pgMakeOffer ? true : false
				},
				'pgUpdateOffer' : {
					type  : 'checkbox',
					id    : 'pgUpdateOffer',
					title : 'Update an offer',
					value : data.pgUpdateOffer ? true : false
				},
				'pgPrint' : {
					type  : 'checkbox',
					id    : 'pgPrint',
					title : 'Print',
					value : data.pgPrint ? true : false
				},
				'pgArchive' : {
					type  : 'checkbox',
					id    : 'pgArchive',
					title : 'Archive',
					value : data.pgArchive ? true : false
				},
				'pgUnArchive' : {
					type  : 'checkbox',
					id    : 'pgUnArchive',
					title : 'Unarchive',
					value : data.pgUnArchive ? true : false
				},
				'stockGridExport' : {
					type  : 'checkbox',
					id    : 'stockGridExport',
					title : 'Export stock data',
					value : data.stockGridExport ? true : false
				},
                'stockAuctionReportGridExport' : {
                    type  : 'checkbox',
                    id    : 'stockAuctionReportGridExport',
                    title : 'Stock auction report data',
                    value : data.stockAuctionReportGridExport ? true : false
                },
                'stockBulkImportDrive' : {
                    type  : 'checkbox',
                    id    : 'stockBulkImportDrive',
                    title : 'Stock bulk import Drive',
                    value : data.stockBulkImportDrive ? true : false
                },
                'stockBulkImportPinnacle' : {
                    type  : 'checkbox',
                    id    : 'stockBulkImportPinnacle',
                    title : 'Stock bulk import Pinnacle',
                    value : data.stockBulkImportPinnacle ? true : false
                },
				'stockView' : {
					type  : 'checkbox',
					id    : 'stockView',
					title : 'View stock',
					value : data.stockView ? true : false,
					onChange : function() {
						$('#stockViewSection input').prop('disabled', !$(this).prop('checked'));
						$('#stockViewSection .control-group').toggleClass('warning', !$(this).prop('checked'));
					}
				},
				'stockUpdate' : {
					type  : 'checkbox',
					id    : 'stockUpdate',
					title : 'Update stock',
					value : data.stockUpdate ? true : false
				},
				'stockUpdateDamages' : {
					type  : 'checkbox',
					id    : 'stockUpdateDamages',
					title : 'Update damages',
					value : data.stockUpdateDamages ? true : false
				},
				'stockUpdateCoverReceived' : {
					type  : 'checkbox',
					id    : 'stockUpdateCoverReceived',
					title : 'Update cover received',
					value : data.stockUpdateCoverReceived ? true : false
				},
				'stockUploadPhotos' : {
					type  : 'checkbox',
					id    : 'stockUploadPhotos',
					title : 'Upload photos',
					value : data.stockUploadPhotos ? true : false
				},
				'stockRouteRetail' : {
					type  : 'checkbox',
					id    : 'stockRouteRetail',
					title : 'Update and send to Retail',
					value : data.stockRouteRetail ? true : false
				},
				'stockRouteAuction' : {
					type  : 'checkbox',
					id    : 'stockRouteAuction',
					title : 'Update and send to Auction',
					value : data.stockRouteAuction ? true : false
				},
				'stockReclaimRetail' : {
					type  : 'checkbox',
					id    : 'stockReclaimRetail',
					title : 'Reclaim from Retail',
					value : data.stockReclaimRetail ? true : false
				},
				'stockRoutePriceguide' : {
					type  : 'checkbox',
					id    : 'stockRoutePriceguide',
					title : 'Update and send to Price Guide',
					value : data.stockRoutePriceguide ? true : false
				},
				'stockRouteValuation' : {
					type  : 'checkbox',
					id    : 'stockRouteValuation',
					title : 'Update and send to Valuation',
					value : data.stockRouteValuation ? true : false
				},
				'stockPrint' : {
					type  : 'checkbox',
					id    : 'stockPrint',
					title : 'Print',
					value : data.stockPrint ? true : false
				},
				'stockArchive' : {
					type  : 'checkbox',
					id    : 'stockArchive',
					title : 'Archive',
					value : data.stockArchive ? true : false
				},
				'stockUnarchive' : {
					type  : 'checkbox',
					id    : 'stockUnarchive',
					title : 'Unarchive',
					value : data.stockUnarchive ? true : false
				},
				'auctionGridExport' : {
					type  : 'checkbox',
					id    : 'auctionGridExport',
					title : 'Export auction data',
					value : data.auctionGridExport ? true : false
				},
				'auctionBid' : {
					type  : 'checkbox',
					id    : 'auctionBid',
					title : 'Bid on auction',
					value : data.auctionBid ? true : false
				},
				'tcGridExport' : {
					type  : 'checkbox',
					id    : 'tcGridExport',
					title : 'Export trade center data',
					value : data.tcGridExport ? true : false
				},
				'appCreateValuation' : {
					type  : 'checkbox',
					id    : 'appCreateValuation',
					title : 'Create valuation',
					value : data.appCreateValuation ? true : false
				},
				'appCompleteValuation' : {
					type  : 'checkbox',
					id    : 'appCompleteValuation',
					title : 'Complete portal valuation',
					value : data.appCompleteValuation ? true : false
				},
				'accessAdminModule' : {
					type  : 'checkbox',
					id    : 'accessAdminModule',
					title : 'Admin access',
					value : data.accessAdminModule ? true : false,
					onChange : function() {
						$('#adminPageSection input').prop('disabled', !$(this).prop('checked'));
						$('#adminPageSection .control-group').toggleClass('warning', !$(this).prop('checked'));
					}
				},
				'adminPage' : {
					type  : 'checkbox',
					id    : 'adminPage',
					title : 'Manage permissions',
					value : data.adminPage ? true : false
				},
				'adminRegistration' : {
					type  : 'checkbox',
					id    : 'adminRegistration',
					title : 'Manage registrations',
					value : data.adminRegistration ? true : false
				},
				'adminReport' : {
					type  : 'checkbox',
					id    : 'adminReport',
					title : 'Reports',
					value : data.adminReport ? true : false
				},
				'adminCommunication' : {
					type  : 'checkbox',
					id    : 'adminCommunication',
					title : 'Manage communications',
					value : data.adminCommunication ? true : false
				},
				'adminSettings' : {
					type  : 'checkbox',
					id    : 'adminSettings',
					title : 'Manage system settings',
					value : data.adminSettings ? true : false
				},
				'adminUser' : {
					type  : 'checkbox',
					id    : 'adminUser',
					title : 'Manage system users',
					value : data.adminUser ? true : false
				},
				'adminDealer' : {
					type  : 'checkbox',
					id    : 'adminDealer',
					title : 'Manage dealerships',
					value : data.adminDealer ? true : false
				},
				'adminAuction' : {
					type  : 'checkbox',
					id    : 'adminAuction',
					title : 'Manage auctions',
					value : data.adminAuction ? true : false
				},
                'historicalPage' : {
					type  : 'checkbox',
					id    : 'historicalPage',
					title : 'Historical Auction Data',
					value : data.historicalPage ? true : false
				},
                'etpGemDmd' : {
                    type  : 'checkbox',
                    id    : 'etpGemDmd',
                    title : 'GEM DMD',
                    value : data.etpGemDmd ? true : false
                }
			};
		},

		_onPermissionsViewDataReceived : function( response )
		{
			_w.viewuserpermissions.itemId = response.Data.id;
			_w.viewuserpermissions.itemData = response.Data;
			_w.viewuserpermissions.setPermissionsViewFormMeta(response.Data);
			_w.viewuserpermissions.ti.hydrate(_w.viewuserpermissions.formMeta);
			_w.viewuserpermissions._setupValidation();
			$('#valuationView').change();
			$('#pgView').change();
			$('#stockView').change();
			$('#settingsPage').change();
			$('#valuationPage').change();
			$('#pgPage').change();
			$('#stockPage').change();
			$('#auctionPage').change();
			$('#suAccess').change();
			$('#accessPortalModule').change();
			$('#accessAdminModule').change();
		},

		_setupValidation : function ()
		{
			$('#frmPermissionsView').validate({
				submitHandler: function( form ) {
					$('#btnUpdate').prop('disabled', true);
					var data = _w.viewuserpermissions._prepPermissionsUpdateData();
					App.API.execTask(
							'updatePermissions:' + _w.viewuserpermissions.itemId, data, {},
							_w.viewuserpermissions._onPermissionsUpdated, _w.taskExecError
						);
				}
			});
			$('#btnUpdate').prop('disabled', false);
		},

		_prepPermissionsUpdateData : function()
		{
			return {Permissions:_w.viewuserpermissions.ti.harvest()};
		},

		_onPermissionsUpdated : function( response )
		{
			window.location.hash = '/userpermissions';
		}

	};

})();