;(function(){

	window._w.xmlrpccallbacklog = {

		ti : null,

		onTemplateReady : function( template, event, eventData )
		{
			_w.xmlrpccallbacklog.ti = _t[template];

			_w.xmlrpccallbacklog.initGrids();

			// XmlRpc grid
			if (null == App.API.taskContract('gridSystemXmlRpcCallback'))
			{
				App.API.getTask(
						'gridSystemXmlRpcCallback', 'Valuation', 'XmlRpcCallbackLog.Grid', null,
						{}, _w.xmlrpccallbacklog.loadXmlRpcGrid, _w.taskContractError
						);
			}
			else
			{
				_w.xmlrpccallbacklog.loadXmlRpcGrid( null, {}, {} );
			}
		},

		onTemplatePublished : function( template, event, eventData )
		{
			$(".gridXmlRpcFilter").keypress(function (evt) {
				var charCode = evt.charCode || evt.keyCode;
				if (charCode  == 13) { //Enter key's keycode
					$('#btnXmlRpcSearch').click();
				}
			});

			_w.xmlrpccallbacklog.ti = _t[template];

			// XmlRpc grid
            $('#btnXmlRpcClearSearch').click(_w.xmlrpccallbacklog.clearXmlRpcGridContext);
            $('#btnXmlRpcSearch').click(_w.xmlrpccallbacklog.searchXmlRpcGrid);

		},

		exportXmlRpcGrid : function()
		{
			App.API.execTask(
					'gridSystemXmlRpcCallback', {}, {'ExportToExcel': true},
					_w.xmlrpccallbacklog._onExportReceived, _w.taskExecError,
					'EXPORT', true
					);
		},

		initGrids : function()
		{

			_w.xmlrpccallbacklog.ti.hydrate({
				// XmlRpc grid
				'gridXmlRpcTitle': 'View xml-rpc callback logs',
				'gridTitleButtons': {
					constructor: 'Button',
					items: {
						/*Export: {
							preset: 'GridExport',
							id: 'exportAuctionGrid',
							handler: _w.xmlrpccallbacklog.exportXmlRpcGrid
						}*/
					}
				},
				'gridXmlRpcColumnHeaders': {
					constructor: 'GridColumnHeader',
					items: {
						ClientName: {
							id: 'gridXmlRpcColumn_ClientName',
							title: 'CLIENT NAME',
							orderAsc: {
								id: 'gridXmlRpcOrder_ClientNameAsc',
								bind: $.proxy(_w.xmlrpccallbacklog.orderXmlRpcGrid, this, 'xmlRpcClient.clientName', 'ASC')
							},
							orderDesc: {
								id: 'gridXmlRpcOrder_ClientNameDesc',
								bind: $.proxy(_w.xmlrpccallbacklog.orderXmlRpcGrid, this, 'xmlRpcClient.clientName', 'DESC')
							}
						},
						ValuationNumber: {
							id: 'gridXmlRpcColumn_ValuationNumber',
							title: 'VALUATION NUMBER',
							orderAsc: {
								id: 'gridXmlRpcOrder_ValuationNumberAsc',
								bind: $.proxy(_w.xmlrpccallbacklog.orderXmlRpcGrid, this, 'valuation.valuationNumber', 'ASC')
							},
							orderDesc: {
								id: 'gridXmlRpcOrder_ValuationNumberDesc',
								bind: $.proxy(_w.xmlrpccallbacklog.orderXmlRpcGrid, this, 'valuation.valuationNumber', 'DESC')
							}
						},
						CallbackUrl: {
							id: 'gridXmlRpcColumn_CallbackUrl',
							title: 'CALLBACK URL',
							orderAsc: {
								id: 'gridXmlRpcOrder_CallbackUrlAsc',
								bind: $.proxy(_w.xmlrpcclients.orderXmlRpcGrid, this, 'xmlRpcCallbackLog.callbackUrl', 'ASC')
							},
							orderDesc: {
								id: 'gridXmlRpcOrder_CallbackUrlDesc',
								bind: $.proxy(_w.xmlrpcclients.orderXmlRpcGrid, this, 'xmlRpcCallbackLog.callbackUrl', 'DESC')
							}
						},
						MethodName: {
							id: 'gridXmlRpcColumn_MethodName',
							title: 'METHOD',
							orderAsc: {
								id: 'gridXmlRpcOrder_MethodNameAsc',
								bind: $.proxy(_w.xmlrpccallbacklog.orderXmlRpcGrid, this, 'xmlRpcCallbackLog.methodName', 'ASC')
							},
							orderDesc: {
								id: 'gridXmlRpcOrder_MethodNameDesc',
								bind: $.proxy(_w.xmlrpccallbacklog.orderXmlRpcGrid, this, 'xmlRpcCallbackLog.methodName', 'DESC')
							}
						},
						Attempts: {
							id: 'gridXmlRpcColumn_Attempts',
							title: 'ATTEMPTS',
							orderAsc: {
								id: 'gridXmlRpcOrder_AttemptsAsc',
								bind: $.proxy(_w.xmlrpccallbacklog.orderXmlRpcGrid, this, 'xmlRpcCallbackLog.attempts', 'ASC')
							},
							orderDesc: {
								id: 'gridXmlRpcOrder_AttemptsDesc',
								bind: $.proxy(_w.xmlrpccallbacklog.orderXmlRpcGrid, this, 'xmlRpcCallbackLog.attempts', 'DESC')
							}
						},
						Created: {
							id: 'gridXmlRpcColumn_Created',
							title: 'CREATED',
							orderAsc: {
								id: 'gridXmlRpcOrder_CreatedAsc',
								bind: $.proxy(_w.xmlrpccallbacklog.orderXmlRpcGrid, this, 'xmlRpcCallbackLog.created', 'ASC')
							},
							orderDesc: {
								id: 'gridXmlRpcOrder_CreatedDesc',
								bind: $.proxy(_w.xmlrpccallbacklog.orderXmlRpcGrid, this, 'xmlRpcCallbackLog.created', 'DESC')
							}
						},
						Status: {
							id: 'gridXmlRpcColumn_Status',
							title: 'STATUS',
							orderAsc: {
								id: 'gridXmlRpcOrder_StatusAsc',
								bind: $.proxy(_w.xmlrpccallbacklog.orderXmlRpcGrid, this, 'xmlRpcCallbackLog.status', 'ASC')
							},
							orderDesc: {
								id: 'gridXmlRpcOrder_StatusDesc',
								bind: $.proxy(_w.xmlrpccallbacklog.orderXmlRpcGrid, this, 'xmlRpcCallbackLog.status', 'DESC')
							}
						}
					}
				},
				'gridXmlRpcColumnFilters': {
					constructor: 'GridColumnFilter',
					items: {
						ClientName : {
							id: 'gridXmlRpcFilter_ClientName',
							context: 'gridXmlRpcFilter'
						},
						ValuationNumber : {
							id: 'gridXmlRpcFilter_ValuationNumber',
							context: 'gridXmlRpcFilter'
						},
						CallbackUrl : {
							id: 'gridXmlRpcFilter_CallbackUrl',
							context: 'gridXmlRpcFilter'
						},
						MethodName: {
							id: 'gridXmlRpcFilter_MethodName',
							context: 'gridXmlRpcFilter'
						},
						Attempts : {
							id: 'gridXmlRpcFilter_Attempts',
							context: 'gridXmlRpcFilter'
						},
						Created: {
							id: 'gridXmlRpcFilter_Created',
							context: 'gridXmlRpcFilter'
						},
						Status: {
							id: 'gridXmlRpcFilter_Status',
							context: 'gridXmlRpcFilter'
						}
					}
				},
				'gridXmlRpcRowRepeater': {},
				'gridXmlRpcPager': {}
			});

		},

		loadXmlRpcGrid : function( contract, data, options )
		{
			App.API.execTask(
					'gridSystemXmlRpcCallback', data, options,
					_w.xmlrpccallbacklog._onXmlRpcGridDataReceived, _w.taskExecError
					);
		},

		pageXmlRpcGrid : function( page )
		{
			_w.xmlrpccallbacklog.loadXmlRpcGrid( {}, {"Grid":{"Page":page}} );
		},

		clearXmlRpcGridContext : function()
		{
			$('.gridXmlRpcContext').val('');
			$('.gridXmlRpcFilter').val('');
			_w.xmlrpccallbacklog.searchXmlRpcGrid();
		},

		searchXmlRpcGrid : function()
		{
			var filter = {
					count: 0,
					filters: {}
			};

			filter = _w.filterIfnotEmpty(filter, 'gridXmlRpcFilter_ClientName', 'xmlRpcClient.clientName');
			filter = _w.filterIfnotEmpty(filter, 'gridXmlRpcFilter_ValuationNumber', 'valuation.valuationNumber');
			filter = _w.filterIfnotEmpty(filter, 'gridXmlRpcFilter_CallbackUrl', 'xmlRpcCallbackLog.callbackUrl');
			filter = _w.filterIfnotEmpty(filter, 'gridXmlRpcFilter_MethodName', 'xmlRpcCallbackLog.methodName');
			filter = _w.filterIfnotEmpty(filter, 'gridXmlRpcFilter_Attempts', 'xmlRpcCallbackLog.attempts');
			filter = _w.filterIfnotEmpty(filter, 'gridXmlRpcFilter_Created', 'xmlRpcCallbackLog.created');
			filter = _w.filterIfnotEmpty(filter, 'gridXmlRpcFilter_Status', 'xmlRpcCallbackLog.status');
			var request = {"Grid":{
			    "Page": 1,
			    "Filter": filter.filters
			  }};
			_w.xmlrpccallbacklog.loadXmlRpcGrid( null, request, {} );
		},

		_onXmlRpcGridDataReceived : function( response )
		{
			_w.xmlrpccallbacklog.ti.hydrateParam('gridXmlRpcRowRepeater', {});
			_w.populateFilters(response.Data.Meta.Filters, {
				'xmlRpcClient.clientName' 				: 'gridXmlRpcFilter_ClientName',
				'valuation.valuationNumber' 			: 'gridXmlRpcFilter_ValuationNumber',
				'xmlRpcCallbackLog.callbackUrl' 		: 'gridXmlRpcFilter_CallbackUrl',
				'xmlRpcCallbackLog.methodName' 			: 'gridXmlRpcFilter_MethodName',
				'xmlRpcCallbackLog.attempts' 			: 'gridXmlRpcFilter_Attempts',
				'xmlRpcCallbackLog.created'				: 'gridXmlRpcFilter_Created',
				'xmlRpcCallbackLog.status'				: 'gridXmlRpcFilter_Status'
			});
			_w.xmlrpcrequestlog.packetData = {};
			_w.xmlrpcrequestlog.responseData = {};
			var gridData = [];
			for (var i = 0; i < response.Data.DataSet.length; i++)
			{
				var row = response.Data.DataSet[i];
				_w.xmlrpcrequestlog.packetData['row' + row.id] = row.packet;
				_w.xmlrpcrequestlog.responseData['row' + row.id] = row.response;
				gridData.push({
					rowId: row.id,
					bind: function(meta) {
						$('#row' +  meta.rowId).click(function(e){
							var id = $(this).attr('id');

							var jspr = JSON.stringify(_w.xmlrpcrequestlog.packetData[id], undefined, 2);
							jspr = jspr.replace(/&/g, '&amp;').replace(/</g, '&lt;').replace(/>/g, '&gt;');
							jspr = jspr.replace(/("(\\u[a-zA-Z0-9]{4}|\\[^u]|[^\\"])*"(\s*:)?|\b(true|false|null)\b|-?\d+(?:\.\d*)?(?:[eE][+\-]?\d+)?)/g, function (match) {
						        var cls = 'number';
						        if (/^"/.test(match)) {
						            if (/:$/.test(match)) {
						                cls = 'key';
						            } else {
						                cls = 'string';
						            }
						        } else if (/true|false/.test(match)) {
						            cls = 'boolean';
						        } else if (/null/.test(match)) {
						            cls = 'null';
						        }
						        return '<span class="' + cls + '">' + match + '</span>';
						    });
							$('#modalbody').html('<pre>' + "Packet:\n" + jspr + '</pre><br/><br/>');

							var jspr = JSON.stringify(_w.xmlrpcrequestlog.responseData[id], undefined, 2);
							jspr = jspr.replace(/&/g, '&amp;').replace(/</g, '&lt;').replace(/>/g, '&gt;');
							jspr = jspr.replace(/("(\\u[a-zA-Z0-9]{4}|\\[^u]|[^\\"])*"(\s*:)?|\b(true|false|null)\b|-?\d+(?:\.\d*)?(?:[eE][+\-]?\d+)?)/g, function (match) {
								var cls = 'number';
								if (/^"/.test(match)) {
									if (/:$/.test(match)) {
										cls = 'key';
									} else {
										cls = 'string';
									}
								} else if (/true|false/.test(match)) {
									cls = 'boolean';
								} else if (/null/.test(match)) {
									cls = 'null';
								}
								return '<span class="' + cls + '">' + match + '</span>';
							});
							$('#modalbody').append('<pre>' + "Response:\n" + jspr + '</pre>');

							$('#myModal').modal('toggle');
						});
					},
					prepend: {},
					style: {},
					items: {
						'id'         			: row.id,
						'ClientName' 			: row.xmlRpcClient.clientName,
						'ValuationNumber'		: row.valuation.valuationNumber,
						'CallbackUrl'			: row.callbackUrl,
						'MethodName'			: row.methodName,
						'Attempts'				: row.attempts,
						'Created'				: row.created,
						'Status'				: row.status
				}
				});
			}
			_w.xmlrpccallbacklog.ti.hydrateParam('gridXmlRpcRowRepeater', {
				constructor : 'GridDataRow',
				items       : gridData
			});
			response.Data.Meta.itemName = 'userPager';
			response.Data.Meta.bind = _w.xmlrpccallbacklog.pageXmlRpcGrid;
			_w.xmlrpccallbacklog.ti.hydrateParam('gridXmlRpcPager', {
				constructor : 'GridPager',
				items       : [response.Data.Meta]
			});
		},

		orderXmlRpcGrid : function(field, direction)
		{
			var order = {};
			order[field] = direction;
			_w.xmlrpccallbacklog.loadXmlRpcGrid( {}, {"Grid":{"Page": 1, "OrderBy": order}} );
		},

		_onExportReceived : function( response )
		{
			var win = window.open();
			win.document.write(response);
		}

	};

})();