;(function(){

	window._w.changepinview = {

		itemId : null,
		itemData : null,
		formMeta : null,
		ti : null,
		limited : false,
		newItem : false,
		ownAccount : false,

		onViewTemplateReady : function( template, event, eventData )
		{
			_w.changepinview.ti = _t[template];
			_w.changepinview.itemData = null;
			_w.changepinview.limited = ('limiteduserview' == template)
				? true
				: false;

			App.DataStore.loadSelectListData('permissions', true, 'User', 'Permissions.SelectList');
			App.DataStore.loadSelectListData('managers', true, 'User', 'Profile.ManagerList');



			_w.changepinview.setChangePinViewFormMeta();
			_w.changepinview.ti.hydrate(_w.changepinview.formMeta);

			// Retrieve initial view data.
			_w.changepinview.itemId = App.Util.getUrlParam('id');
			if (0 == _w.userview.itemId || null == _w.userview.itemId)
			{
				_w.userview.newItem = true;
				_w.userview.ownAccount = false;
				_w.userview.itemData = {};
				App.API.getTask(
					'createUser', 'User', 'Profile.Create',
					null, {}, function(){}, _w.taskContractError
				);

			}
			else
			{
				_w.userview.ownAccount = (App.userData.id == _w.userview.itemId)
					? true
					: false;
				_w.userview.newItem = false;
				App.API.getTask(
					'updateUser:' + _w.userview.itemId, 'User', 'Profile.Update', _w.userview.itemId,
					{'id':_w.userview.itemId}, _w.userview._onUserViewDataReceived, _w.taskContractError
				);
			}

		},

		onViewPublished : function( template, event, eventData )
		{
			$('#btnBack').click(function() {
				window.location.hash = '/userview?id='+_w.changepinview.itemId;
			});


			$('#btnChangePin').click(function() {

				$("#error").html();

				if('' == $("#currentPin").val())
				{
					$("#currentPin").addClass("error");
					$("#error").html("<font color='red'>Current PIN field is required</font>");
					return;
				}
				else
				{
					if(!$.isNumeric($('#currentPin').val()))
					{
						$("#currentPin").addClass("error");
						$("#error").html("<font color='red'>Current PIN field must be numeric</font>");
						return;
					}

					$("#currentPin").removeClass("error");
					$("#currentPin").addClass("valid");
				}

				if('' == $("#newPin").val())
				{
					$("#newPin").addClass("error");
					$("#error").html("<font color='red'>New PIN field is required</font>");
					return;
				}
				else
				{
					if(!$.isNumeric($('#newPin').val()))
					{
						$("#newPin").addClass("error");
						$("#error").html("<font color='red'>New PIN field must be numeric</font>");
						return;
					}

					//console.log($('#newPin').val().replace(/ /g,'').length);

					if($('#newPin').val().replace(/ /g,'').length != 4)
					{
						$("#newPin").addClass("error");
						$("#error").html("<font color='red'>New PIN must be a 4-digit pin</font>");
						return;
					}

					$("#newPin").removeClass("error");
					$("#newPin").addClass("valid");
				}

				if('' == $("#pinVerify").val())
				{
					$("#pinVerify").addClass("error");
					$("#error").html("<font color='red'>PIN confirmation field is required</font>");
					return;
				}

				if($("#newPin").val() != $("#pinVerify").val())
				{
					$("#pinVerify").addClass("error");
					$("#error").html("<font color='red'>PIN and confirmation pin do not match</font>");
					return;
				}

			    App.API.getTask(
			      'PinCange:' + App.userData.id, 'User', 'Profile.ChangePassword', App.userData.id,
			      {}, function () {
			    	  App.API.execTask(
			    			  'PinCange:' + App.userData.id, {
			    				  Profile : {
			    					  oldPassword : $("#currentPin").val(),
			    					  newPassword : $("#newPin").val(),
			    				  }
			    			  },
			    			  {},
			    			  function() {
			    				  alert('Pin changed successfully.');
			    				  if (App.isNewAuctionUser)
			    				  {
			    					  App.isNewAuctionUser = false;
			    					  window.location.hash = '/auction';
			    				  }
			    				  else
			    				  {
			    					  window.location.hash = '/userview?id='+_w.changepinview.itemId;
			    				  }
			    			  },function( response ) {

			    				  if('Current password does not match.'==response.StatusReason)
			    				  {
			    					  	$("#currentPin").removeClass("valid");
			    						$("#currentPin").addClass("error");
			    						$("#error").html("<font color='red'>"+response.StatusReason+"</font>");
			    						return;
			    				  }

			        		 }
			    	  );
			      	}, _w.taskContractError
			    );
			  });
		},


		setChangePinViewFormMeta : function( data )
		{
			if (!data)
			{
				data = {};
			}
			_w.changepinview.formMeta = {
				'currentPin' : {
					type  : 'input',
					id    : 'currentPin',
					title : 'Current PIN',
					value : '',
					maxlength : 6
				},
				'newPin' : {
					type  : 'input',
					id    : 'newPin',
					title : 'New PIN',
					value : '',
					maxlength : 6
				},
				'pinVerify' : {
					type  : 'input',
					id    : 'pinVerify',
					title : 'Confirm new PIN',
					value : ''
				}
			};
		},



		_onDataAndTemplate : function() {

		},

		_onChangePinDataReceived : function( response )
		{
			_w.changepinview.itemId = response.Data.id;
			_w.changepinview.itemData = response.Data;
			_w.changepinview.setUserViewFormMeta(response.Data);
			_w.changepinview.ti.hydrate(_w.userview.formMeta);
			if (_w.changepinview.ti.published)
			{
				_w.changepinview._onDataAndTemplate();
			}
		},

		_prepUserUpdateData : function()
		{
			var data = {Profile:_w.userview.ti.harvest()};
			if ('' == data.Profile.manager)
			{
				data.Profile.manager = null;
			}
			return data;
		},

		_onUserUpdated : function( response )
		{
			if (_w.userview.ownAccount)
			{
				App.API.getTask(
						'updateOffer:' + _w.offerview.offerId, 'User', 'Profile.ActiveAccount', null,
						{}, function (response) {
							App.permissions = response.Data.permissions;
							delete response.Data.permissions;
							App.companyData = response.Data.company;
							delete response.Data.company;
							App.userData = response.Data;
							window.location.hash = '/settings';
						}, _w.onActiveAccountFailure
					);
			}
			else
			{
				window.location.hash = '/settings';
			}
		}
	};

})();