;(function(){

	window._w.clubview = {

		itemId : null,
		itemData : null,
		formMeta : null,
		ti : null,
		newItem : false,

		onViewTemplateReady : function( template, event, eventData )
		{
			_w.clubview.ti = _t[template];
			_w.clubview.initGrid();

			_w.clubview.setClubViewFormMeta();
			_w.clubview.ti.hydratePartial(_w.clubview.formMeta);

			// Retrieve initial view data.
			_w.clubview.itemId = App.Util.getUrlParam('id');
			if (0 == _w.clubview.itemId || null == _w.clubview.itemId)
			{
				_w.clubview.newItem = true;
				_w.clubview.itemData = {};
				App.API.getTask(
					'createClub', 'PriceGuide', 'Club.Create',
					null, {}, function(){}, _w.taskContractError
				);

			}
			else
			{
				_w.clubview.newItem = false;
				App.DataStore.loadSelectListData('allowedInvites', false, 'Company', 'Company.InviteSelectList', null, {Filter:{club:_w.clubview.itemId}});
				App.API.getTask(
						'inviteMember', 'PriceGuide', 'Member.Invite',
						null, {}, function(){}, _w.taskContractError
					);
				App.API.getTask(
					'updateClub:' + _w.clubview.itemId, 'PriceGuide', 'Club.Update', null,
					{'id':_w.clubview.itemId}, $.proxy( _w.clubview._onClubViewDataReceived, this ), _w.taskContractError
				);
				// Member Grid
				if (null == App.API.taskContract('gridMember'))
				{
					App.API.getTask(
							'gridMember', 'PriceGuide', 'Member.Grid', null,
							{}, _w.clubview.loadMemberGrid, _w.taskContractError
					);
				}
				else
				{
					_w.clubview.loadMemberGrid( null, {}, {} );
				}
			}

		},

		onViewPublished : function( template, event, eventData )
		{
			$(".gridMemberFilter").keyup(function (evt) {
				var charCode = evt.charCode || evt.keyCode;
				if (charCode  == 13) { //Enter key's keycode
					$('#btnMemberSearch').click();
				}
			});

			if (_w.clubview.newItem)
			{
				_w.clubview._setupValidation();
				$('#invitesection').hide();
				_w.clubview.setClubViewFormMeta();
				_w.clubview.ti.hydratePartial(_w.clubview.formMeta);
			}
			else
			{
				$('#btnInvite').click(function()
				{
					var members = $('#company').val();
					if (null == members)
					{
						alert('Please select at least 1 new member to invite.');
						return;
					}
					var data = [];
					for (var i = 0; i < members.length; i++)
					{
						data.push({
							Member :
							{
								club    : _w.clubview.itemId,
								company : members[i]
							}
						});
					}
					App.API.execTaskMulti(
							'inviteMember', data, {},
							_w.clubview._onMembersInvited, _w.taskExecError
						);
				});

				// Member Grid
	            $('#btnMemberClearSearch').click(_w.clubview.clearMemberGridContext);
	            $('#btnMemberSearch').click(_w.clubview.searchMemberGrid);
			}
			if (!_w.clubview.newItem && null != _w.clubview.itemData)
			{
				_w.clubview._setupValidation();
			}
		},

		setClubViewFormMeta : function( data )
		{
			if (!data)
			{
				data = {};
			}
			_w.clubview.formMeta = {
				'name' : {
					type  : 'input',
					id    : 'name',
					title : 'Name',
					value : data.name ? data.name : ''
				},
				'useAsDefault' : {
					type  : 'checkbox',
					id    : 'useAsDefault',
					title : 'Use as Send to Price Guide from app',
					value : data.useAsDefault ? data.useAsDefault : false
				},
				'company' : {
					type  : 'select',
					id    : 'company',
					title : 'Members',
					dataStoreId : 'allowedInvites',
					multiple    : true,
					value : data.useAsDefault ? data.useAsDefault : false
				}
			};
		},

		_onClubViewDataReceived : function( response )
		{
			_w.clubview.itemId = response.Data.id;
			_w.clubview.itemData = response.Data;
			_w.clubview.setClubViewFormMeta(response.Data);
			_w.clubview.ti.hydratePartial(_w.clubview.formMeta);
			if (_w.clubview.ti.published)
			{
				_w.clubview._setupValidation();
			}
		},

		_setupValidation : function ()
		{
			$('#frmClubView').validate({
				"rules": {
					name: {required: true}
				},
				messages: {
					name: {
						minlength: "This field is required."
					}
				},
				submitHandler: function( form ) {
					$('#btnUpdate').prop('disabled', true);
					var data = _w.clubview._prepClubUpdateData();
					if (_w.clubview.newItem)
					{
						App.API.execTask(
								'createClub', data, {},
								_w.clubview._onClubUpdated, _w.taskExecError
							);
					}
					else
					{
						App.API.execTask(
								'updateClub:' + _w.clubview.itemId, data, {},
								_w.clubview._onClubUpdated, _w.taskExecError
							);
					}
				}
			});
			$('#btnUpdate').prop('disabled', false);
		},

		_prepClubUpdateData : function()
		{
			return {Club:_w.clubview.ti.harvest()};
		},

		_onMembersInvited : function ( responses )
		{
			_w.clubview.loadMemberGrid();
		},

		_onClubUpdated : function( response )
		{
			window.location.hash = '/settings';
		},

		initGrid : function()
		{
			_w.clubview.ti.hydrate({
				// Club membership grid
				'gridMemberTitle': 'My club members',
				'gridMemberColumnHeaders': {
					constructor: 'GridColumnHeader',
					items: {
						Dealer: {
							id: 'gridMemberColumn_Dealer',
							title: 'DEALERSHIP',
							orderAsc: {
								id: 'gridMemberOrder_DealerAsc',
								bind: $.proxy(_w.clubview.orderMemberGrid, this, 'company.name', 'ASC')
							},
							orderDesc: {
								id: 'gridMemberOrder_DealerDesc',
								bind: $.proxy(_w.clubview.orderMemberGrid, this, 'company.name', 'DESC')
							}
						},
						FirstName: {
							id: 'gridMemberColumn_FirstName',
							title: 'NAME',
							orderAsc: {
								id: 'gridMemberOrder_FirstNameAsc',
								bind: $.proxy(_w.clubview.orderMemberGrid, this, 'contact.firstName', 'ASC')
							},
							orderDesc: {
								id: 'gridMemberOrder_FirstNameDesc',
								bind: $.proxy(_w.clubview.orderMemberGrid, this, 'contact.firstName', 'DESC')
							}
						},
						FamilyName: {
							id: 'gridMemberColumn_FamilyName',
							title: 'SURNAME',
							orderAsc: {
								id: 'gridMemberOrder_FamilyNameAsc',
								bind: $.proxy(_w.clubview.orderMemberGrid, this, 'contact.familyName', 'ASC')
							},
							orderDesc: {
								id: 'gridMemberOrder_FamilyNameDesc',
								bind: $.proxy(_w.clubview.orderMemberGrid, this, 'contact.familyName', 'DESC')
							}
						},
						Email: {
							id: 'gridMemberColumn_Email',
							title: 'EMAIL',
							orderAsc: {
								id: 'gridMemberOrder_EmailAsc',
								bind: $.proxy(_w.clubview.orderMemberGrid, this, 'contact.email', 'ASC')
							},
							orderDesc: {
								id: 'gridMemberOrder_EmailDesc',
								bind: $.proxy(_w.clubview.orderMemberGrid, this, 'contact.email', 'DESC')
							}
						},
						Status: {
							id: 'gridMemberColumn_Status',
							title: 'STATUS',
							orderAsc: {
								id: 'gridMemberOrder_StatusAsc',
								bind: $.proxy(_w.clubview.orderMemberGrid, this, 'mmbr.status', 'ASC')
							},
							orderDesc: {
								id: 'gridMemberOrder_StatusDesc',
								bind: $.proxy(_w.clubview.orderMemberGrid, this, 'mmbr.status', 'DESC')
							}
						}
					}
				},
				'gridMemberColumnFilters': {
					constructor: 'GridColumnFilter',
					items: {
						Dealer: {
							id: 'gridMemberFilter_Dealer',
							context: 'gridMemberFilter'
						},
						FirstName: {
							id: 'gridMemberFilter_FirstName',
							context: 'gridMemberFilter'
						},
						FamilyName: {
							id: 'gridMemberFilter_FamilyName',
							context: 'gridMemberFilter'
						},
						Email: {
							id: 'gridMemberFilter_Email',
							context: 'gridMemberFilter'
						},
						Status: {
							id: 'gridMemberFilter_Status',
							context: 'gridMemberFilter'
						}
					}
				},
				'gridMemberRowRepeater': {},
				'gridMemberPager': {}
			});

		},

		loadMemberGrid : function( contract, data, options )
		{
			data = !data
				? {Grid:{}}
				: data;
			if (!data.Grid)
			{
				data.Grid = {Filter:{}};
			}
			if (!data.Grid.Filter)
			{
				data.Grid.Filter = {};
			}
			data.Grid.Filter['club.id'] = _w.clubview.itemId;

			App.API.execTask(
					'gridMember', data, options,
					_w.clubview._onMemberGridDataReceived, _w.taskExecError
					);
		},

		pageMemberGrid : function( page )
		{
			_w.clubview.loadMemberGrid( {}, {"Grid":{"Page":page}} );
		},

		clearMemberGridContext : function()
		{
			$('.gridMemberContext').val('');
			$('.gridMemberFilter').val('');
			_w.clubview.searchMemberGrid();
		},

		searchMemberGrid : function()
		{
			var filter = {
					count: 0,
					filters: {}
			};
			filter = _w.filterIfnotEmpty(filter, 'gridMemberFilter_Dealer', 'allowedCompany.name');
			filter = _w.filterIfnotEmpty(filter, 'gridMemberFilter_FirstName', 'contact.firstName');
			filter = _w.filterIfnotEmpty(filter, 'gridMemberFilter_FamilyName', 'contact.familyName');
			filter = _w.filterIfnotEmpty(filter, 'gridMemberFilter_Email', 'contact.email');
			filter = _w.filterIfnotEmpty(filter, 'gridMemberFilter_Status', 'mmbr.status');

			var request = {"Grid":{
			    "Page": 1,
			    "Filter": filter.filters
			  }};
			_w.clubview.loadMemberGrid( null, request, {} );
		},

		_onMemberGridDataReceived : function( response )
		{
			_w.clubview.ti.hydrateParam('gridMemberRowRepeater', {});

			var gridData = [];
			for (var i = 0; i < response.Data.DataSet.length; i++)
			{
				var row = response.Data.DataSet[i];

				gridData.push({
					url: 'memberview',
					prepend: {},
					style: {},
					items: {
						'id'         : {'id':row.id,'clubId':row.club.id},
						'Dealer'	 : row.company.name,
						'FirstName'  : row.company.contact.firstName,
						'FamilyName' : row.company.contact.familyName,
						'Email'      : row.company.contact.email,
						'Status'     : row.status
				}
				});
			}
			_w.clubview.ti.hydrateParam('gridMemberRowRepeater', {
				constructor : 'GridDataRow',
				items       : gridData
			});
			response.Data.Meta.itemName = 'memberPager';
			response.Data.Meta.bind = _w.clubview.pageMemberGrid;
			_w.clubview.ti.hydrateParam('gridMemberPager', {
				constructor : 'GridPager',
				items       : [response.Data.Meta]
			});
		},

		orderMemberGrid : function(field, direction)
		{
			var order = {};
			order[field] = direction;
			_w.clubview.loadMemberGrid( {}, {"Grid":{"Page": 1, "OrderBy": order}} );
		}

	};

})();