;(function(){

	window._w.dealerview = {

		itemId : null,
		itemData : null,
		formMeta : null,
		ti : null,
		limited : false,
		newItem : false,
		ownAccount : true,

		onViewTemplateReady : function( template, event, eventData )
		{
			_w.dealerview.ti = _t[template];
			_w.dealerview.limited = ('limiteddealerview' == template)
				? true
				: false;

			App.DataStore.setData('companytypes', [
		           {"value":"Limited", "label":"Limited"},
		           {"value":"PTY Limited", "label":"PTY Limited"},
		           {"value":"Closed Corporation", "label":"Closed Corporation"},
		           {"value":"Sole Proprietor", "label":"Sole Proprietor"}
		           ]);
			App.DataStore.loadSelectListData('countries', true, 'Location', 'Country.SelectList');



			_w.dealerview.setCompanyViewFormMeta();
			_w.dealerview.ti.hydrate(_w.dealerview.formMeta);

			// Retrieve initial view data.
			_w.dealerview.itemId = App.companyData.id;
			_w.dealerview.newItem = false;
			App.API.getTask(
				'updateCompany:' + _w.dealerview.itemId, 'Company', 'Company.Update', _w.dealerview.itemId,
				{'id':_w.dealerview.itemId}, $.proxy( _w.dealerview._onCompanyViewDataReceived, this ), _w.taskContractError
			);

		},

		onViewPublished : function( template, event, eventData )
		{
			if (null != _w.dealerview.itemData)
			{
				_w.dealerview._setupValidation();
			}
		},

		setCompanyViewFormMeta : function( data )
		{
			if (!data)
			{
				data = {};
			}
			_w.dealerview.formMeta = {
				'firstName' : {
					type  : 'input',
					id    : 'firstName',
					title : 'Name',
					value : data.contact ? data.contact.firstName : ''
				},
				'familyName' : {
					type  : 'input',
					id    : 'familyName',
					title : 'Surname',
					value : data.contact ? data.contact.familyName : ''
				},
				'office' : {
					type  : 'input',
					id    : 'office',
					title : 'Landline',
					value : data.contact ? data.contact.office : ''
				},
				'mobile' : {
					type  : 'mobile',
					id    : 'mobile',
					title : 'Mobile',
					value : data.contact ? data.contact.mobile : ''
				},
				'email' : {
					type  : 'input',
					id    : 'email',
					title : 'Email',
					value : data.contact ? data.contact.email : ''
				},

				'name' : {
					type  : 'input',
					id    : 'name',
					title : 'Name',
					value : data.name ? data.name : ''
				},
				'businessName' : {
					type  : 'input',
					id    : 'businessName',
					title : 'Business name',
					value : data.businessName ? data.businessName : ''
				},
				'companyRegistrationNumber' : {
					type  : 'input',
					id    : 'companyRegistrationNumber',
					title : 'Company Reg no',
					value : data.companyRegistrationNumber ? data.companyRegistrationNumber : ''
				},
				'vatNumber' : {
					type  : 'input',
					id    : 'vatNumber',
					title : 'Vat no',
					value : data.vatNumber ? data.vatNumber : ''
				},
				'dealerStockNumber' : {
					type  : 'input',
					id    : 'dealerStockNumber',
					title : 'Dealer stock no',
					value : data.dealerStockNumber ? data.dealerStockNumber : ''
				},
				'companyType' : {
					type        : 'select',
					id          : 'companyType',
					title       : 'Company type',
					dataStoreId : 'companytypes',
					value       : data.companyType ? data.companyType : ''
				},

				'country' : {
					type        : 'select',
					id          : 'country',
					title       : 'Country',
					dataStoreId : 'countries',
					value       : data.city ? data.city.region.country.id : '',
					onChange    : function () {
						if (!App.DataStore.getItem('BuildSelect:country', false))
						{
							_w.dealerview.itemData.city.region.country.id = $('#country').val();
							_w.dealerview._listRegionTown();
						}
					}
				},
				'region' : {
					type        : 'select',
					id          : 'region',
					title       : 'Region',
					dataStoreId : 'regions',
					value       : data.city ? data.city.region.id : '',
					onChange    : function () {
						if (!App.DataStore.getItem('BuildSelect:region', false))
						{
							_w.dealerview.itemData.city.region.id = $('#region').val();
							_w.dealerview._listRegionTown();

						}
					}
				},
				'city' : {
					type        : 'select',
					id          : 'city',
					title       : 'Town',
					dataStoreId : 'cities',
					value       : data.city ? data.city.id : ''
				},
				'street' : {
					type  : 'input',
					id    : 'street',
					title : 'Street',
					value : data.street ? data.street : ''
				},
				'postalCode' : {
					type  : 'input',
					id    : 'postalCode',
					title : 'Code',
					value : data.postalCode ? data.postalCode : ''
				}
			};
		},

		_listRegionTown : function()
		{
			App.DataStore.loadSelectListData(
					'regions', false, 'Location', 'Region.SelectList', null,
					{"Filter": {
						"country" : _w.dealerview.itemData.city.region.country.id
						}}
					);
			App.DataStore.loadSelectListData(
					'cities', false, 'Location', 'Town.SelectList', null,
					{"Filter": {
						"region" : _w.dealerview.itemData.city.region.id
						}}
					);
		},

		_onCompanyViewDataReceived : function( response )
		{
			_w.dealerview.itemId = response.Data.id;
			_w.dealerview.itemData = response.Data;
			_w.dealerview._listRegionTown();
			_w.dealerview.setCompanyViewFormMeta(response.Data);
			_w.dealerview.ti.hydrate(_w.dealerview.formMeta);
			if (_w.dealerview.ti.published)
			{
				_w.dealerview._setupValidation();
			}
		},

		_setupValidation : function ()
		{
			$('#frmDealerView').validate({
				rules: {
					name: {required: true},
					street: {required: true},
					postalCode: {required: true, digits: true},
					firstName: {required: true},
					familyName: {required: true},
					mobile: {required: true, mobile: true},
					office: {required: true},
					email: {required: true, email: true},
					country: "required",
					region: "required",
					city: "required"
				},
				messages: {
					email: {
						email: "Must be a valid email address."
					},
					country : "This field is required.",
					region : "This field is required.",
					city : "This field is required."
				},
				submitHandler: function( form ) {
					$('#btnUpdate').prop('disabled', true);
					var data = _w.dealerview._prepCompanyUpdateData();
					App.API.execTask(
							'updateCompany:' + _w.dealerview.itemId, data, {},
							_w.dealerview._onCompanyUpdated, _w.taskExecError
						);
				}
			});
			$('#btnUpdate').prop('disabled', false);
		},

		_prepCompanyUpdateData : function()
		{
			var data = _w.dealerview.ti.harvest();
			var postData = {Company:{}, Contact:{}};
			var contactFields = ["firstName","familyName","office","mobile","email"];
			for (var field in data)
			{
				if (-1 == contactFields.indexOf(field))
				{
					postData.Company[field] = data[field];
				}
				else
				{
					postData.Contact[field] = data[field];
				}
			}
			return postData;
		},

		_onCompanyUpdated : function( response )
		{
			if (_w.dealerview.ownAccount)
			{
				App.API.getTask(
						'updateOffer:' + _w.offerview.offerId, 'User', 'Profile.ActiveAccount', null,
						{}, function (response) {
					App.permissions = response.Data.permissions;
							delete response.Data.permissions;
							App.companyData = response.Data.company;
							delete response.Data.company;
							App.userData = response.Data;
							window.location.hash = '/settings';
						}, _w.onActiveAccountFailure
					);
			}
			else
			{
				window.location.hash = '/settings';
			}
		}

	};

})();