;
(function () {

    window._w.historicaldata = {

        ti: null,
        rawData: {},
        gridData: {},
        dfrom: '',
        dto: '',
        basketOnly: false,
        gridStatus: null,

        onPageDestruct: function ()
        {
            App.Event.removeListener('historicaldataGridSuFilter', 'SuChange');

        },

        onHistoricaldataPageTemplateReady: function (template, event, eventData)
        {
            _w.historicaldata.ti = _t[template];

            App.DataStore.setData('filterhistoricmakes', []);
            App.DataStore.setData('filterhistoricmodels', []);
            App.DataStore.setData('filterhistorictypes', []);
            App.DataStore.setData('filterhistoricyears', []);

            App.DataStore.loadSelectListData('filterhistoricmakes', false, 'Auction', 'Auction.HistoricMakeSelectList');
            App.DataStore.loadSelectListData('filterhistoricmodels', false, 'Auction', 'Auction.HistoricModelSelectList');
            App.DataStore.loadSelectListData('filterhistorictypes', false, 'Auction', 'Auction.HistoricTypeSelectList');
            App.DataStore.loadSelectListData('filterhistoricyears', false, 'Auction', 'Auction.HistoricYearSelectList');
            _w.historicaldata.ti.hydrate({
                'gridTitle': 'Historical Data',
                'gridTitleSubtext': 'Please use the filters below to narrow down the view',
                'gridTitleButtons': {
                    constructor: 'Button',
                    items: {
                        Export: {
                            preset: 'GridExport',
                            id: 'exportHistoricGrid',
                            handler: _w.historicaldata.exportHistoricGrid,
                            permission: App.permissions.historicalPage
                        }
                    }

                },
                'gridContextFilter': {
                    constructor: 'GridContextFilter',
                    items: {
                        Buttons: {
                            actions: true,
                            searchId: 'btnSearch',
                            bindSearch: _w.historicaldata.searchHistoricGrid,
                            clearId: 'btnClearSearch',
                            bindClear: _w.historicaldata.clearHistoricGridContext

                        }
                    }
                },
                'gridColumnHeaders': {
                    constructor: 'GridColumnHeader',
                    items: {
                        Make: {
                            id: 'gridHistoricalColumn_Make',
                            title: 'MAKE',
                            orderAsc: {
                                id: 'gridHistoricalOrder_MakeAsc',
                                bind: $.proxy(_w.historicaldata.orderHistoricGrid, this, 'make.name', 'ASC')
                            },
                            orderDesc: {
                                id: 'gridHistoricalOrder_MakeDesc',
                                bind: $.proxy(_w.historicaldata.orderHistoricGrid, this, 'make.name', 'DESC')
                            },
                            style: 'hidden-phone'
                        },
                        Model: {
                            id: 'gridHistoricalColumn_Model',
                            title: 'MODEL',
                            orderAsc: {
                                id: 'gridHistoricalOrder_ModelAsc',
                                bind: $.proxy(_w.historicaldata.orderHistoricGrid, this, 'model.name', 'ASC')
                            },
                            orderDesc: {
                                id: 'gridHistoricalOrder_ModelDesc',
                                bind: $.proxy(_w.historicaldata.orderHistoricGrid, this, 'model.name', 'DESC')
                            },
                            style: 'hidden-phone'
                        },
                        Type: {
                            id: 'gridHistoricalColumn_Type',
                            title: 'TYPE',
                            orderAsc: {
                                id: 'gridHistoricalOrder_TypeAsc',
                                bind: $.proxy(_w.historicaldata.orderHistoricGrid, this, 'type.name', 'ASC')
                            },
                            orderDesc: {
                                id: 'gridHistoricalOrder_TypeDesc',
                                bind: $.proxy(_w.historicaldata.orderHistoricGrid, this, 'type.name', 'DESC')
                            }

                        },
                        MMCode: {
                            id: 'gridHistoricalColumn_MMCode',
                            title: 'MM CODE',
                            orderAsc: {
                                id: 'gridHistoricalOrder_MMCodeAsc',
                                bind: $.proxy(_w.historicaldata.orderHistoricGrid, this, 'type.mmCode', 'ASC')
                            },
                            orderDesc: {
                                id: 'gridHistoricalOrder_MMCodeDesc',
                                bind: $.proxy(_w.historicaldata.orderHistoricGrid, this, 'type.mmCode', 'DESC')
                            }

                        },
                        Year: {
                            id: 'gridHistoricalColumn_Year',
                            title: 'YEAR',
                            orderAsc: {
                                id: 'gridHistoricalOrder_YearAsc',
                                bind: $.proxy(_w.historicaldata.orderHistoricGrid, this, 'vehicleYear.name', 'ASC')
                            },
                            orderDesc: {
                                id: 'gridHistoricalOrder_YearDesc',
                                bind: $.proxy(_w.historicaldata.orderHistoricGrid, this, 'vehicleYear.name', 'DESC')
                            },
                            style: 'year'
                        },
                        KM: {
                            id: 'gridHistoricalColumn_KM',
                            title: 'KM&#39;S',
                            orderAsc: {
                                id: 'gridHistoricalOrder_KMAsc',
                                bind: $.proxy(_w.historicaldata.orderHistoricGrid, this, 'stock.km', 'ASC')
                            },
                            orderDesc: {
                                id: 'gridHistoricalOrder_KMDesc',
                                bind: $.proxy(_w.historicaldata.orderHistoricGrid, this, 'stock.km', 'DESC')
                            },
                            style: 'kms hidden-phone'
                        },
                        TradePrice: {
                            id: 'gridHistoricalColumn_TradePrice',
                            title: 'TRADE PRICE',
                            orderAsc: {
                                id: 'gridHistoricalOrder_TradePriceAsc',
                                bind: $.proxy(_w.historicaldata.orderHistoricGrid, this, 'stock.tradePrice', 'ASC')
                            },
                            orderDesc: {
                                id: 'gridHistoricalOrder_TradePriceDesc',
                                bind: $.proxy(_w.historicaldata.orderHistoricGrid, this, 'stock.tradePrice', 'DESC')
                            },
                            style: 'amount'
                        },
                        ReconCosts: {
                            id: 'gridHistoricalColumn_ReconCosts',
                            title: 'RECON COSTS',
                            orderAsc: {
                                id: 'gridHistoricalOrder_ReconCostsAsc',
                                bind: $.proxy(_w.historicaldata.orderHistoricGrid, this, 'stock.damageTotal', 'ASC')
                            },
                            orderDesc: {
                                id: 'gridHistoricalOrder_ReconCostsDesc',
                                bind: $.proxy(_w.historicaldata.orderHistoricGrid, this, 'stock.damageTotal', 'DESC')
                            },
                            style: 'amount'
                        },
                        HighestBid: {
                            id: 'gridHistoricalColumn_HighestBid',
                            title: 'HIGHEST BID',
                            orderAsc: {
                                id: 'gridHistoricalOrder_HighestBidAsc',
                                bind: $.proxy(_w.historicaldata.orderHistoricGrid, this, 'currentBid.amount', 'ASC')
                            },
                            orderDesc: {
                                id: 'gridHistoricalOrder_HighestBidDesc',
                                bind: $.proxy(_w.historicaldata.orderHistoricGrid, this, 'currentBid.amount', 'DESC')
                            },
                            style: 'amount'
                        },
                        DateSold: {
                            id: 'gridHistoricalColumn_DateSold',
                            title: 'DATE SOLD',
                            orderAsc: {
                                id: 'gridHistoricalOrder_DateSoldAsc',
                                bind: $.proxy(_w.historicaldata.orderHistoricGrid, this, 'auction.endDate', 'ASC')
                            },
                            orderDesc: {
                                id: 'gridHistoricalOrder_DateSoldDesc',
                                bind: $.proxy(_w.historicaldata.orderHistoricGrid, this, 'auction.endDate', 'DESC')
                            },
                            style: 'date'
                        },
                    }
                },

                'gridColumnFilters': {
                    constructor: 'GridColumnFilter',
                    items: {
                        Make: {
                            id: 'gridHistoricalFilter_Make',
                            context: 'gridHistoricalFilter',
                            dataStoreId: 'filterhistoricmakes',
                            selectEmpty: 'All',
                            bind: function (meta) {
                                _w.historicaldata.changes = 0;
                                $('#' + meta.id).unbind('change');
                                $('#' + meta.id).change(function () {
                                    _w.historicaldata.changes++;
                                    if (1 == _w.historicaldata.changes || 'Active' != _w.historicaldata.gridStatus)
                                    {
                                        return;
                                    }
                                    _w.historicaldata.searchHistoricGrid();
                                });
                            }
                        },
                        Model: {
                            id: 'gridHistoricalFilter_Model',
                            context: 'gridHistoricalFilter',
                            dataStoreId: 'filterhistoricmodels',
                            selectEmpty: 'All',
                        },
                        Type: {
                            id: 'gridHistoricalFilter_Type',
                            context: 'gridHistoricalFilter',
                            dataStoreId: 'filterhistorictypes',
                            selectEmpty: 'All',
                        },
                        MMCode: {
                            id: 'gridHistoricalFilter_MMCode',
                            context: 'gridHistoricalFilter'
                        },
                        Year: {
                            id: 'gridHistoricalFilter_Year',
                            context: 'gridHistoricalFilter',
                            dataStoreId: 'filterhistoricyears',
                            selectEmpty: 'All',
                        },
                        KM: {
                            id: 'gridHistoricalFilter_KM',
                            context: 'gridHistoricalFilter'
                        },
                        TradePrice: {
                            id: 'gridHistoricalFilter_TradePrice',
                            context: 'gridHistoricalFilter'
                        },
                        ReconCosts: {
                            id: 'gridHistoricalFilter_ReconCosts',
                            context: 'gridHistoricalFilter'
                        },
                        HighestBid: {
                            id: 'gridHistoricalFilter_HighestBid',
                            context: 'gridHistoricalFilter'
                        },
                        DateSold: {
                            id: false,
                        },
                    }
                },
                'gridRowRepeater': {},
                'gridPager': {}
            });

            // Retrieve initial grid data.
            if (null == App.API.taskContract('gridHistorical'))
            {
                App.API.getTask(
                    'gridHistorical', 'Auction', 'Auction.HistoricGrid', null,
                    {}, function () {
                        request = {
                            "Grid": {
                                "Page": 1,
                                "Filter": {
                                    'auction.jobState': 'Sold'
                                }
                            }
                        };
                    }, _w.taskContractError
                );
            }
        },

        onHistoricGridPublished: function ()
        {
            $(".gridHistoricalFilter").keyup(function (evt) {
                var charCode = evt.charCode || evt.keyCode;
                if (charCode == 13)
                { //Enter key's keycode
                    $('#btnSearch').click();
                }

            });

            $("body").on('click', 'div.gridHistoricalFilter li', function () {
                $('#btnSearch').click();
            });

            $(".gridHistoricalContext").keyup(function (evt) {
                var charCode = evt.charCode || evt.keyCode;
                if (charCode == 13)
                { //Enter key's keycode
                    $('#btnSearch').click();
                }

            });

            var setTableFormWidth = function ()
            {
                $('.table-form').css({
                    width: $(window).width() * 0.98
                });
            };

            $(window).on('resize', setTableFormWidth);
            setTableFormWidth();
            App.Event.listen('historicaldataGridSuFilter', 'SuChange', $.proxy(_w.historicaldata.loadHistoricGrid, this), 'Recurring');
            setTimeout(_w.historicaldata.refreshGrid, 1200000);
        },

        refreshGrid: function ()
        {
            if ('historicaldata' != App.activePage)
            {
                return;
            }
            _w.historicaldata.loadHistoricGrid(null, {}, {});
            setTimeout(_w.historicaldata.refreshGrid, 1200000);
        },

        pageHistoricGrid: function (page)
        {
            _w.historicaldata.loadHistoricGrid({}, {"Grid": {"Page": page}});
        },

        loadHistoricGrid: function (contract, data, options)
        {
            App.API.execTask(
                'gridHistorical', data, options,
                _w.historicaldata._onHistoricGridDataReceived, _w.taskExecError
            );
        },

        _buildGrid: function ()
        {
            _w.historicaldata.gridData = {};
            for (var i in _w.historicaldata.rawData.DataSet)
            {
                var row = _w.historicaldata.rawData.DataSet[i];

                _w.historicaldata.gridData['i' + row.id] = {
                    bind: function (meta) {
                        $('#row' + meta.rowId).click(function (e) {
                            window.location = '#/' + meta.surl + '?id=' + meta.rowId;
                            console.log('#/' + meta.surl + '?id=' + meta.rowId);
                        });
                    },
                    surl: 'historyview',
                    prepend: {
                        TradePrice: 'R ',
                        ReconCosts: 'R ',
                        HighestBid: 'R '
                    },
                    rowId: row.id,
                    style: {
                        Make: 'make hidden-phone',
                        Model: 'hidden-phone',
                        Type: 'type',
                        MMCode: '',
                        Year: 'year',
                        KM: 'hidden-phone',
                        TradePrice: 'amount',
                        ReconCosts: 'amount',
                        HighestBid: 'amount',
                        DateSold: 'date'
                    },
                    items: {
                        'id': row.id,
                        'Make': row.stock.type.model.make.name,
                        'Model': row.stock.type.model.name,
                        'Type': row.stock.type.name,
                        'MMCode': row.stock.type.mmCode,
                        'Year': row.stock.vehicleYear.name,
                        'KM': row.stock.km,
                        'TradePrice': row.stock.tradePrice,
                        'ReconCosts': row.stock.damageTotal,
                        'HighestBid': row.currentBid.amount,
                        'DateSold': row.endDate
                    }
                };
            }
            _w.historicaldata.ti.hydrateParam('gridRowRepeater', {
                constructor: 'GridDataRow',
                items: _w.historicaldata.gridData
            });
        },

        rebuildGrid: function ()
        {
            if ('historicaldata' != App.activePage)
            {
                return;
            }
            _w.historicaldata._buildGrid();
            setTimeout(_w.historicaldata.rebuildGrid, 5000);
        },

        _onHistoricGridDataReceived: function (response)
        {
            _w.historicaldata.gridStatus = 'Sold';
            if (!_w.timeRebuilder)
            {
                _w.timeRebuilder = true;
                setTimeout(_w.historicaldata.rebuildGrid, 5000);
            }
            _w.historicaldata.ti.hydrateParam('gridRowRepeater', {});
            _w.historicaldata.currentFilters = response.Data.Meta.Filters;
            _w.populateFilters(response.Data.Meta.Filters, {
                'make.id': 'gridHistoricalFilter_Make',
                'model.id': 'gridHistoricalFilter_Model',
                'type.id': 'gridHistoricalFilter_Type',
                'type.mmCode': 'gridHistoricalFilter_MMCode',
                'vehicleYear.id': 'gridHistoricalFilter_Year',
                'stock.km': 'gridHistoricalFilter_KM',
                'stock.tradePrice': 'gridHistoricalFilter_TradePrice',
                'stock.damageTotal': 'gridHistoricalFilter_ReconCosts',
                'currentBid.amount': 'gridHistoricalFilter_HighestBid',
            });
            $('select.gridHistoricalFilter').each(function (i, elem) {
                $(elem).selectpicker('refresh');
            });
            _w.historicaldata.rawData = {
                DataSet: {},
                Meta: response.Data.Meta
            };
            for (var i = 0; i < response.Data.DataSet.length; i++)
            {
                _w.historicaldata.rawData.DataSet['a' + response.Data.DataSet[i]['id']] = response.Data.DataSet[i];
            }


            $('#placeholderLogo').hide();
            _w.historicaldata._buildGrid();
            _w.historicaldata.rawData.Meta.itemName = 'stockPager';
            _w.historicaldata.rawData.Meta.bind = _w.historicaldata.pageHistoricGrid;
            _w.historicaldata.ti.hydrateParam('gridPager', {
                constructor: 'GridPager',
                items: [_w.historicaldata.rawData.Meta]
            });
        },

        exportHistoricGrid: function ()
        {
            App.API.execTask(
                'gridHistorical', {}, {'ExportToExcel': true},
                _w.historicaldata._onExportReceived, _w.taskExecError,
                'EXPORT', true
            );
        },

        _onExportReceived: function (response)
        {
            var win = window.open();
            win.document.write(response);
        },

        clearHistoricGridContext: function ()
        {
            _w.historicaldata.gridStatus = 'Inactive';
            try
            {
                $('select.gridHistoricalFilter').each(function (i, elem) {
                    $(elem).selectpicker('val', '');
                    $(elem).selectpicker('refresh');
                });
            }
            catch (err)
            {
                console.log(err);
            }
            $('.gridHistoricalContext').val('');
            $('.gridHistoricalFilter').val('');
            $('#gridHistoricalFilter_Status').val('Sold');
            _w.historicaldata.searchHistoricGrid(true);
        },

        searchHistoricGrid: function (resetOrder)
        {
            _w.historicaldata.gridStatus = 'Inactive';
            var filter = {
                count: 0,
                filters: {}
            };

            filter = _w.filterIfnotEmpty(filter, 'gridHistoricalFilter_Make', 'make.id');
            filter = _w.filterIfnotEmpty(filter, 'gridHistoricalFilter_Model', 'model.id');
            filter = _w.filterIfnotEmpty(filter, 'gridHistoricalFilter_Type', 'type.id');
            filter = _w.filterIfnotEmpty(filter, 'gridHistoricalFilter_MMCode', 'type.mmCode');
            filter = _w.filterIfnotEmpty(filter, 'gridHistoricalFilter_Year', 'vehicleYear.id');
            filter = _w.filterIfnotEmpty(filter, 'gridHistoricalFilter_KM', 'stock.km');
            filter = _w.filterIfnotEmpty(filter, 'gridHistoricalFilter_TradePrice', 'stock.tradePrice');
            filter = _w.filterIfnotEmpty(filter, 'gridHistoricalFilter_ReconCosts', 'stock.damageTotal');
            filter = _w.filterIfnotEmpty(filter, 'gridHistoricalFilter_HighestBid', 'currentBid.amount');

            var data = {
                "filter": {
                    "Filters": filter.filters
                }
            };

            App.DataStore.loadSelectListData('filterhistoricmakes', false, 'Auction', 'Auction.HistoricMakeSelectList', null, data, undefined, function()
            {
                if (undefined != _w.historicaldata.currentFilters['make.id'])
                {
                    $('#gridHistoricalFilter_Make').val(_w.historicaldata.currentFilters['make.id']);
                    $('#gridHistoricalFilter_Make').selectpicker('refresh');
                }
            });
            App.DataStore.loadSelectListData('filterhistoricmodels', false, 'Auction', 'Auction.HistoricModelSelectList', null, data, undefined, function()
            {
                if (undefined != _w.historicaldata.currentFilters['model.id'])
                {
                    $('#gridHistoricalFilter_Model').val(_w.historicaldata.currentFilters['model.id']);
                    $('#gridHistoricalFilter_Model').selectpicker('refresh');
                }
            });
            App.DataStore.loadSelectListData('filterhistorictypes', false, 'Auction', 'Auction.HistoricTypeSelectList', null, data, undefined, function()
            {
                if (undefined != _w.historicaldata.currentFilters['type.id'])
                {
                    $('#gridHistoricalFilter_Type').val(_w.historicaldata.currentFilters['type.id']);
                    $('#gridHistoricalFilter_Type').selectpicker('refresh');
                }
            });
            App.DataStore.loadSelectListData('filterhistoricyears', false, 'Auction', 'Auction.HistoricYearSelectList', null, data, undefined, function()
            {
                if (undefined != _w.historicaldata.currentFilters['vehicleYear.id'])
                {
                    $('#gridHistoricalFilter_Year').val(_w.historicaldata.currentFilters['vehicleYear.id']);
                    $('#gridHistoricalFilter_Year').selectpicker('refresh');
                }
            });


            var request = {
                "Grid": {
                    "Page": 1,
                    "Filter": filter.filters
                }
            };
            if (resetOrder)
            {
                request.Grid.OrderBy = {
                    'make.name': 'ASC',
                    'model.name': 'ASC',
                    'auction.endDate': 'DESC'
                };
            }
            _w.historicaldata.loadHistoricGrid(null, request, {});
        },

        orderHistoricGrid: function (field, direction)
        {
            var order = {};
            order[field] = direction;
            _w.historicaldata.loadHistoricGrid({}, {"Grid": {"Page": 1, "OrderBy": order}});
        }

    };

})();