;(function(){

	window._w.offerview = {

		itemId        : null,
		itemData      : null,
		formMeta      : null,
		offerId       : null,
		offerData     : null,
		formOfferMeta : null,
		ti            : null,
		limited       : false,
		newItem       : false,

		onOfferViewTemplateReady : function( template, event, eventData )
		{
			_w.offerview.ti = _t[template];
			_w.offerview.limited = ('limitedvaluationview' == template)
				? true
				: false;

			_w.offerview.setStockViewFormMeta();
			_w.offerview.setOfferViewFormMeta();
			_w.offerview.ti.hydrate(_w.offerview.formMeta);

			_w.offerview.formOfferMeta = {
					type  : 'input',
					id    : 'amountOffered',
					title : 'Amount offered',
					value : '0.00'
			};

			// Retrieve initial view data.
			_w.offerview.itemId = App.Util.getUrlParam('pgId');
			_w.offerview.offerId   = App.Util.getUrlParam('id');

			// Offer data
			if (0 == _w.offerview.offerId || null == _w.offerview.offerId)
			{
				$('#btnUnarchive').hide();
				$('#btnArchive').hide();
				_w.offerview.newItem = true;
				_w.offerview.offerData = {};
			}
			else
			{
				_w.offerview.newItem = false;
			}

			// Stock data
			var task = 'PriceGuide.View';
			App.API.getTask(
				'viewPg:' + _w.offerview.itemId, 'PriceGuide', task, _w.offerview.itemId,
				{}, $.proxy( _w.offerview._onStockViewDataReceived, this ), _w.taskContractError
			);
		},

		loadHistoricalGrid : function( contract, data, options )
		{
			App.API.execTask(
					'gridStockHistory', {Grid:{Filter:{"PricingHistory.stockId":_w.offerview.itemData.stock.id}}}, options,
					_w.offerview._onHistoryGridDataReceived, _w.taskExecError
					);

		},
		_onHistoryGridDataReceived : function( response )
		{
			_w.offerview.gridStatus = 'Active';
			_w.offerview.ti.hydrateParam('gridPricingHistoryRowRepeater', {});
			var gridData = [];

			console.log(response.Data.DataSet.length);

			if (response.Data.DataSet.length == 0 || response.Data.DataSet.length == null) {
				$('#pricing_history_none_found').show();
				$('#PHColumnHeaders').hide();
			}

			for (var i = 0; i < response.Data.DataSet.length; i++)
			{
				var row = response.Data.DataSet[i];
				gridData.push({
					prepend: {
						Trade  					: 'R ',
						TotalRecon	 			: 'R ',
						PriceguideOffer 		: 'R ',
						AuctionWinningBid 		: 'R '
					},
					style: {
						Date					: '',
						Trade					: '',
						TotalRecon				: '',
						km						: '',
						PriceguideOffer			: '',
						AuctionWinningBid		: '',

					},
					items: {
						'Date'    			: row.date,
						'Trade'   			: row.trade,
						'TotalRecon'  		: row.totalRecon,
						'KM'    			: row.km,
						'PriceguideOffer'  	: row.pricegOffer,
						'AuctionWinningBid' : row.auctionWinningBid
				}
				});
			}
			_w.offerview.ti.hydrateParam('gridPricingHistoryRowRepeater', {
				constructor : 'GridDataRow',
				items       : gridData
			});
			response.Data.Meta.bind = _w.offerview.pageStockGrid;
		},

		onOfferViewPublished : function( template, event, eventData )
		{

			$('#btnRequestHPI').click(function () {

				if ('' == $('#HPIusername').val() || '' ==  $('#HPIpin').val())
				{
					alert('Please enter a valid username and password.');
					return;
				}

				$('#HPIdropConfirm').slideToggle();
				$('#HPIresponse').html('');
			});



			App.Util.updateCheckboxStyle($('#acceptHPIdisclaimer'));
			$('#HPIbtnConfirm').click(function () {
				if ( $('#engineNumber').html() == '' || $('#vinNumber').html() == '' ) {
					alert('Cannot request report without Vehicle Engine Number and VIN Number.');
					return;
				}
				if (!$('#acceptHPIdisclaimer').is(':checked'))
				{
					alert('Please accept the conditions before sending.');
					return;
				}

				var user = $('#HPIusername').val();
				var pass = $('#HPIpin').val();

				App.API.getTask(
						'TransUnionForHPI', 'Stock', 'Utility.TransUnionForHPI', null,
						{'Filter' : {'username' : user ,'pass' : pass , 'stock' : _w.offerview.itemData.stock.id}},
						function() {
							App.API.execTask(
									'TransUnionForHPI',{}, {},
									function(data)
									{
										$('#HPIdropConfirm').hide();
										if ('Success' == data.Status)
										{
											$('#HPIresponse').html('Success on HPI Report');
											alert('Success on HPI Report');
											App.DataStore.loadSelectListData(
													'tuhpi', false, 'Stock', 'Tuhpi.List', null,{"Filter":
													{
														"stock" 		: _w.offerview.itemData.stock.id,
														"company" 		: App.companyData.id
													}}, {},function() {
													// data is retrieved
													var tuHpiData = App.DataStore.getData('tuhpi');
													for (var i = 0; i < tuHpiData.length; i++)
													{
														var tuHpiId = tuHpiData[i].id
														var tuHpiCreated = tuHpiData[i].created
														if (tuHpiId)
														{
															$('#tuhpiDate').html(tuHpiCreated);
															$('#downloadTuhpi').show();
															$('#HPIbtnConfirm').prop('disabled', true);
															return;
														}
														else
														{
															$('#tuhpiDate').html('Not Requested Yet');
															$('#downloadTuhpi').hide();
															$('#HPIbtnConfirm').prop('disabled', false);
														}
													}
											});
										}
										else
										{
											$('#HPIresponse').html('API call to remote host failed. No data could be retrieved from remote service.');
										}
									}, function(response)
									{
										$('#HPIbtnConfirm').prop('disabled', false);
										alert(
											undefined != response.StatusReason
												? response.StatusReason
												: 'API call to remote host failed. No data could be retrieved from remote service.'
										);
									}
							);
						}


						, _w.taskContractError
				);
			});


			$('#downloadTuhpi').click(function () {
				App.API.getTask(
						'printTuhpi:' + _w.offerview.itemData.stock.id, 'Stock', 'Tuhpi.Print', _w.offerview.itemData.stock.id,
						{}, function() {
							App.API.execTask(
									'printTuhpi:' + _w.offerview.itemData.stock.id, {}, {},
									function () {}, _w.taskExecError,
									'EXPORT', true
							);
						}, _w.taskContractError
				);
			});



			$('#btnMakeOffer').click(function () {
				amount = $('#amountOffered').val();
				if ('' == amount || isNaN(amount)  || parseFloat(amount) <= 0 )
				{
					alert('Please enter a valid amount.');
					return;
				}
				
				if(amount.indexOf(".")==-1)
				{
					amount = amount+'.00'
				}
				
				_w.offerview.ti.hydrateParam('infAmountOffered', amount);
				$('#dropCmp').slideToggle();
				$('#dropConfirm').slideToggle();
			});

			$('#btnConfirm').click(function () {
				var data = {
						"Offer": {
							"amount": $('#amountOffered').val()
						}
				};
				if ('' == data.Offer.amount || isNaN(data.Offer.amount))
				{
					alert('Please enter a valid amount.');
					return;
				}
				var oldOffer = parseFloat( _w.offerview.offerData.amount);
				var newOffer = parseFloat( data.Offer.amount);
console.log('old vs new', '.' + oldOffer + '...' + newOffer + '.');
				if (!_w.offerview.newItem && (newOffer <= oldOffer))
				{
					alert('Your updated offer must be higher than your previous offer.');
					return;
				}
				if (_w.offerview.newItem)
				{
					App.API.execTask(
							'createOffer', data, {},
							_w.offerview._onOfferUpdated, _w.taskExecError
						);
				}
				else
				{
					App.API.execTask(
							'updateOffer:' + _w.offerview.offerId, data, {},
							_w.offerview._onOfferUpdated, _w.taskExecError
						);
				}
			});

			$('.mobile-header-bottom .bottom-heading').text('OFFER DETAILS');

			$('#btnArchive').click(function () {
				App.API.getTask(
						'archivePriceGuide:' + _w.offerview.offerId,
						'PriceGuide', 'Offer.Archive', _w.offerview.itemId,
						{"id":_w.offerview.offerId},
						function () {
							App.API.execTask(
									'archivePriceGuide:' + _w.offerview.offerId, {}, {},
									_w.offerview._onOfferUpdated, _w.taskExecError
								);
						},
						_w.taskContractError
					);
			});
			$('#btnUnarchive').click(function () {
				App.API.getTask(
						'unarchivePriceGuide:' + _w.offerview.offerId,
						'PriceGuide', 'Offer.Unarchive', _w.offerview.itemId,
						{"id":_w.offerview.offerId},
						function () {
							App.API.execTask(
									'unarchivePriceGuide:' + _w.offerview.offerId, {}, {},
									_w.offerview._onOfferUpdated, _w.taskExecError
								);
						},
						_w.taskContractError
					);
			});

			$('.back-btn').on('click', function(){
				window.history.back();
			});

			//console.log(_w.offerview.newItem);


				_w.offerview.ti.hydrate({
					'gridPricingHistoryColumnHeaders': {
						constructor: 'GridColumnHeader',
						items: {
							Date: {
								id: 'gridPricingHistoryColumn_Date',
								title: 'Date',
							},
							Trade: {
								id: 'gridPricingHistoryColumn_Trade',
								title: 'Trade',
							},
							TotalRecon: {
								id: 'gridPricingHistoryColumn_totalRecon',
								title: 'Total Recon',
							},
							km: {
								id: 'gridPricingHistoryColumn_km',
								title: 'km',
							},
							PriceguideOffer: {
								id: 'gridPricingHistoryColumn_pricegOffer',
								title: 'Priceguide Offer',
							},
							AuctionWinningBid: {
								id: 'gridPricingHistoryColumn_auctionWinningBid',
								title: 'Auction Winning Bid',
							},

						}
					},
					'gridPricingHistoryRowRepeater': {}
				});






			/*
			 * Permissions
			 */
			if (0 == _w.offerview.offerId || null == _w.offerview.offerId)
			{
				true == App.permissions.pgMakeOffer ? $('#optMakeOffer').show() : $('#optMakeOffer').hide();
			}
			else
			{
				true == App.permissions.pgUpdateOffer ? $('#optMakeOffer').show() : $('#optMakeOffer').hide();
			}

			true == App.permissions.pgPrint ? $('#printPriceGuidePdf').show() : $('#printPriceGuidePdf').hide();


			if (_w.offerview.newItem)
			{
				_w.offerview.setOfferViewFormMeta();
			}
			if (!_w.offerview.newItem && null != _w.offerview.itemData)
			{
				_w.offerview._onStockDataAndTemplate();
			}
			if (!_w.offerview.newItem && null != _w.offerview.offerData)
			{
				_w.offerview._onOfferDataAndTemplate();
			}
		},

		setStockViewFormMeta : function( data )
		{
			data = (undefined == data)
				? {"stock":{}}
				: data;
			var damagesHtml = '';
			var accessoriesHtml = '';
			if (undefined != data && undefined != data.stock && undefined != data.stock.damages)
			{
				for (var i = 0; i < data.stock.damages.length; i++)
				{
					damagesHtml += '<div class="control-group">';
					damagesHtml += '<label class="control-label valuation-line">' + data.stock.damages[i].damage.name + ':</label>';
					damagesHtml += '<div class="controls">';
					damagesHtml += '<p class="information-lines">R ' + data.stock.damages[i].amount + '</p>';
					damagesHtml += '</div>';
					damagesHtml += '</div>';
				}
			}
			if (undefined != data && undefined != data.stock && undefined != data.stock.accessories)
			{
				for (var i = 0; i < data.stock.accessories.length; i+=2)
				{
					var acc1 = data.stock.accessories[i]
						? data.stock.accessories[i].accessory.name
						: '&nbsp;';
					var acc2 = data.stock.accessories[i+1]
						? data.stock.accessories[i+1].accessory.name
						: '&nbsp;';
					accessoriesHtml += '<div class="row-fluid">';
					accessoriesHtml += '<div class="span6 textshow">' + acc1 + '</div>';
					accessoriesHtml += '<div class="span6 textshow">' + acc2 + '</div>';
					accessoriesHtml += '</div>';
				}
			}


			console.log(data);
			_w.offerview.formMeta = {



				'vehicle' : data.stock.type
					? data.stock.type.model.make.name + ', '
							+ data.stock.type.model.name + ', '
							+ data.stock.type.name
					: '',
				'vehicleRef' : {
					title       : 'Reference Number',
					value       : data.stock.referenceNumber
				},
				'vehicleYear' : {
					title       : 'Year',
					value       : data.stock.vehicleYear ? data.stock.vehicleYear.name : ''
				},
				'category' : {
					title       : 'Category',
					value       : data.stock.type ? data.stock.type.category.name : ''
				},
				'make' : {
					title       : 'Vehicle Make',
					value       : data.stock.type ? data.stock.type.model.make.name : ''
				},
				'model' : {
					id          : 'vehicleModel',
					title       : 'Vehicle Model',
					value       : data.stock.type ? data.stock.type.model.name : ''
				},
				'type' : {
					title       : 'Vehicle Type',
					value       : data.stock.type ? data.stock.type.name : ''
				},
				'mmCode' : {
					title       : 'MM Code',
					value       : data.stock.type ? data.stock.type.mmCode : ''
				},
				'fuelType' : {
					title       : 'Fuel Type',
					value       : data.stock.fuelType ? data.stock.fuelType.name : ''
				},
				'transmissionType' : {
					title       : 'Transmission Type',
					value       : data.stock.transmissionType ? data.stock.transmissionType.name : ''
				},
				'condition' : {
					title       : 'Condition',
					value       : data.stock.condition ? data.stock.condition.name : ''
				},
				'exteriorColour' : {
					title       : 'Main ext. colour',
					value       : data.stock.exteriorColour ? data.stock.exteriorColour.name : ''
				},
				'interiorColour' : {
					title : 'Main int. colour',
					value : data.stock.interiorColour ? data.stock.interiorColour.name : ''
				},
				'upholstery' : {
					title       : 'Upholstery',
					value       : data.stock.upholstery ? data.stock.upholstery.name : ''
				},
				'papers' : {
					title       : 'Papers',
					value       : data.stock.papers ? data.stock.papers.name : ''
				},
				'natis' : {
					title       : 'Natis',
					value       : data.stock.natis ? data.stock.natis.name : ''
				},
				'spareKeys' : {
					title       : 'Spare keys',
					value       : undefined == data.stock.spareKeys
									? ''
									: (data.stock.spareKeys ? 'Yes' : 'No')
				},
				'fullServiceHistory' : {
					title       : 'Full service history',
					value       : undefined == data.stock.fullServiceHistory
									? ''
									: data.stock.fullServiceHistory.name
				},
				'registrationNumber' : {
					title : 'Registration no',
					value : data.stock.registrationNumber ? data.stock.registrationNumber : ''
				},
				'vinNumber' : {
					title : 'Vin no',
					value : data.stock.vinNumber ? data.stock.vinNumber : ''
				},
				'engineNumber' : {
					title : 'Engine no',
					value : data.stock.engineNumber ? data.stock.engineNumber : ''
				},
				'km' : {
					title : 'Kms',
					value : data.stock.km ? data.stock.km : ''
				},
				'fshNotes' : {
					title : 'FSH notes',
					value : data.stock.fshNotes ? data.stock.fshNotes : ''
				},
				'damages' : damagesHtml,
				'damageTotal' : {
					title : 'Total estimated repair price',
					value : 'R ' + (data.stock ? data.stock.damageTotal : '0.00')
				},
				'damageNotes' : {
					title : 'Damages comments',
					value : data.stock.damageNotes ? data.stock.damageNotes : ''
				},
				'previousRepairsNoted' : {
					title : 'Previous repairs noted',
					value : data.stock.previousRepairsNoted ? 'Yes' : 'No'
				},
				'previousRepairsNotes' : {
					title : 'Previous repairs comments',
					value : data.stock.previousRepairsNotes ? data.stock.previousRepairsNotes : ''
				},
				'accessories' : accessoriesHtml,
				'accessoryNotes' : {
					title     : 'Comments',
					value     : data.stock.accessoryNotes ? data.stock.accessoryNotes : ''
				},
				'mainImage' : {
					type  : 'image',
					view  : true,
					id    : 'mainImage',
					baseImage : 'main_img_car.jpg',
					value : data.stock.mainImage ? data.stock.mainImage : ''
				},
				'frontImage' : {
					type  : 'image',
					view  : true,
					id    : 'frontImage',
					baseImage : 'front_car.jpg',
					value : data.stock.frontImage ? data.stock.frontImage : ''
				},
				'leftImage' : {
					type  : 'image',
					view  : true,
					id    : 'leftImage',
					baseImage : 'left_car.jpg',
					value : data.stock.leftImage ? data.stock.leftImage : ''
				},
				'rightImage' : {
					type  : 'image',
					view  : true,
					id    : 'rightImage',
					baseImage : 'right_car.jpg',
					value : data.stock.rightImage ? data.stock.rightImage : ''
				},
				'backImage' : {
					type  : 'image',
					view  : true,
					id    : 'backImage',
					baseImage : 'back_car.jpg',
					value : data.stock.backImage ? data.stock.backImage : ''
				},
				'interiorImage' : {
					type  : 'image',
					view  : true,
					id    : 'interiorImage',
					baseImage : 'interior_car.jpg',
					value : data.stock.interiorImage ? data.stock.interiorImage : ''
				},
				'engineImage' : {
					type  : 'image',
					view  : true,
					id    : 'engineImage',
					baseImage : 'engine_car.jpg',
					value : data.stock.engineImage ? data.stock.engineImage : ''
				},
				'natisImage' : {
					type  : 'image',
					view  : true,
					id    : 'natisImage',
					baseImage : 'copy_of_natis_car.jpg',
					value : data.stock.natisImage ? data.stock.natisImage : ''
				},

				'coverReceived': data.stock.coverReceived ? data.stock.coverReceived : '',

				'infCreated': data.created ? ((data.created).split(' '))[0] : '',
				'infLoadedOnPriceGuide': data.stock.loadedOnPriceGuide
					? ((data.stock.loadedOnPriceGuide).split(' '))[0] : '',
				'infTradePrice': {
					title : 'Trade',
					value : data.stock.tradePrice ? 'R ' + data.stock.tradePrice : '0.00'
				},
				'infRetailPrice': {
					title : 'Retail',
					value : data.stock.retailPrice ? 'R ' + data.stock.retailPrice : '0.00'
				},
                'infListPrice': {
                    title : 'New list price',
                    value : data.stock.listPrice ? 'R ' + data.stock.listPrice : '0.00'
                },
				'infCustomerPrice': {
					title : 'Customer Request',
					value : data.stock.valuation && data.stock.valuation.requiredPrice
							? 'R ' + data.stock.valuation.requiredPrice
							: 'R 0.00'
				},

                'infSighted': {
                    title : 'Sighted',
                    value : data.stock.valuation && data.stock.valuation.sighted
                        ? (data.stock.valuation.sighted == true ? "Yes" : "No")
                        : "No"
                },
                'infLicenseDiscExpired': {
                    title : 'License Disc Expired',
                    value : data.stock.valuation && data.stock.valuation.licenseDiscExpired
                        ? (data.stock.valuation.licenseDiscExpired == true ? "Yes" : "No")
                        : "No"
                },

				'companyName' : {
					title : 'Dealership name',
					value : data.company ? data.company.name : ''
				},
				'companyContact' : {
					title : 'Name and surname',
					value : data.company && data.company.contact
								? data.company.contact.firstName + ' ' + data.company.contact.familyName
								: ''
				},
				'companyMobile' : {
					title : 'Mobile',
					value : data.company && data.company.contact
								? data.company.contact.mobile
								: ''
				},
				'companyEmail' : {
					title : 'Email',
					value : data.company && data.company.contact
								? data.company.contact.email
								: ''
				},

				// Added region here
				'region' : {
					title : 'Region',
					value : data.stock && data.stock.company
								? data.stock.company.region.name
								: ''
				},

				'amountOffered' : _w.offerview.formOfferMeta ? _w.offerview.formOfferMeta : {},
				'infAmountOffered' : _w.offerview.formOfferMeta ? _w.offerview.formOfferMeta.value : '0.00',
				'print': {
					constructor: 'Button',
					items: {
						Export: {
							preset: 'Print',
							id: 'printPriceGuidePdf',
							handler: _w.offerview.printPriceGuidePdf
						}
					}
				}
			};
		},

		printPriceGuidePdf : function()
		{
			App.API.getTask(
					'printPriceGuidePdf:' + _w.offerview.itemId, 'PriceGuide', 'Pdf.Print', _w.offerview.itemId,
					{}, function() {
						App.API.execTask(
								'printPriceGuidePdf:' + _w.offerview.itemId, {}, {},
								function () {}, _w.offerview,
								'EXPORT', true
						);
					}, _w.taskContractError
			);
		},

		setOfferViewFormMeta : function( data )
		{
			data = (undefined == data)
				? {"stock":{}}
				: data;
			_w.offerview.formOfferMeta = {
					type  : 'input',
					id    : 'amountOffered',
					title : 'Offer',
					value : data.amount ? data.amount : '0.00',
					onChange : function () {
						_w.offerview.ti.hydrateParam('infAmountOffered', $(this).val());
					},
					onFocus : function()
						{
							var $_this = $(this),
									value  = $_this.val();

							if( value == '0.00' )
								{
									$_this.val('');
								}
						},
					onBlur : function()
						{
							var $_this = $(this),
									value  = $_this.val();

							if( value === '' )
								{
									$_this.val('0.00');
								}
						}
			};
			_w.offerview.ti.hydrateParam('amountOffered', _w.offerview.formOfferMeta);
			_w.offerview.ti.hydrateParam('infAmountOffered', _w.offerview.formOfferMeta.value);

		},

		_onOfferDataAndTemplate : function ()
		{


			if ('Archived' == _w.offerview.offerData.status)
			{
				true == App.permissions.pgUnArchive ? $('#btnUnarchive').show() : $('#btnUnarchive').hide();
				$('#btnArchive').hide();
				$('#optMakeOffer').hide();
			}
			else
			{
				true == App.permissions.pgArchive ? $('#btnArchive').show() : $('#btnArchive').hide();
				$('#btnUnarchive').hide();
			}
		},

		_onOfferViewDataReceived : function( response )
		{
			_w.offerview.offerId = response.Data.id;
			_w.offerview.offerData = response.Data;
			_w.offerview.setOfferViewFormMeta(response.Data);
			if (_w.offerview.ti.published)
			{
				_w.offerview._onOfferDataAndTemplate();
			}
		},

		_onStockDataAndTemplate : function ()
		{
			App.DataStore.loadSelectListData(
					'tuhpi', false, 'Stock', 'Tuhpi.List', null,{"Filter":
					{
						"stock" 		: _w.offerview.itemData.stock.id,
						"company" 		: App.companyData.id

					}}, {},function() {
					// data is retrieved
					var tuHpiData = App.DataStore.getData('tuhpi');
					for (var i = 0; i < tuHpiData.length; i++)
					{
						var tuHpiId = tuHpiData[i].id
						var tuHpiCreated = tuHpiData[i].created
						//created
						if (tuHpiId)
						{
							$('#tuhpiDate').html(tuHpiCreated);
							$('#downloadTuhpi').show();
						}
						else
						{
							$('#tuhpiDate').html('Not Requested Yet');
							$('#downloadTuhpi').hide();
						}
					}
			});

			if (App.permissions.settingsHpiReport == false)
			{
				$('#requestHPIreport').hide();
			}


			if (App.permissions.settingsHpiReport)
			{
				$('#requestHPIreport').show();
			}
			if (_w.offerview.newItem)
			{
				if ('Open4Offers' == _w.offerview.itemData.jobState
						|| 'Updateable Offers' == _w.offerview.itemData.jobState)
				{
					App.API.getTask(
							'createOffer', 'PriceGuide', 'Offer.Create',
							_w.offerview.itemId, {}, function(){}, _w.taskContractError
						);
				}
			}
			else
			{
				if ('Updateable Offers' == _w.offerview.itemData.jobState)
				{
					App.API.getTask(
						'updateOffer:' + _w.offerview.offerId, 'PriceGuide', 'Offer.Update', _w.offerview.itemId,
						{"id":_w.offerview.offerId}, $.proxy( _w.offerview._onOfferViewDataReceived, this ), _w.taskContractError
					);
				}
			}
			if ('Open4Offers' != _w.offerview.itemData.jobState
					&& 'Updateable Offers' != _w.offerview.itemData.jobState)
			{
				$('#optMakeOffer').hide();
			}
			true == App.permissions.pgPrint ? $('#printPriceGuidePdf').show() : $('#printPriceGuidePdf').hide();
			if (null == App.API.taskContract('gridStockHistory'))
			{
				App.API.getTask(
						'gridStockHistory', 'Stock', 'PricingHistory.Grid', null,
						{}, _w.offerview.loadHistoricalGrid, _w.taskContractError
						);
			}
			else
			{
				_w.offerview.loadHistoricalGrid( null, {}, {} );
			}
		},

		_onStockViewDataReceived : function( response )
		{
			_w.offerview.itemId = response.Data.id;
			_w.offerview.itemData = response.Data;
			_w.offerview.setStockViewFormMeta(response.Data);
			_w.offerview.ti.hydrate(_w.offerview.formMeta);
			if (_w.offerview.ti.published)
			{
				_w.offerview._onStockDataAndTemplate();
			}
		},

		_onOfferUpdated : function( response )
		{
			window.location.hash = '/priceguide';
		}

	};

})();