;(function(){

	window._w.stockview = {

		itemId      : null,
		itemData    : null,
		formMeta    : null,
		ti          : null,
		limited     : false,
		newItem     : false,
		validations : 0,
		dates       : [],

		onStockViewTemplateReady : function( template, event, eventData )
		{
			console.log('onstockready');
			_w.stockview.itemData = null;
			_w.stockview.ti = _t[template];
			_w.stockview.limited = ('limitedstockview' == template)
				? true
				: false;
			_w.stockview.itemId = App.Util.getUrlParam('id');
			if (0 == _w.stockview.itemId || null == _w.stockview.itemId)
			{
				_w.stockview.newItem = true;
				_w.stockview.itemData = {
						stock       : {},
						vehicleYear : null,
						type        : {
							category    : {
								id : null
							},
							model       : {
								id   : null,
								make : {
									id : null
								}
							}
						}
				};
			}
			_w.stockview.dates = [];
			var phData = App.DataStore.getData('publicHolidays');
			for (var i = 0; i < phData.length; i++)
			{
				var dateParts = phData[i].holiday.split('-').map(function(part){
						return parseInt(part, 10);
					});
				var holiday = new Date(dateParts[0], dateParts[1]-1, dateParts[2]);
				_w.stockview.dates.push(holiday.toDateString());
			}

			App.DataStore.setData('sparekeys', [{"value":"1", "label":"Yes"}, {"value":"0", "label":"No"}]);
		},

		onStockViewPublished : function( template, event, eventData )
		{

			_w.stockview.ti = _t[template];
			_w.stockview.limited = ('limitedstockview' == template)
				? true
				: false;
			_w.stockview.setStockViewFormMeta();
			_w.stockview.ti.hydrate(_w.stockview.formMeta);
			if (_w.stockview.newItem)
			{
				_w.stockview._setupValidation();
				$('#btnSendToAuction').show();
				$('#btnUpdate').prop('disabled', false);
				$('#printStockPdf').hide();

				/*
				 * Permissions
				 */
				true == App.permissions.stockCreate ? $('#btnUpdate').show() : $('#btnUpdate').hide();
				true == App.permissions.stockRouteAuction && !App.companyData.tC ? $('#optSendToAuction').show() : $('#optSendToAuction').hide();
				if (!App.permissions.stockUpdateDamages)
				{
					$('.damages-form').hide();
				}
				
				if (!App.permissions.stockUploadPhotos)
				{
					$('.photos-form').hide();
				}
			}

			if ( $('#tuhpiDate').val= '' )
			{
				$('#downloadTuhpi').hide();
			}

			$('#btnRequestHPI').click(function () {

				if ('' == $('#HPIusername').val() || '' ==  $('#HPIpin').val())
				{
					alert('Please enter a valid username and password.');
					return;
				}

				$('#HPIdropConfirm').slideToggle();
				$('#HPIresponse').html('');
			});

            $('#btnRequestHPIAccident').click(function () {

                if ('' == $('#HPIAccidentUsername').val() || '' == $('#HPIAccidentPin').val())
                {
                    alert('Please enter a valid username and password.');
                    return;
                }

                $('#HPIAccidentDropConfirm').slideToggle();
                $('#HPIAccidentResponse').html('');
            });


			App.Util.updateCheckboxStyle($('#acceptHPIdisclaimer'));
			$('#HPIbtnConfirm').click(function () {

				if ( $('#engineNumber').val() == '' )
				{
					alert('Please update the Vehicle Engine Number and try again');
					return;
				}
				if ( $('#vinNumber').val() == '' &&  $('#registrationNumber').val() == '')
				{
					alert('Please update the Vin Number or the Registration Number and and try again');
					return;
				}
				if (!$('#acceptHPIdisclaimer').is(':checked'))
				{
					alert('Please accept the conditions before sending.');
					return;
				}
				if (!$('#frmStockView').valid())
				{
					return;
				}
				$('#HPIbtnConfirm').prop('disabled', true);
				var data = _w.stockview._prepStockUpdateData();
				App.API.execTask(
						'updateStock:' + _w.stockview.itemId, {"Stock":data}, {},
						function()
						{
							var task = _w.stockview.limited
								? 'Stock.LimitedUpdate'
								: 'Stock.Update';
							App.API.getTask(
									'updateStock:' + _w.stockview.itemId, 'Stock', task, _w.stockview.itemId,
									{}, function(){}, _w.taskContractError
								);
							var user = $('#HPIusername').val();
							var pass = $('#HPIpin').val();

							App.API.getTask(
									'TransUnionForHPI', 'Stock', 'Utility.TransUnionForHPI', null,
									{'Filter' : {'username' : user ,'pass' : pass , 'stock' : _w.stockview.itemId}},
									function() {
										App.API.execTask(
												'TransUnionForHPI',{}, {},
												function(data)
												{
													$('#HPIdropConfirm').hide();
													if ('Success' == data.Status)
													{
														$('#HPIresponse').html('Success on HPI Report');
														alert('Success on HPI Report');
														App.DataStore.loadSelectListData(
																'tuhpi', false, 'Stock', 'Tuhpi.List', null,
																{"Filter":
																	{
																		"stock" 		: _w.stockview.itemId,
																		"company" 		: App.companyData.id
																	}
																}, {},function()
																{
																	// data is retrieved
																	var tuHpiData = App.DataStore.getData('tuhpi');

                                                                    _w.stockview._loadHpiReportData(tuHpiData);

																	//for (var i = 0; i < tuHpiData.length; i++)
																	//{
																	//	var tuHpiId = tuHpiData[i].id
																	//	var tuHpiCreated = tuHpiData[i].created
																	//	if (tuHpiId)
																	//	{
																	//		$('#tuhpiDate').html(tuHpiCreated);
																	//		$('#downloadTuhpi').show();
																	//		$('#HPIbtnConfirm').prop('disabled', true);
																	//		return;
																	//	}
																	//	else
																	//	{
																	//		$('#tuhpiDate').html('Not Requested Yet');
																	//		$('#downloadTuhpi').hide();
																	//		$('#HPIbtnConfirm').prop('disabled', false);
																	//	}
																	//}
																}
															);
													}
													else
													{
														$('#HPIresponse').html('API call to remote host failed. No data could be retrieved from remote service.');
														$('#HPIbtnConfirm').prop('disabled', false);
													}
												}, function(response)
												{
													alert(
														undefined != response.StatusReason
															? response.StatusReason
															: 'API call to remote host failed. No data could be retrieved from remote service.'
													);
													$('#HPIbtnConfirm').prop('disabled', false);
												}
										);
									}
									, _w.taskContractError
							);
						}, _w.taskExecError
						);
			});

            App.Util.updateCheckboxStyle($('#acceptHPIAccidentDisclaimer'));
            $('#HPIAccidentBtnConfirm').click(function () {

                if ( $('#engineNumber').val() == '' )
                {
                    alert('Please update the Vehicle Engine Number and try again');
                    return;
                }
                if ( $('#vinNumber').val() == '' &&  $('#registrationNumber').val() == '')
                {
                    alert('Please update the Vin Number or the Registration Number and and try again');
                    return;
                }
                if (!$('#acceptHPIAccidentDisclaimer').is(':checked'))
                {
                    alert('Please accept the conditions before sending.');
                    return;
                }
                if (!$('#frmStockView').valid())
                {
                    return;
                }
                $('#HPIAccidentBtnConfirm').prop('disabled', true);
                var data = _w.stockview._prepStockUpdateData();

                App.API.execTask(
                    'updateStock:' + _w.stockview.itemId, {"Stock":data}, {},
                    function()
                    {
                        var task = _w.stockview.limited
                            ? 'Stock.LimitedUpdate'
                            : 'Stock.Update';
                        App.API.getTask(
                            'updateStock:' + _w.stockview.itemId, 'Stock', task, _w.stockview.itemId,
                            {}, function(){}, _w.taskContractError
                        );
                        var user = $('#HPIAccidentUsername').val();
                        var pass = $('#HPIAccidentPin').val();

                        App.API.getTask(
                            'TransUnionForHPIAccident', 'Stock', 'Utility.TransUnionForHPIAccident', null,
                            {'Filter' : {'username' : user ,'pass' : pass , 'stock' : _w.stockview.itemId}},
                            function() {
                                App.API.execTask(
                                    'TransUnionForHPIAccident',{}, {},
                                    function(data)
                                    {
                                        $('#HPIdropConfirm').hide();
                                        if ('Success' == data.Status)
                                        {
                                            $('#HPIresponse').html('Success on HPI Report');
                                            alert('Success on HPI Report');
                                            App.DataStore.loadSelectListData(
                                                'tuhpi', false, 'Stock', 'Tuhpi.List', null,
                                                {"Filter":
                                                {
                                                    "stock" 		: _w.stockview.itemId,
                                                    "company" 		: App.companyData.id
                                                }
                                                }, {},function()
                                                {
                                                    // data is retrieved
                                                    var tuHpiData = App.DataStore.getData('tuhpi');

                                                    _w.stockview._loadHpiReportData(tuHpiData);

                                                }
                                            );
                                        }
                                        else
                                        {
                                            $('#HPIresponse').html('API call to remote host failed. No data could be retrieved from remote service.');
                                            $('#HPIbtnConfirm').prop('disabled', false);
                                        }
                                    }, function(response)
                                    {
                                        alert(
                                            undefined != response.StatusReason
                                                ? response.StatusReason
                                                : 'API call to remote host failed. No data could be retrieved from remote service.'
                                        );
                                        $('#HPIbtnConfirm').prop('disabled', false);
                                    }
                                );
                            }
                            , _w.taskContractError
                        );
                    }, _w.taskExecError
                );
            });

			//$('#downloadTuhpi').click(function () {
			//	App.API.getTask(
			//			'printTuhpi:' + _w.stockview.itemId, 'Stock', 'Tuhpi.Print', _w.stockview.itemId,
			//			{}, function() {
			//				App.API.execTask(
			//						'printTuhpi:' + _w.stockview.itemId, {}, {},
			//						function () {}, _w.taskExecError,
			//						'EXPORT', true
			//				);
			//			}, _w.taskContractError
			//	);
			//});

            $('#btn_mainImage').change(function () {
				if ('' == $('#mainImage').val())
				{
					$('#img_mainImage').addClass('error');
					$('#img_mainImage').removeClass('valid');
				}
				else
				{
					$('#img_mainImage').removeClass('error');
					$('#img_mainImage').addClass('valid');
				}
			});

			$('#btnFetchTu').click(function () {
				if (!$('#vehicleYear').val()
					|| !$('#vehicleType').val())
				{
					alert('Vehicle year and type is required to fetch Trade and Retail pricing.');
					return;
				}
				App.API.getTask(
						'TransUnionFromMmCode', 'Stock', 'Utility.TransUnionFromMmCode', null,
						{}, _w.stockview._onTuReady, _w.taskContractError
				);
			});
			$('#btnUpdate').prop('disabled', true);
			$('#btnArchive').click(function () {
				App.API.directRoute(
						'archiveStock:' + _w.stockview.itemId,
						'Stock', 'Stock.MoveToArchive', _w.stockview.itemId, {},
						_w.stockview._onStockUpdated, _w.taskExecError
						);
			});
			$('#btnUnarchive').click(function () {
				App.API.directRoute(
						'unarchiveStock:' + _w.stockview.itemId,
						'Stock', 'Stock.MoveToStock', _w.stockview.itemId, {},
						_w.stockview._onStockUpdated, _w.taskExecError
						);
			});
			App.Util.updateCheckboxStyle($('#acceptPgHPIdisclaimer'));
			$('#btnSendToPg').click(function () {
				var clubs = $('#clubs').val();
				if (null == clubs)
				{
					alert('Please select at least one club.');
					return;
				}
				if (!$('#acceptPgHPIdisclaimer').is(':checked'))
				{
					alert('Please accept the conditions before sending.');
					return;
				}
				if ('' == $('#registrationNumber').val())
				{
					alert('The Registration, VIN and Engine number is mandatory for moving a vehicle to price guide.');
					$('#registrationNumber').addClass('error');
					$('#registrationNumber').removeClass('valid');
					return;
				}
				else
				{
					$('#registrationNumber').removeClass('error');
					$('#registrationNumber').addClass('valid');
				}
				if ('' == $('#vinNumber').val())
				{
					alert('The Registration, VIN and Engine number is mandatory for moving a vehicle to price guide.');
					$('#vinNumber').addClass('error');
					$('#vinNumber').removeClass('valid');
					return;
				}
				else
				{
					$('#vinNumber').removeClass('error');
					$('#vinNumber').addClass('valid');
				}
				if ('' == $('#engineNumber').val())
				{
					alert('The Registration, VIN and Engine number is mandatory for moving a vehicle to price guide.');
					$('#engineNumber').addClass('error');
					$('#engineNumber').removeClass('valid');
					return;
				}
				else
				{
					$('#engineNumber').removeClass('error');
					$('#engineNumber').addClass('valid');
				}
				if (!$('#frmStockView').valid())
				{
					return;
				}
				$('#btnSendToPg').prop('disabled', true);
				App.API.execTask(
					'updateStock:' + _w.stockview.itemId, {"Stock":_w.stockview._prepStockUpdateData()}, {},
					function () {
						App.API.getRoute(
								'sendToPg:' + _w.stockview.itemId, 'Stock', 'Stock.SendToPriceGuide', _w.stockview.itemId,
								{}, function() {
									var clubList = $('#clubs').val();
									var clubs = [];
									for (var i = 0; i < clubList.length; i++)
									{
										clubs.push({id: clubList[i]});
									}
									App.API.execRoute(
											'sendToPg:' + _w.stockview.itemId, {Context: {clubs: clubs}}, {},
											_w.stockview._onStockUpdated, _w.taskExecError
									);
								}, _w.taskContractError
						);
					}, _w.taskExecError
				);
			});

			$('.back-btn').on('click', function(){
				window.history.back();
			});

			$('#btnSendToRetail').click(function () {
				var reservePrice = $('#retailAmountRequired').val();
				if ('' == reservePrice || isNaN(reservePrice))
				{
					alert('Please provide minimum retail price.');
					return;
				}
				if (!$('#frmStockView').valid())
				{
					return;
				}
				$('#btnSendToRetail').prop('disabled', true);
				App.API.execTask(
						'updateStock:' + _w.stockview.itemId, {"Stock":_w.stockview._prepStockUpdateData()}, {},
						function () {
							App.API.directRoute(
									'retailStock:' + _w.stockview.itemId,
									'Stock', 'Stock.SendToRetail', _w.stockview.itemId, {},
									_w.stockview._onStockUpdated, _w.taskExecError
									);
						}, _w.taskExecError
				);
			});
			$('#btnReclaimFromRetail').click(function () {
				if (!$('#frmStockView').valid())
				{
					return;
				}
				$('#btnReclaimFromRetail').prop('disabled', true);
				App.API.execTask(
						'updateStock:' + _w.stockview.itemId, {"Stock":_w.stockview._prepStockUpdateData()}, {},
						function () {
							App.API.directRoute(
									'retailReclaimStock:' + _w.stockview.itemId,
									'Stock', 'Stock.ReclaimFromRetail', _w.stockview.itemId, {},
									_w.stockview._onStockUpdated, _w.taskExecError
							);
						}, _w.taskExecError
				);
			});
			$('#btnSendToTc').click(function () {
				if (!$('#frmStockView').valid())
				{
					return;
				}
				$('#btnSendToTc').prop('disabled', true);
				if (8 != $('#vehicleCategory').val())
				{
					App.API.getTask(
						'TransUnionFromMmCode', 'Stock', 'Utility.TransUnionFromMmCode', null,
						{}, _w.stockview._onTuTcUpdateReady, _w.taskContractError
					);
				}
				else
				{
					App.API.execTask(
						'updateStock:' + _w.stockview.itemId, {"Stock":_w.stockview._prepStockUpdateData()}, {},
						function () {
							App.API.directRoute(
								'tcStock:' + _w.stockview.itemId,
								'Stock', 'Stock.SendToTradeCenter', _w.stockview.itemId, {},
								_w.stockview._onStockUpdated, _w.taskExecError
							);
						}, _w.taskExecError
					);
				}
			});
			App.Util.updateCheckboxStyle($('#acceptAuctionHPIdisclaimer'));
			$('#btnSendToAuction').click(function () {
				var endDate = $('#endDate').val();
				var reservePrice = $('#reservePrice').val();
				if ('' == endDate || '' == reservePrice || isNaN(reservePrice))
				{
					alert('Please provide end date and reserve price.');
					return;
				}

				if (!$('#frmStockView').valid())
				{
					return;
				}
				if (!$('#acceptAuctionHPIdisclaimer').is(':checked'))
				{
					alert('Please accept the conditions before sending.');
					return;
				}

				if ('' == $('#mainImage').val())
				{
					alert('The main image is mandatory for moving a vehicle to auction.');
					$('#img_mainImage').addClass('error');
					$('#img_mainImage').removeClass('valid');
					return;
				}
				else
				{
					$('#img_mainImage').removeClass('error');
					$('#img_mainImage').addClass('valid');
				}
				if ('' == $('#registrationNumber').val())
				{
					alert('The Registration, VIN and Engine number is mandatory for moving a vehicle to auction.');
					$('#registrationNumber').addClass('error');
					$('#registrationNumber').removeClass('valid');
					return;
				}
				else
				{
					$('#registrationNumber').removeClass('error');
					$('#registrationNumber').addClass('valid');
				}
				if ('' == $('#vinNumber').val())
				{
					alert('The Registration, VIN and Engine number is mandatory for moving a vehicle to auction.');
					$('#vinNumber').addClass('error');
					$('#vinNumber').removeClass('valid');
					return;
				}
				else
				{
					$('#vinNumber').removeClass('error');
					$('#vinNumber').addClass('valid');
				}
				if ('' == $('#engineNumber').val())
				{
					alert('The Registration, VIN and Engine number is mandatory for moving a vehicle to auction.');
					$('#engineNumber').addClass('error');
					$('#engineNumber').removeClass('valid');
					return;
				}
				else
				{
					$('#engineNumber').removeClass('error');
					$('#engineNumber').addClass('valid');
				}


				$('#btnSendToAuction').prop('disabled', true);
				if (_w.stockview.newItem)
				{
					var data = {};
					data.Stock = _w.stockview._prepStockUpdateData();
					data.Context = {endDate: endDate, reservePrice: reservePrice};
					App.API.execTask(
						'createStockAuction', data, {},
						_w.stockview._onStockUpdated, _w.taskExecError
					);
				}
				else
				{
					if (8 != $('#vehicleCategory').val())
					{
						App.API.getTask(
							'TransUnionFromMmCode', 'Stock', 'Utility.TransUnionFromMmCode', null,
							{}, _w.stockview._onTuUpdateReady, _w.taskContractError
						);
					}
					else
					{
						App.API.execTask(
							'updateStock:' + _w.stockview.itemId, {"Stock":_w.stockview._prepStockUpdateData()}, {},
							function () {
								App.API.getRoute(
									'sendToAuction:' + _w.stockview.itemId, 'Stock', 'Stock.SendToAuction', _w.stockview.itemId,
									{}, function() {
										var endDate = $('#endDate').val();
										var reservePrice = $('#reservePrice').val();
										App.API.execRoute(
											'sendToAuction:' + _w.stockview.itemId, {Context: {endDate: endDate, reservePrice: reservePrice}}, {},
											_w.stockview._onStockUpdated, _w.taskExecError
										);
									}, _w.taskContractError
								);
							}, _w.taskExecError
						);
					}
				}
			});
			if (null != _w.stockview.itemData)
			{
				_w.stockview._onDataAndTemplate();
			}
			if (false == _w.stockview.newItem)
			{
				_w.stockview.ti.hydrate({
					'gridPricingHistoryColumnHeaders': {
						constructor: 'GridColumnHeader',
						items: {
							Date: {
								id: 'gridPricingHistoryColumn_Date',
								title: 'Date',
							},
							Trade: {
								id: 'gridPricingHistoryColumn_Trade',
								title: 'Trade',
							},
							TotalRecon: {
								id: 'gridPricingHistoryColumn_totalRecon',
								title: 'Total Recon',
							},
							km: {
								id: 'gridPricingHistoryColumn_km',
								title: 'km',
							},
							PriceguideOffer: {
								id: 'gridPricingHistoryColumn_pricegOffer',
								title: 'Priceguide Offer',
							},
							AuctionWinningBid: {
								id: 'gridPricingHistoryColumn_auctionWinningBid',
								title: 'Auction Winning Bid',
							}
						}
					},
					'gridPricingHistoryRowRepeater': {}
				});
			}
			else
			{
				$('#pricinghistory').hide();
			}

			_w.stockview.itemId = App.Util.getUrlParam('id');
			if (0 == _w.stockview.itemId || null == _w.stockview.itemId)
			{
				App.API.getTask(
					'createStock', 'Stock', 'Stock.Create',
					null, {}, function(){}, _w.taskContractError
				);
				App.API.getTask(
					'createStockAuction', 'Stock', 'Stock.CreateAuction',
					null, {}, function(){}, _w.taskContractError
				);
				App.DataStore.loadSelectListGroup([
                   {dataId: 'years', isStatic: true, workspace: 'Stock', task: 'Year.SelectList'},
                   {dataId: 'categories', isStatic: true, workspace: 'Stock', task: 'Category.SelectList'},
                   {dataId: 'conditions', isStatic: true, workspace: 'Stock', task: 'Condition.SelectList'},
                   {dataId: 'exteriorColours', isStatic: true, workspace: 'Stock', task: 'ExteriorColour.SelectList'},
                   {dataId: 'interiorColours', isStatic: true, workspace: 'Stock', task: 'InteriorColour.SelectList'},
                   {dataId: 'upholsteries', isStatic: true, workspace: 'Stock', task: 'Upholstery.SelectList'},
                   {dataId: 'papers', isStatic: true, workspace: 'Stock', task: 'Paper.SelectList'},
                   {dataId: 'natis', isStatic: true, workspace: 'Stock', task: 'Natis.SelectList'},
                   {dataId: 'fsh', isStatic: true, workspace: 'Stock', task: 'FullServiceHistory.SelectList'},
                   {dataId: 'fuelTypes', isStatic: true, workspace: 'Stock', task: 'FuelType.SelectList'},
                   {dataId: 'transmissionTypes', isStatic: true, workspace: 'Stock', task: 'TransmissionType.SelectList'},
                   {dataId: 'damages', isStatic: true, workspace: 'Stock', task: 'Damage.SelectList'},
                   {dataId: 'accessories', isStatic: true, workspace: 'Stock', task: 'Accessory.SelectList'},
                   {dataId: 'clubs', isStatic: true, workspace: 'PriceGuide', task: 'Club.SelectList'}
                ]);

			}
			else
			{
				_w.stockview.newItem = false;
				var task = _w.stockview.limited
					? 'Stock.LimitedUpdate'
					: 'Stock.Update';
				App.API.getTask(
						'updateStock:' + _w.stockview.itemId, 'Stock', task, _w.stockview.itemId,
						{}, $.proxy( _w.stockview._onStockViewDataReceived, this ), _w.taskContractError
					);
			}
		},

		setStockViewFormMeta : function( data )
		{
			var damages = {};
			if (undefined != data)
			{
				for (var i = 0; i < data.damages.length; i++)
				{
					damages['d' + data.damages[i].damage] = data.damages[i].amount;
				}
			}
			else
			{
				data = {};
			}

			_w.stockview.formMeta = {
				'vehicleYear' : {
					type        : 'select',
					id          : 'vehicleYear',
					title       : 'Year',
					dataStoreId : 'years',
					value       : data.vehicleYear ? data.vehicleYear : '',
					onChange    : function () {
						if (!App.DataStore.getItem('BuildSelect:vehicleYear', false))
						{
							if (_w.stockview.itemData)
							{
								_w.stockview.itemData.vehicleYear = $('#vehicleYear').val();
								_w.stockview._listMakesModelsTypes(function () {
									if ($('#vehicleYear').val() && $('#vehicleType').val())
									{
										App.API.getTask(
												'TransUnionFromMmCode', 'Stock', 'Utility.TransUnionFromMmCode', null,
												{}, _w.stockview._onTuReady, _w.taskContractError
										);
									}
								});
							}
						}
					}
				},
				'category' : {
					type        : 'select',
					id          : 'vehicleCategory',
					title       : 'Category',
					dataStoreId : 'categories',
					value       : data.type ? data.type.category.id : '',
					onChange    : function () {

						if ($(this).val() == 8)
						{
							$('#retailPrice').val('');
							$('#tradePrice').val('');
                            $('#listPrice').val('');
							$('#' + _w.stockview.ti.tid + '_initialTradePrice').val($('#' + _w.stockview.ti.tid + '_tradePrice').html());
							$('#' + _w.stockview.ti.tid + '_updatedTradePrice').val('');
							$('#' + _w.stockview.ti.tid + '_retailPrice').html('R ' + '.00');
							$('#' + _w.stockview.ti.tid + '_tradePrice').html('R ' + '.00');
                            $('#' + _w.stockview.ti.tid + '_listPrice').html('R ' + '.00');
						}



						if ($(this).val() == 8 && _w.stockview.itemId == 0)
						{
							$('#mmCode').html("Other");

						}
						if (!App.DataStore.getItem('BuildSelect:vehicleCategory', false))
						{
							if (_w.stockview.itemData)
							{
								_w.stockview.itemData.type.category.id = $('#vehicleCategory').val();
								_w.stockview._listMakesModelsTypes();
							}
						}
						$('#' + _w.stockview.ti.tid + '_makeManual').hide();
						$('#' + _w.stockview.ti.tid + '_modelManual').hide();
						$('#' + _w.stockview.ti.tid + '_typeManual').hide();
						$('#makeManual').val('');
						$('#modelManual').val('');
						$('#typeManual').val('');
						$('#' + _w.stockview.ti.tid + '_make').show();
						$('#' + _w.stockview.ti.tid + '_model').show();
						$('#' + _w.stockview.ti.tid + '_type').show();
					}
				},
				'make' : {
					type        : 'select',
					id          : 'vehicleMake',
					title       : 'Vehicle Make',
					dataStoreId : 'makes',
					value       : data.type ? data.type.model.make.id : '',
					onChange    : function () {
						if (!App.DataStore.getItem('BuildSelect:vehicleMake', false))
						{
							$('#vehicleMakeManual').val('');
							$('#vehicleModelManual').val('');
							$('#vehicleTypeManual').val('');
							if (-1 == $('#vehicleMake').val())
							{
								$('#' + _w.stockview.ti.tid + '_make').hide();
								$('#' + _w.stockview.ti.tid + '_model').hide();
								$('#' + _w.stockview.ti.tid + '_type').hide();
								$('#' + _w.stockview.ti.tid + '_makeManual').show();
								$('#' + _w.stockview.ti.tid + '_modelManual').show();
								$('#' + _w.stockview.ti.tid + '_typeManual').show();
							}
							else
							{
								$('#' + _w.stockview.ti.tid + '_makeManual').hide();
								$('#' + _w.stockview.ti.tid + '_modelManual').hide();
								$('#' + _w.stockview.ti.tid + '_typeManual').hide();
								$('#' + _w.stockview.ti.tid + '_make').show();
								$('#' + _w.stockview.ti.tid + '_model').show();
								$('#' + _w.stockview.ti.tid + '_type').show();
								if (_w.stockview.itemData)
								{
									_w.stockview.itemData.type.model.make.id = $('#vehicleMake').val();
									_w.stockview._listMakesModelsTypes();
								}
							}
						}
					}
				},
				'model' : {
					type        : 'select',
					id          : 'vehicleModel',
					title       : 'Vehicle Model',
					dataStoreId : 'models',
					value       : data.type ? data.type.model.id : '',
					onChange    : function () {
						if (!App.DataStore.getItem('BuildSelect:vehicleModel', false))
						{
							$('#vehicleModelManual').val('');
							$('#vehicleTypeManual').val('');

							if (-1 == $('#vehicleModel').val())
							{
								$('#' + _w.stockview.ti.tid + '_model').hide();
								$('#' + _w.stockview.ti.tid + '_type').hide();
								$('#' + _w.stockview.ti.tid + '_modelManual').show();
								$('#' + _w.stockview.ti.tid + '_typeManual').show();
							}
							else
							{
								$('#' + _w.stockview.ti.tid + '_modelManual').hide();
								$('#' + _w.stockview.ti.tid + '_typeManual').hide();
								$('#' + _w.stockview.ti.tid + '_model').show();
								$('#' + _w.stockview.ti.tid + '_type').show();
								if (_w.stockview.itemData)
								{
									_w.stockview.itemData.type.model.id = $('#vehicleModel').val();
									_w.stockview._listMakesModelsTypes();
								}
							}
						}
					}
				},
				'type' : {
					type        : 'select',
					id          : 'vehicleType',
					title       : 'Vehicle Type',
					dataStoreId : 'types',
					value       : data.type ? data.type.id : '',
					onChange    : function () {
						if (!App.DataStore.getItem('BuildSelect:vehicleType', false))
						{
							$('#vehicleTypeManual').val('');
							if (-1 == $('#vehicleType').val())
							{
								$('#' + _w.stockview.ti.tid + '_type').hide();
								$('#' + _w.stockview.ti.tid + '_typeManual').show();
							}
							else
							{
								$('#' + _w.stockview.ti.tid + '_typeManual').hide();
								$('#' + _w.stockview.ti.tid + '_type').show();
								if ($('#vehicleYear').val()
									&& $('#vehicleType').val())
								{
									App.API.getTask(
											'TransUnionFromMmCode', 'Stock', 'Utility.TransUnionFromMmCode', null,
											{}, _w.stockview._onTuReady, _w.taskContractError
									);
								}
								if ('' != $(this).val() && null != $(this).val())
								{

									App.API.getTask(
											'GetMmCode' + $(this).val(), 'Stock', 'Type.GetMmCode', null,
											{id:$(this).val()}, function(response){
												$('#mmCode').html(response.Data.mmCode);
											}, _w.taskContractError
									);
								}
								else
								{
									$('#mmCode').html('');
								}
							}
						}
					}
				},

				'makeManual' : {
					type        : 'input',
					id          : 'vehicleMakeManual',
					title       : 'Vehicle Make',
					//dataStoreId : 'makesManual',
					value       : data.type ? data.type.model.make.id : '',
				},
				'modelManual' : {
					type        : 'input',
					id          : 'vehicleModelManual',
					title       : 'Vehicle Model',
					//dataStoreId : 'modelsManual',
					value       : data.type ? data.type.model.id : '',
				},
				'typeManual' : {
					type        : 'input',
					id          : 'vehicleTypeManual',
					title       : 'Vehicle Type',
					//dataStoreId : 'typesManual',
					value       : data.type ? data.type.id : '',
				},

				'mmCode' : {
					type        : 'input',
					id          : 'mmCode',
					title       : 'MM Code',
					style		: 'disable',
					setAttrib	: 'readonly',
					value       : data.type ? data.type.mmCode : ''
				},

				'stockNumber' : {
					type  		: 'input',
					id    		: 'stockNumber',
					title 		: 'Stock number',
					value 		: data.stockNumber ? data.stockNumber : ''
				},

				'fuelType' : {
					type        : 'select',
					id          : 'vehicleFuelType',
					title       : 'Fuel Type',
					dataStoreId : 'fuelTypes',
					value       : data.fuelType ? data.fuelType : ''
				},
				'transmissionType' : {
					type        : 'select',
					id          : 'vehicleTransmissionType',
					title       : 'Transmission Type',
					dataStoreId : 'transmissionTypes',
					value       : data.transmissionType ? data.transmissionType : ''
				},
				'condition' : {
					type        : 'select',
					id          : 'vehicleCondition',
					title       : 'Condition',
					dataStoreId : 'conditions',
					value       : data.condition ? data.condition : ''
				},
				'exteriorColour' : {
					type        : 'select',
					id          : 'exteriorColour',
					title       : 'Main ext. colour',
					dataStoreId : 'exteriorColours',
					value       : data.exteriorColour ? data.exteriorColour : ''
				},
				'interiorColour' : {
					type  : 'select',
					id    : 'interiorColour',
					title : 'Main int. colour',
					dataStoreId : 'interiorColours',
					value : data.interiorColour ? data.interiorColour : ''
				},
				'upholstery' : {
					type        : 'select',
					id          : 'vehicleUpholstery',
					title       : 'Upholstery',
					dataStoreId : 'upholsteries',
					value       : data.upholstery ? data.upholstery : ''
				},
				'papers' : {
					type        : 'select',
					id          : 'vehiclePapers',
					title       : 'Papers',
					dataStoreId : 'papers',
					value       : data.papers ? data.papers : ''
				},
				'natis' : {
					type        : 'select',
					id          : 'vehicleNatis',
					title       : 'Natis',
					dataStoreId : 'natis',
					value       : data.natis ? data.natis : ''
				},
				'spareKeys' : {
					type        : 'select',
					id          : 'spareKeys',
					title       : 'Spare keys',
					dataStoreId : 'sparekeys',
					value       : undefined != data.spareKeys && null != data.spareKeys
									? (data.spareKeys == true ? "1" : "0")
									: null
				},
				'fullServiceHistory' : {
					type        : 'select',
					id          : 'fullServiceHistory',
					title       : 'Full service history',
					dataStoreId : 'fsh',
					value       : data.fullServiceHistory ? data.fullServiceHistory : ''
				},
				'registrationNumber' : {
					type  : 'input',
					id    : 'registrationNumber',
					title : 'Registration no',
					value : data.registrationNumber ? data.registrationNumber : '',
                    style	: 'capitalise'
				},
				'vinNumber' : {
					type  : 'input',
					id    : 'vinNumber',
					title : 'Vin no',
					value : data.vinNumber ? data.vinNumber : '',
                    style	: 'capitalise'
				},
				'engineNumber' : {
					type  : 'input',
					id    : 'engineNumber',
					title : 'Eng. no',
					value : data.engineNumber ? data.engineNumber : '',
                    style	: 'capitalise'
				},
				'km' : {
					type  : 'input',
					id    : 'km',
					title : 'Kms',
					value : data.km ? data.km : ''
				},
				'fshNotes' : {
					type  : 'textarea-small',
					id    : 'fshNotes',
					title : 'FSH notes',
					value : data.fshNotes ? data.fshNotes : ''
				},
				'damages' : {
					type        : 'damageDetails',
					disabled	: !App.permissions.stockUpdateDamages,
					id          : 'damages',
					dataStoreId : 'damages',
					data        : data.damages ? data.damages : {}
				},
				'previousRepairsNoted' : {
					type  : 'checkbox',
					id    : 'previousRepairsNoted',
					title : 'Previous repairs',
					style : 'damages-comments',
					value : data.previousRepairsNoted ? data.previousRepairsNoted : false
				},
				'previousRepairsNotes' : {
					type  : 'textarea-styled',
					disabled	: !App.permissions.stockUpdateDamages,
					id    : 'previousRepairsNotes',
					title : 'Previous repairs notes',
					style : 'damages-comments',
					value : data.previousRepairsNotes ? data.previousRepairsNotes : '',
					onChange: function(){
						var haveData = ('' != $(this).val() ? true : false);
						$('#previousRepairsNoted').prop('checked', haveData);
					}
				},
				'damageTotal' : 'R 0.00',
				'damageNotes' : {
					type  : 'textarea-styled',
					disabled	: !App.permissions.stockUpdateDamages,
					id    : 'damageNotes',
					title : 'Damages comments',
					style : 'damages-comments',
					value : data.damageNotes ? data.damageNotes : ''
				},
				'coverReceived' : {
					type  : 'textarea-styled',
					disabled	: !App.permissions.stockUpdateCoverReceived,
					id    : 'coverReceived',
					title : 'Cover Received',
					style : 'cover-received',
					value : data.coverReceived ? data.coverReceived : ''
				},
				'accessories' : {
					type        : 'checkGroup',
					id          : 'accessories',
					dataStoreId : 'accessories',
					itemName    : 'accessory',
					data        : data.accessories ? data.accessories : {}
				},
				'accessoryNotes' : {
					type      : 'textarea-styled',
					id        : 'accessoryNotes',
					title     : 'Comments',
					style     : 'comment',
					areaStyle : 'comment-text-box',
					value     : data.accessoryNotes ? data.accessoryNotes : ''
				},
				'mainImage' : {
					type  : 'image',
					id    : 'mainImage',
					baseImage : 'main_img_car.jpg',
					view  : !App.permissions.stockUploadPhotos,
					value : data.mainImage ? data.mainImage : ''
				},
				'frontImage' : {
					type  : 'image',
					id    : 'frontImage',
					baseImage : 'front_car.jpg',
					view  : !App.permissions.stockUploadPhotos,
					value : data.frontImage ? data.frontImage : ''
				},
				'leftImage' : {
					type  : 'image',
					id    : 'leftImage',
					baseImage : 'left_car.jpg',
					view  : !App.permissions.stockUploadPhotos,
					value : data.leftImage ? data.leftImage : ''
				},
				'rightImage' : {
					type  : 'image',
					id    : 'rightImage',
					baseImage : 'right_car.jpg',
					view  : !App.permissions.stockUploadPhotos,
					value : data.rightImage ? data.rightImage : ''
				},
				'backImage' : {
					type  : 'image',
					id    : 'backImage',
					baseImage : 'back_car.jpg',
					view  : !App.permissions.stockUploadPhotos,
					value : data.backImage ? data.backImage : ''
				},
				'interiorImage' : {
					type  : 'image',
					id    : 'interiorImage',
					baseImage : 'interior_car.jpg',
					view  : !App.permissions.stockUploadPhotos,
					value : data.interiorImage ? data.interiorImage : ''
				},
				'engineImage' : {
					type  : 'image',
					id    : 'engineImage',
					baseImage : 'engine_car.jpg',
					view  : !App.permissions.stockUploadPhotos,
					value : data.engineImage ? data.engineImage : ''
				},
				'natisImage' : {
					type  : 'image',
					id    : 'natisImage',
					baseImage : 'copy_of_natis_car.jpg',
					view  : !App.permissions.stockUploadPhotos,
					value : data.natisImage ? data.natisImage : ''
				},
				'clubs' : {
					type        : 'select',
					id          : 'clubs',
					title       : 'Select clubs',
					dataStoreId : 'clubs',
					multiple    : true,
					value       : ''
				},
				'endDate' : {
					type  : 'date',
					id    : 'endDate',
					title : 'Auction end date',
					dtopt : {startDate: "+1d", endDate:"+" + App.serverConfig.auctionMaxDays + "d", daysOfWeekDisabled: [0], beforeShowDay: function(date) {
						if (date.getDay() == 6 && !App.openDays[App.Util.formatDate(date, 'yyyy-mm-dd')])
						{
							return false;
						}
						for (var i = 0; i < _w.stockview.dates.length; i++)
						{
							if (_w.stockview.dates[i] == date.toDateString())
							{
								return false;
							}
						}
						return true;
					}},
					value : ''
				},
				'reservePrice' : {
					type  : 'input',
					id    : 'reservePrice',
					title : 'Reserve price',
					value : ''
				},
				'retailAmountRequired' : {
					type  : 'input',
					id    : 'retailAmountRequired',
					title : 'Minimum retail price',
					value : data.retailAmountRequired ? data.retailAmountRequired : ''
				},
				'print': {
					constructor: 'Button',
					items: {
						Export: {
							preset: 'Print',
							id: 'printStockPdf',
							handler: _w.stockview.printStockPdf
						}
					}
				},
                'printAuction': {
                    constructor: 'Button',
                    items: {
                        Export: {
                            preset: 'Print',
                            id: 'printStockAuctionPdf',
                            handler: _w.stockview.printStockAuctionPdf
                        }
                    }
                },
 				'complaint' : {
 					type  : 'textarea-styled',
 					id    : 'complaint',
 					title : 'Complaint',
 					value : '',
 					areaStyle : 'span12',
 					style : 'span10'
 				},


				'dateCreatedPriceGuide': data.created,
				'loadedOnPriceGuide': data.loadedOnPriceGuide,
				'numberOfOffers': data.numberOfOffers,
				'highestOffer': 'R ' + data.highestOffer,
				'timesListed': data.timesListed,
				'highestBid': 'R ' + data.highestBid,
				'referenceNumber': data.referenceNumber,
				'jobState': ('Stock' == data.jobState || 'Trade Center' == data.jobState)
                        && data.auction
                        && (
                        data.auction.jobState == 'Undone'
                        || data.auction.jobState == 'Relist'
                        )
					? 'Relist'
					: data.jobState,




				'tradePrice' : data.tradePrice ? 'R ' + data.tradePrice : 'R 0.00',
				'initialTradePrice' : 0.00 != data.oldTradePrice
					? 'R ' + data.oldTradePrice + (data.oldTradePriceDate ? '<br/>' + data.oldTradePriceDate : '')
					: (data.tradePrice
						? 'R ' + data.tradePrice + (data.tradePriceDate ? '<br/>' + data.tradePriceDate : '')
						: 'R 0.00'
					),
				'updatedTradePrice' : 0.00 != data.oldTradePrice
					? 'R ' + data.tradePrice + (data.tradePriceDate ? '<br/>' + data.tradePriceDate : '')
					: 'R 0.00',
				'retailPrice': data.retailPrice ? 'R ' + data.retailPrice : 'R 0.00',

                'listPrice' : data.listPrice ? 'R ' + data.listPrice : 'R 0.00',

			};
		},

		printStockPdf : function()
		{
			App.API.getTask(
					'printStock:' + _w.stockview.itemId, 'Stock', 'Pdf.Print', _w.stockview.itemId,
					{}, function() {
						App.API.execTask(
								'printStock:' + _w.stockview.itemId, {}, {},
								function () {}, _w.taskExecError,
								'EXPORT', true
						);
					}, _w.taskContractError
			);
		},
        printStockAuctionPdf : function()
        {
            App.API.getTask(
                'printStock:' + _w.stockview.itemId, 'Auction', 'Pdf.PrintPortal', _w.stockview.itemData.auction.id,
                {}, function() {
                    App.API.execTask(
                        'printStock:' + _w.stockview.itemId, {}, {},
                        function () {}, _w.taskExecError,
                        'EXPORT', true
                    );
                }, _w.taskContractError
            );
        },
		loadHistoricalGrid : function( contract, data, options )
		{
			App.API.execTask(
					'gridStockHistory', {Grid:{Filter:{"PricingHistory.stockId":_w.stockview.itemId}}}, options,
					_w.stockview._onHistoryGridDataReceived, _w.taskExecError
					);
		},

		_onHistoryGridDataReceived : function( response )
		{
			_w.stockview.gridStatus = 'Active';
			_w.stockview.ti.hydrateParam('gridPricingHistoryRowRepeater', {});
			var gridData = [];

			if (response.Data.DataSet.length == 0)
			{
				$('#pricing_history_none_found').show();
				$('#PHColumnHeaders').hide();
			}
			else
			{
				$('#pricing_history_none_found').hide();
				$('#PHColumnHeaders').show();
			}

			for (var i = 0; i < response.Data.DataSet.length; i++)
			{
				var row = response.Data.DataSet[i];

				gridData.push({
					prepend: {
						Trade  					: 'R ',
						TotalRecon	 			: 'R ',
						PriceguideOffer 		: 'R ',
						AuctionWinningBid 		: 'R '
					},

					style: {
						Date					: '',
						Trade					: '',
						TotalRecon				: '',
						km						: '',
						PriceguideOffer			: '',
						AuctionWinningBid		: '',


					},
					items: {


						'Date'    			: row.date,
						'Trade'   			: row.trade,
						'TotalRecon'  		: row.totalRecon,
						'KM'    			: row.km,
						'PriceguideOffer'  	: row.pricegOffer,
						'AuctionWinningBid' : row.auctionWinningBid,

				}
				});
			}
			_w.stockview.ti.hydrateParam('gridPricingHistoryRowRepeater', {
				constructor : 'GridDataRow',
				items       : gridData
			});
			//response.Data.Meta.bind = _w.stockview.pageStockGrid;
		},

		_listMakesModelsTypes : function( callback )
		{


			if (!_w.stockview.itemData.vehicleYear)
			{
				return;
			}
			if (_w.stockview.itemData.type
					&& _w.stockview.itemData.type.category
					&& _w.stockview.itemData.type.category.id)
			{
				App.DataStore.loadSelectListData(
						'makes', false, 'Stock', 'Utility.ListMakes', null,
						{"Filter": {
							"category" : _w.stockview.itemData.type.category.id,
							"year" : _w.stockview.itemData.vehicleYear
							}}, {}, $.proxy(function(categoryId)
							{
								if (8 == categoryId)
								{
									var data = App.DataStore.getData('makes');
									data.unshift({
										value: -1,
										label: 'Custom'
									});
									App.DataStore.setData('makes', data);
								}
							}, this, _w.stockview.itemData.type.category.id)
						);
				if (_w.stockview.itemData.type
						&& _w.stockview.itemData.type.model
						&& _w.stockview.itemData.type.model.make
						&& _w.stockview.itemData.type.model.make.id)
				{
					App.DataStore.loadSelectListData(
							'models', false, 'Stock', 'Utility.ListModels', null,
							{"Filter": {
								"make" : _w.stockview.itemData.type.model.make.id,
								"category" : _w.stockview.itemData.type.category.id,
								"year" : _w.stockview.itemData.vehicleYear
								}}, {}, $.proxy(function(categoryId)
								{
									if (8 == categoryId)
									{
										var data = App.DataStore.getData('models');
										data.unshift({
											value: -1,
											label: 'Custom'
										});
										App.DataStore.setData('models', data);
									}
								}, this, _w.stockview.itemData.type.category.id)
							);
					if (_w.stockview.itemData.type.model.id)
					{
						App.DataStore.loadSelectListData(
								'types', false, 'Stock', 'Utility.ListTypes', null,
								{"Filter": {
									"model" : _w.stockview.itemData.type.model.id,
									"category" : _w.stockview.itemData.type.category.id,
									"year" : _w.stockview.itemData.vehicleYear
									}}, {}, $.proxy(function(categoryId, callback)
									{
										if (8 == categoryId)
										{
											var data = App.DataStore.getData('types');
											data.unshift({
												value: -1,
												label: 'Custom'
											});
											App.DataStore.setData('types', data);
										}
										if (callback)
										{
											callback();
										}
									}, this, _w.stockview.itemData.type.category.id, callback)
								);
					}
				}
			}
		},

		_onDataAndTemplate : function ()
		{
			_w.stockview.relistReservePrice = _w.stockview.itemData.auction
												&& _w.stockview.itemData.auction.reservePrice
				? _w.stockview.itemData.auction.reservePrice
				: '';
			$('#reservePrice').val(_w.stockview.relistReservePrice);
			if (!_w.stockview.newItem)
			{
				App.DataStore.loadSelectListData(
							'tuhpi', false, 'Stock', 'Tuhpi.List', null,{"Filter":
								{
									"stock" 		: _w.stockview.itemId,
									"company" 		: App.companyData.id

								}}, {},function() {
								 // data is retrieved
								 var tuHpiData = App.DataStore.getData('tuhpi');

                                _w.stockview._loadHpiReportData(tuHpiData);

								 //for (var i = 0; i < tuHpiData.length; i++)
									//{
									//	var tuHpiId = tuHpiData[i].id
									//	var tuHpiCreated = tuHpiData[i].created
									//	//created
                                 //
									//	if (tuHpiId)
									//	{
									//		$('#tuhpiDate').html(tuHpiCreated);
									//		$('#downloadTuhpi').show();
									//		$('#HPIbtnConfirm').prop('disabled', false);
									//		return;
									//	}
									//	else
									//	{
									//		$('#tuhpiDate').html('Not Requested Yet');
									//		$('#downloadTuhpi').hide();
									//		$('#HPIbtnConfirm').prop('disabled', false);
									//	}
									//}
				});
				if ('Sold' == _w.stockview.itemData.jobState
					&& true == _w.stockview.itemData.auction.Within30DaysOfEnd
					&& App.companyData.id == _w.stockview.itemData.auction.company)
	 			{
	 				$('#btnDispute').show();
	 				$('#btnLogDispute').click(function() {
	 					var comp = $('#complaint').val();
	 					if ('' == comp)
	 					{
	 						alert('Please specify the complaint.');
	 						return;
	 					}
	 					var data = {
	 							Dispute : {
	 								againstCompany : _w.stockview.itemData.auction.soldToCompany,
	 								auction        : _w.stockview.itemData.auction.id,
	 								complaint      : comp
	 							}
	 					};
	 					App.API.getTask(
	 							'createDispute', 'Dispute', 'Dispute.Create',
	 							null, {}, function(){
	 								App.API.execTask(
	 										'createDispute', data, {},
	 										function() {
	 											alert('Dispute logged.');
	 											$('#dropDsp').slideToggle();
	 										}, function() {}
	 								);
	 							}, _w.taskContractError
	 						);
	 				});
	 			}
			}

			$('#endDate').prop('readonly', true);

			var total = 0.00;
			$.each($.find('.rand-input'), function(i, input) {
				total += parseFloat($(input).val());
			});
			$('#' + _w.stockview.ti.tid + '_damageTotal').html('R ' + total);
			$('#' + _w.stockview.ti.tid + '_initialTradePrice').val($('#' + _w.stockview.ti.tid + '_tradePrice').html());
			$('#' + _w.stockview.ti.tid + '_updatedTradePrice').val(_w.stockview.itemData.tradePrice);
			$('#retailPrice').val(_w.stockview.itemData.retailPrice);
			$('#tradePrice').val(_w.stockview.itemData.tradePrice);
            $('#listPrice').val(_w.stockview.itemData.listPrice);
			if ('Archived' == _w.stockview.itemData.jobState)
			{
				true == App.permissions.stockUnarchive ? $('#btnUnarchive').show() : $('#btnUnarchive').hide();
			}
			if ('Retail' == _w.stockview.itemData.jobState)
			{
				true == App.permissions.stockReclaimRetail ? $('#btnReclaimFromRetail').show() : $('#btnReclaimFromRetail').hide();
			}

			/*
			 * Permissions
			 */
			if ('Stock' == _w.stockview.itemData.jobState || _w.stockview.newItem)
			{
				true == App.permissions.stockUpdate ? $('#btnUpdate').show() : $('#btnUpdate').hide();
				true == App.permissions.stockRouteRetail && !_w.stockview.newItem ? $('#optSendToRetail').show() : $('#optSendToRetail').hide();
				true == App.permissions.stockRoutePriceguide ? $('#optSendToPg').show() : $('#optSendToPg').hide();
				if (true == App.permissions.stockRouteAuction)
				{
					App.companyData.tC
						? $('#btnSendToTc').show()
						: $('#optSendToAction').show();
					if (_w.stockview.newItem)
					{
						$('#btnSendToTc').hide();
					}
				}
				else
				{
					$('#optSendToAction').hide();
				}
				true == App.permissions.stockArchive ? $('#btnArchive').show() : $('#btnArchive').hide();
			}
			if ('Auction' == _w.stockview.itemData.jobState)
			{
				(true == App.permissions.stockUpdate && "0.00" == _w.stockview.itemData.highestBid) ? $('#btnUpdate').show() : $('#btnUpdate').hide();
				$('#btnSendToTc').hide();
				$('#optSendToAction').hide();
				$('#optSendToRetail').hide();
				$('#optSendToPg').hide();
				$('#btnArchive').hide();
			}
            if ('Relist' == _w.stockview.itemData.jobState)
            {
                (true == App.permissions.stockUpdate && "0.00" == _w.stockview.itemData.highestBid) ? $('#btnUpdate').show() : $('#btnUpdate').hide();
                $('#btnSendToTc').hide();
                $('#optSendToAction').hide();
                $('#optSendToRetail').hide();
                $('#optSendToPg').hide();
                $('#btnArchive').show();
            }

			true == App.permissions.stockPrint ? $('#printStockPdf').show() : $('#printStockPdf').hide();
			true == App.permissions.stockB4cReport ? $('#btnB4cAccidentReport').show() : $('#btnB4cAccidentReport').hide();
			true == App.permissions.stockBmw ? $('#btnBwmAccidentReport').show() : $('#btnBwmAccidentReport').hide();

			if (!App.permissions.pgPage && !App.permissions.auctionPag)
			{
				$('.pg-a-data-wrapper').hide();
			}
			if (true == App.permissions.pgPage) { $('.price-guide-info').show(); };
			if (true == App.permissions.auctionPage) { $('.auction-info').show(); };

			if (App.permissions.settingsHpiReport == false)
			{
				$('#requestHPIreport').hide();
                $('#requestHPIAccidentReport').hide();
			}

			if (_w.stockview.newItem)
			{
				$('.info-block').hide();
				$('#optSendToPg').hide();
				$('#printStockPdf').hide();
				$('#btnArchive').hide();

				//HPI Report Hide on New
				$('#requestHPIreport').hide();
                $('#requestHPIAccidentReport').hide();
				$('.hpiReport').hide();
			}
			else
			{
				if (App.permissions.settingsHpiReport)
				{
					$('#requestHPIreport').show();
                    $('#requestHPIAccidentReport').show();
				}
				if (null == App.API.taskContract('gridStockHistory'))
				{
					App.API.getTask(
							'gridStockHistory', 'Stock', 'PricingHistory.Grid', null,
							{}, _w.stockview.loadHistoricalGrid, _w.taskContractError
							);
					$('#pricing_history_none_found').hide();
					$('#PHColumnHeaders').hide();
				}
				else
				{
					_w.stockview.loadHistoricalGrid( null, {}, {} );
				}
			}

            if ('Sold' == _w.stockview.itemData.jobState)
            {
                $('.printStockPdf').addClass('hide');
                $('.printStockAuctionPdf').removeClass('hide');
            }

			_w.stockview._setupValidation();
		},

		_onStockViewDataReceived : function( response )
		{
			_w.stockview.itemId = response.Data.id;
			_w.stockview.itemData = response.Data;
			_w.stockview._listMakesModelsTypes();
			_w.stockview.setStockViewFormMeta(response.Data);
			_w.stockview.ti.hydrate(_w.stockview.formMeta);
			if (_w.stockview.ti.published)
			{
				_w.stockview._onDataAndTemplate();
			}
			App.DataStore.loadSelectListGroup([
               {dataId: 'years', isStatic: true, workspace: 'Stock', task: 'Year.SelectList'},
               {dataId: 'categories', isStatic: true, workspace: 'Stock', task: 'Category.SelectList'},
               {dataId: 'conditions', isStatic: true, workspace: 'Stock', task: 'Condition.SelectList'},
               {dataId: 'exteriorColours', isStatic: true, workspace: 'Stock', task: 'ExteriorColour.SelectList'},
               {dataId: 'interiorColours', isStatic: true, workspace: 'Stock', task: 'InteriorColour.SelectList'},
               {dataId: 'upholsteries', isStatic: true, workspace: 'Stock', task: 'Upholstery.SelectList'},
               {dataId: 'papers', isStatic: true, workspace: 'Stock', task: 'Paper.SelectList'},
               {dataId: 'natis', isStatic: true, workspace: 'Stock', task: 'Natis.SelectList'},
               {dataId: 'fsh', isStatic: true, workspace: 'Stock', task: 'FullServiceHistory.SelectList'},
               {dataId: 'fuelTypes', isStatic: true, workspace: 'Stock', task: 'FuelType.SelectList'},
               {dataId: 'transmissionTypes', isStatic: true, workspace: 'Stock', task: 'TransmissionType.SelectList'},
               {dataId: 'damages', isStatic: true, workspace: 'Stock', task: 'Damage.SelectList'},
               {dataId: 'accessories', isStatic: true, workspace: 'Stock', task: 'Accessory.SelectList'},
               {dataId: 'clubs', isStatic: true, workspace: 'PriceGuide', task: 'Club.SelectList'}
            ]);
		},

		_setupValidation : function ()
		{
			App.DataStore.listen('regValidation', 'damages', function(id, damages) {
				var rules = {
					mainImage: "required",
					vehicleYear: "required",
					vehicleCategory: "required",

					//category

					vehicleMake: { required: function(){
						return $('#vehicleMake').parent().css('display') != 'none';
					} },
					vehicleModel: { required: function(){
						return $('#vehicleModel').parent().css('display') != 'none';
					} },
					vehicleType: { required: function(){
						return $('#vehicleType').parent().css('display') != 'none';
					} },

					stockNumber: "required",

					vehicleMakeManual: { required: function(){
						return $('#vehicleMakeManual').parent().parent().css('display') != 'none';
					} },
					vehicleModelManual: { required: function(){
						return $('#vehicleModelManual').parent().parent().css('display') != 'none';
					} },
					vehicleTypeManual: { required: function(){
						return $('#vehicleTypeManual').parent().parent().css('display') != 'none';
					} },

					vehicleFuelType: "required",
					vehicleTransmissionType: "required",
					registrationNumber: "required",
					km: { required: true, digits: true }
				};
				for (var i = 0; i < damages.length; i++)
				{
					rules['damage' + damages[i].value + 'Amount'] = {number: true};
				}

				$('#frmStockView').validate({
					"rules": rules,
					messages: {
						mainImage : "This field is required.",
						vehicleYear : "This field is required.",
						vehicleCategory : "This field is required.",
						vehicleMake : "This field is required.",
						vehicleModel : "This field is required.",
						stockNumber : "This field is required.",
						vehicleType : "This field is required.",

						vehicleMakeManual : "This field is required.",
						vehicleModelManual : "This field is required.",
						vehicleTypeManual : "This field is required.",

						vehicleFuelType : "This field is required.",
						vehicleTransmissionType : "This field is required.",
						registrationNumber : "This field is required.",
						km : {required: "This field is required."}
					},
					invalidHandler: function(event, validator) {
					    var errors = validator.numberOfInvalids();
					    if (0 < _w.stockview.validations && errors)
					    {
						      var message = errors == 1
						        ? 'You missed 1 field. It has been highlighted'
						        : 'You missed ' + errors + ' fields. They have been highlighted';
						      alert(message);
						}
					    _w.stockview.validations++;
					},
					submitHandler: function( form ) {
						$('#btnUpdate').prop('disabled', true);
						var data = _w.stockview._prepStockUpdateData();
						if (_w.stockview.newItem)
						{
							App.API.execTask(
									'createStock', {"Stock":data}, {},
									_w.stockview._onStockUpdated, _w.taskExecError
									);
						}
						else
						{
							App.API.execTask(
									'updateStock:' + _w.stockview.itemId, {"Stock":data}, {},
									_w.stockview._onStockUpdated, _w.taskExecError
									);
						}
					}
				});
				$('#btnUpdate').prop('disabled', false);

				try {
					_w.stockview.validations = 0;
					$('#frmStockView').valid();
				} catch(err) {}
				$('label.error').remove();
				$('.valid').removeClass('valid');
			});
		},

		_onTuTcUpdateReady : function ()
		{
			App.API.execTask(
					'TransUnionFromMmCode', {
						Filter : {
							vehicleYear : parseInt($('#vehicleYear').val()),
							type : parseInt($('#vehicleType').val()),
							stockId : _w.stockview.itemId
						}
				}, {},
				_w.stockview._onTuTcUpdateReceived, function(){}
			);
		},

		_onTuTcUpdateReceived : function ( response )
		{
			if ('Success' != response.Data.Status)
			{
				App.API.execTask(
						'updateStock:' + _w.stockview.itemId, {"Stock":_w.stockview._prepStockUpdateData()}, {},
						function () {
							App.API.directRoute(
									'tcStock:' + _w.stockview.itemId,
									'Stock', 'Stock.SendToTradeCenter', _w.stockview.itemId, {},
									_w.stockview._onStockUpdated, _w.taskExecError
									);
						}, _w.taskExecError
				);
				return;
			}
			var vals = response.Data.VehicleDetails[0].Value;
			$('#retailPrice').val(vals.RetailPrice);
			$('#tradePrice').val(vals.TradePrice);
            $('#listPrice').val(vals.NewPrice);
			$('#' + _w.stockview.ti.tid + '_retailPrice').html('R ' + vals.RetailPrice + '.00');
			$('#' + _w.stockview.ti.tid + '_tradePrice').html('R ' + vals.TradePrice + '.00');
            $('#' + _w.stockview.ti.tid + '_listPrice').html('R ' + vals.NewPrice + '.00');
			App.API.execTask(
					'updateStock:' + _w.stockview.itemId, {"Stock":_w.stockview._prepStockUpdateData()}, {},
					function () {
						App.API.directRoute(
								'tcStock:' + _w.stockview.itemId,
								'Stock', 'Stock.SendToTradeCenter', _w.stockview.itemId, {},
								_w.stockview._onStockUpdated, _w.taskExecError
								);
					}, _w.taskExecError
			);
		},

		_onTuUpdateReady : function ()
		{
			App.API.execTask(
					'TransUnionFromMmCode', {
						Filter : {
							vehicleYear : parseInt($('#vehicleYear').val()),
							type : parseInt($('#vehicleType').val()),
							stockId : _w.stockview.itemId
						}
				}, {},
				_w.stockview._onTuUpdateReceived, function(){}
			);
		},

		_onTuUpdateReceived : function ( response )
		{
			if ('Success' != response.Data.Status)
			{
				App.API.execTask(
						'updateStock:' + _w.stockview.itemId, {"Stock":_w.stockview._prepStockUpdateData()}, {},
						function () {
							App.API.getRoute(
									'sendToAuction:' + _w.stockview.itemId, 'Stock', 'Stock.SendToAuction', _w.stockview.itemId,
									{}, function() {
										var endDate = $('#endDate').val();
										var reservePrice = $('#reservePrice').val();
										App.API.execRoute(
												'sendToAuction:' + _w.stockview.itemId, {Context: {endDate: endDate, reservePrice: reservePrice}}, {},
												_w.stockview._onStockUpdated, _w.taskExecError
										);
									}, _w.taskContractError
							);
						}, _w.taskExecError
				);
				return;
			}
			var vals = response.Data.VehicleDetails[0].Value;
			$('#retailPrice').val(vals.RetailPrice);
			$('#tradePrice').val(vals.TradePrice);
            $('#listPrice').val(vals.NewPrice);
			$('#' + _w.stockview.ti.tid + '_retailPrice').html('R ' + vals.RetailPrice + '.00');
			$('#' + _w.stockview.ti.tid + '_tradePrice').html('R ' + vals.TradePrice + '.00');
            $('#' + _w.stockview.ti.tid + '_listPrice').html('R ' + vals.NewPrice + '.00');
			App.API.execTask(
					'updateStock:' + _w.stockview.itemId, {"Stock":_w.stockview._prepStockUpdateData()}, {},
					function () {
						App.API.getRoute(
								'sendToAuction:' + _w.stockview.itemId, 'Stock', 'Stock.SendToAuction', _w.stockview.itemId,
								{}, function() {
									var endDate = $('#endDate').val();
									var reservePrice = $('#reservePrice').val();
									App.API.execRoute(
											'sendToAuction:' + _w.stockview.itemId, {Context: {endDate: endDate, reservePrice: reservePrice}}, {},
											_w.stockview._onStockUpdated, _w.taskExecError
									);
								}, _w.taskContractError
						);
					}, _w.taskExecError
			);
		},

		_onTuReady : function ()
		{
			App.API.execTask(
					'TransUnionFromMmCode', {
						Filter : {
							vehicleYear : parseInt($('#vehicleYear').val()),
							type : parseInt($('#vehicleType').val())
						}
				}, {},
				_w.stockview._onTuReceived, function(){alert('There were no trade and retail from TransUnion');}
			);
		},

		_onTuReceived : function ( response )
		{
			if ('Success' != response.Data.Status)
			{
				if ('No Results From TransUnion' == response.Data.Status || 'No Values From TransUnion' == response.Data.Status) {
					//write zero values for transunion failed
					var vals = 0.00;
					$('#retailPrice').val(vals);
					$('#tradePrice').val(vals);
					$('#listPrice').val(vals);
					$('#' + _w.stockview.ti.tid + '_retailPrice').html(vals);
					$('#' + _w.stockview.ti.tid + '_tradePrice').html(vals);
					$('#' + _w.stockview.ti.tid + '_listPrice').html(vals);
				}
				alert(response.Data.Status);
				return;
			}
			var vals = response.Data.VehicleDetails[0].Value;
			$('#retailPrice').val(vals.RetailPrice);
			$('#tradePrice').val(vals.TradePrice);
            $('#listPrice').val(vals.NewPrice);
			$('#' + _w.stockview.ti.tid + '_retailPrice').html('R ' + vals.RetailPrice + '.00');
			$('#' + _w.stockview.ti.tid + '_tradePrice').html('R ' + vals.TradePrice + '.00');
            $('#' + _w.stockview.ti.tid + '_listPrice').html('R ' + vals.NewPrice + '.00');
		},

		_prepStockUpdateData : function()
		{
			var data = _w.stockview.ti.harvest();
			data.km = '' == data.km
				? 0
				: parseInt(data.km);
			var retailPrice = $('#retailPrice').val();
			var tradePrice  = $('#tradePrice').val();
            var listPrice  = $('#listPrice').val();
			var retailAmountRequired  = $('#retailAmountRequired').val();
			data.retailPrice = ('' == retailPrice)
				? 0.00
				: parseFloat(retailPrice);
			data.tradePrice = ('' == tradePrice)
				? 0.00
				: parseFloat(tradePrice);
            data.listPrice = ('' == listPrice)
                ? 0.00
                : parseFloat(listPrice);
			data.retailAmountRequired = ('' == retailAmountRequired)
				? 0.00
				: parseFloat(retailAmountRequired);
			delete data.damageTotal;
			if (-1 == data.make)
			{
				delete data.make;
				delete data.model;
				delete data.type;
			}
			if (-1 == data.model)
			{
				delete data.model;
				delete data.type;
			}
			if (-1 == data.type)
			{
				delete data.type;
			}
			if ('' == data.mainImage)
			{
				delete data.mainImage;
			}
			if ('' == data.leftImage)
			{
				delete data.leftImage;
			}
			if ('' == data.backImage)
			{
				delete data.backImage;
			}
			if ('' == data.engineImage)
			{
				delete data.engineImage;
			}
			if ('' == data.frontImage)
			{
				delete data.frontImage;
			}
			if ('' == data.rightImage)
			{
				delete data.rightImage;
			}
			if ('' == data.interiorImage)
			{
				delete data.interiorImage;
			}
			if ('' == data.natisImage)
			{
				delete data.natisImage;
			}
			delete data.clubs;
			return data;
		},

		_onStockUpdated : function( response )
		{
			window.location.hash = '/stock';
		},
        _onHpiDownloadButtonClick: function (event)
        {
            //console.log('event.currentTarget.dataset',event.currentTarget.dataset);

            var hpiType = event.currentTarget.dataset.value;
            var hpiId = event.currentTarget.dataset.id;

            //console.log('hpiId',hpiId);
            //console.log('hpiType',hpiType);

            if('ACC' == hpiType)
            {
                App.API.getTask(
                    'printTuhpiAccident:' + _w.stockview.itemId, 'Stock', 'Tuhpi.PrintAccident', _w.stockview.itemId,
                    {'PdfTemplate':{'recordId':hpiId}}, function () {
                        App.API.execTask(
                            'printTuhpiAccident:' + _w.stockview.itemId, {}, {},
                            function () {
                            }, _w.taskExecError,
                            'EXPORT', true
                        );
                    }, _w.taskContractError
                );
            }
            else
            {
                App.API.getTask(
                    'printTuhpi:' + _w.stockview.itemId, 'Stock', 'Tuhpi.Print', _w.stockview.itemId,
                    {'PdfTemplate':{'recordId':hpiId}}, function () {
                        App.API.execTask(
                            'printTuhpi:' + _w.stockview.itemId, {}, {},
                            function () {
                            }, _w.taskExecError,
                            'EXPORT', true
                        );
                    }, _w.taskContractError
                );

            }

        },
        _loadHpiReportData: function (hpiData) {
            var tuHpiData = hpiData;

            if (0 < tuHpiData.length) {
                $('#HPIreportData').html('');
                var tuHpiId = '';
                var tuHpiCreated = '';
                var tuHpiType = '';
                var tuHpiButtonType = '';
            }

            for (var i = 0; i < tuHpiData.length; i++) {
                if (3 > i) {

                    tuHpiId = tuHpiData[i].id;
                    tuHpiCreated = tuHpiData[i].created;
                    tuHpiType = tuHpiData[i].hpi_type;
                    tuHpiButtonType = tuHpiData[i].hpi_type;

                    var hpiDataHtml = '<div class="control-group mobile-control-group row-fluid" style="display: block;border:1px solid #d3d3d3;" id="' + i + '">'
                        + '<div class="control-group mobile-control-group span4" style="padding-left:10px; padding-top:13px;">Last date requested:</div>'
                        + '<div class="control-group mobile-control-group span4" style="padding-left:10px;border-left:1px solid #d3d3d3; padding-top:13px;">'
                        + '<div id="tuhpiDate_' + i + '" class="span9">Not requested yet.</div>'
                        + '</div>'
                        + '<div class="control-group mobile-control-group span4" style="padding-left:10px;border-left:1px solid #d3d3d3; padding-top:13px;">'
                        + '<div id="tuhpiType_' + i + '" class="span8">Not requested yet.</div>'
                        + '<div class="span4">'
                        + '<button id="downloadTuhpi_' + tuHpiId + '" class="btn pull-right span12" data-id="' + tuHpiId + '" data-value="' + tuHpiButtonType + '" type="button" style="margin:-5px 0 0 0;">view</button>'
                        + '</div>'
                        + '</div>'
                        + '</div>';

                    $('#HPIreportData').append(hpiDataHtml);

                    if (tuHpiId) {
                        $('#tuhpiDate_' + i).html(tuHpiCreated);
                        $('#tuhpiType_' + i).html(tuHpiType);
                        $('#downloadTuhpi').show();
                        $('#HPIbtnConfirm').prop('disabled', false);
                    }
                    else {
                        $('#tuhpiDate_' + i).html('Not Requested Yet');
                        $('#tuhpiType_' + i).html('Not Requested Yet');
                        $('#downloadTuhpi').hide();
                    }


                    $('#downloadTuhpi_' + tuHpiId).click(function (event) {
                        _w.stockview._onHpiDownloadButtonClick(event);
                    });

                }
            }
        }
    };


})();