;(function(){

	window._w.tcstockview = {

		itemId      : null,
		itemData    : null,
		formMeta    : null,
		ti          : null,
		limited     : false,
		newItem     : false,
		validations : 0,
		dates       : [],

		onStockViewTemplateReady : function( template, event, eventData )
		{
			_w.tcstockview.ti = _t[template];
			var phData = App.DataStore.getData('publicHolidays');
			for (var i = 0; i < phData.length; i++)
			{
				var dateParts = phData[i].holiday.split('-').map(function(part){
						return parseInt(part, 10);
					});
				var holiday = new Date(dateParts[0], dateParts[1]-1, dateParts[2]);
				_w.tcstockview.dates.push(holiday.toDateString());
			}

			_w.tcstockview.limited = ('limitedstockview' == template || 'limitedtcstockview' == template)
				? true
				: false;
			App.DataStore.setData('sparekeys', [{"value":"1", "label":"Yes"}, {"value":"0", "label":"No"}]);
			App.DataStore.loadSelectListData('years', true, 'Stock', 'Year.SelectList');
			App.DataStore.loadSelectListData('categories', true, 'Stock', 'Category.SelectList');
			App.DataStore.loadSelectListData('conditions', true, 'Stock', 'Condition.SelectList');
			App.DataStore.loadSelectListData('exteriorColours', true, 'Stock', 'ExteriorColour.SelectList');
			App.DataStore.loadSelectListData('interiorColours', true, 'Stock', 'InteriorColour.SelectList');
			App.DataStore.loadSelectListData('upholsteries', true, 'Stock', 'Upholstery.SelectList');
			App.DataStore.loadSelectListData('papers', true, 'Stock', 'Paper.SelectList');
			App.DataStore.loadSelectListData('natis', true, 'Stock', 'Natis.SelectList');
			App.DataStore.loadSelectListData('fsh', true, 'Stock', 'FullServiceHistory.SelectList');
			App.DataStore.loadSelectListData('fuelTypes', true, 'Stock', 'FuelType.SelectList');
			App.DataStore.loadSelectListData('transmissionTypes', true, 'Stock', 'TransmissionType.SelectList');
			App.DataStore.loadSelectListData('damages', true, 'Stock', 'Damage.SelectList');
			App.DataStore.loadSelectListData('accessories', true, 'Stock', 'Accessory.SelectList');
			App.DataStore.loadSelectListData('clubs', true, 'PriceGuide', 'Club.SelectList');

			_w.tcstockview.setStockViewFormMeta();
			_w.tcstockview.ti.hydrate(_w.tcstockview.formMeta);
			// Retrieve initial view data.
			_w.tcstockview.itemId = App.Util.getUrlParam('id');

			if (0 == _w.tcstockview.itemId || null == _w.tcstockview.itemId)
			{
				_w.tcstockview.newItem = true;
				_w.tcstockview.itemData = {
						stock       : {},
						vehicleYear : null,
						type        : {
							category    : {
								id : null
							},
							model       : {
								id   : null,
								make : {
									id : null
								}
							}
						}
				};
				App.API.getTask(
					'createStock', 'Stock', 'Stock.Create',
					null, {}, function(){}, _w.taskContractError
				);
				App.API.getTask(
					'createStockAuction', 'Stock', 'Stock.CreateAuction',
					null, {}, function(){}, _w.taskContractError
				);
			}
			else
			{
				_w.tcstockview.newItem = false;
				var task = _w.tcstockview.limited
					? 'Stock.LimitedUpdate'
					: 'Stock.Update';
				App.API.getTask(
						'updateStock:' + _w.tcstockview.itemId, 'Stock', task, _w.tcstockview.itemId,
						{}, $.proxy( _w.tcstockview._onStockViewDataReceived, this ), _w.taskContractError
					);
			}
		},

		onStockViewPublished : function( template, event, eventData )
		{
			_w.tcstockview.limited = ('limitedstockview' == template)
				? true
				: false;

			$('#btn_mainImage').change(function () {
				if ('' == $('#mainImage').val())
				{
					$('#img_mainImage').addClass('error');
					$('#img_mainImage').removeClass('valid');
				}
				else
				{
					$('#img_mainImage').removeClass('error');
					$('#img_mainImage').addClass('valid');
				}
			});

			$('#btnFetchTu').click(function () {
				if (!$('#vehicleYear').val()
					|| !$('#vehicleType').val())
				{
					alert('Vehicle year and type is required to fetch Trade and Retail pricing.');
					return;
				}
				App.API.getTask(
						'TransUnionFromMmCode', 'Stock', 'Utility.TransUnionFromMmCode', null,
						{}, _w.tcstockview._onTuReady, _w.taskContractError
				);
			});
			$('#btnUpdate').prop('disabled', true);
			$('#btnArchive').click(function () {
				App.API.directRoute(
						'archiveStock:' + _w.tcstockview.itemId,
						'Stock', 'Stock.MoveToArchive', _w.tcstockview.itemId, {},
						_w.tcstockview._onStockUpdated, _w.taskExecError
						);
			});
			$('#btnUnarchive').click(function () {
				App.API.directRoute(
						'unarchiveStock:' + _w.tcstockview.itemId,
						'Stock', 'Stock.MoveToStock', _w.tcstockview.itemId, {},
						_w.tcstockview._onStockUpdated, _w.taskExecError
						);
			});
			App.Util.updateCheckboxStyle($('#acceptPgHPIdisclaimer'));
			$('#btnSendToPg').click(function () {
				var clubs = $('#clubs').val();
				if (null == clubs)
				{
					alert('Please select at least one club.');
					return;
				}
				if (!$('#acceptPgHPIdisclaimer').is(':checked'))
				{
					alert('Please accept the conditions before sending.');
					return;
				}
				if ('' == $('#registrationNumber').val())
				{
					alert('The Registration, VIN and Engine number is mandatory for moving a vehicle to price guide.');
					$('#registrationNumber').addClass('error');
					$('#registrationNumber').removeClass('valid');
					return;
				}
				else
				{
					$('#registrationNumber').removeClass('error');
					$('#registrationNumber').addClass('valid');
				}
				if ('' == $('#vinNumber').val())
				{
					alert('The Registration, VIN and Engine number is mandatory for moving a vehicle to price guide.');
					$('#vinNumber').addClass('error');
					$('#vinNumber').removeClass('valid');
					return;
				}
				else
				{
					$('#vinNumber').removeClass('error');
					$('#vinNumber').addClass('valid');
				}
				if ('' == $('#engineNumber').val())
				{
					alert('The Registration, VIN and Engine number is mandatory for moving a vehicle to price guide.');
					$('#engineNumber').addClass('error');
					$('#engineNumber').removeClass('valid');
					return;
				}
				else
				{
					$('#engineNumber').removeClass('error');
					$('#engineNumber').addClass('valid');
				}
				if (!$('#frmStockView').valid())
				{
					return;
				}
				$('#btnSendToPg').prop('disabled', true);
				App.API.execTask(
					'updateStock:' + _w.tcstockview.itemId, {"Stock":_w.tcstockview._prepStockUpdateData()}, {},
					function () {
						App.API.getRoute(
								'sendToPg:' + _w.tcstockview.itemId, 'Stock', 'Stock.SendToPriceGuide', _w.tcstockview.itemId,
								{}, function() {
									var clubList = $('#clubs').val();
									var clubs = [];
									for (var i = 0; i < clubList.length; i++)
									{
										clubs.push({id: clubList[i]});
									}
									App.API.execRoute(
											'sendToPg:' + _w.tcstockview.itemId, {Context: {clubs: clubs}}, {},
											_w.tcstockview._onStockUpdated, _w.taskExecError
									);
								}, _w.taskContractError
						);
					}, _w.taskExecError
				);
			});
			$('#btnSendToDealer').click(function () {
				if (!$('#frmStockView').valid())
				{
					return;
				}
				$('#btnSendToDealer').prop('disabled', true);
				App.API.execTask(
						'updateStock:' + _w.tcstockview.itemId, {"Stock":_w.tcstockview._prepStockUpdateData()}, {},
						function () {
							App.API.directRoute(
									'tcStock:' + _w.tcstockview.itemId,
									'Stock', 'Stock.SendToDealer', _w.tcstockview.itemId, {},
									_w.tcstockview._onStockUpdated, _w.taskExecError
									);
						}, _w.taskExecError
				);
			});
			App.Util.updateCheckboxStyle($('#acceptAuctionHPIdisclaimer'));
			$('#btnSendToAuction').click(function () {
				var endDate = $('#endDate').val();
				var reservePrice = $('#reservePrice').val();
				if ('' == endDate || '' == reservePrice || isNaN(reservePrice))
				{
					alert('Please provide end date and reserve price.');
					return;
				}

				if (!$('#frmStockView').valid())
				{
					return;
				}
				if (!$('#acceptAuctionHPIdisclaimer').is(':checked'))
				{
					alert('Please accept the conditions before sending.');
					return;
				}

				if ('' == $('#mainImage').val())
				{
					alert('The main image is mandatory for moving a vehicle to auction.');
					$('#img_mainImage').addClass('error');
					$('#img_mainImage').removeClass('valid');
					return;
				}
				else
				{
					$('#img_mainImage').removeClass('error');
					$('#img_mainImage').addClass('valid');
				}
				if ('' == $('#registrationNumber').val())
				{
					alert('The Registration, VIN and Engine number is mandatory for moving a vehicle to auction.');
					$('#registrationNumber').addClass('error');
					$('#registrationNumber').removeClass('valid');
					return;
				}
				else
				{
					$('#registrationNumber').removeClass('error');
					$('#registrationNumber').addClass('valid');
				}
				if ('' == $('#vinNumber').val())
				{
					alert('The Registration, VIN and Engine number is mandatory for moving a vehicle to auction.');
					$('#vinNumber').addClass('error');
					$('#vinNumber').removeClass('valid');
					return;
				}
				else
				{
					$('#vinNumber').removeClass('error');
					$('#vinNumber').addClass('valid');
				}
				if ('' == $('#engineNumber').val())
				{
					alert('The Registration, VIN and Engine number is mandatory for moving a vehicle to auction.');
					$('#engineNumber').addClass('error');
					$('#engineNumber').removeClass('valid');
					return;
				}
				else
				{
					$('#engineNumber').removeClass('error');
					$('#engineNumber').addClass('valid');
				}


				$('#btnSendToAuction').prop('disabled', true);
				if (_w.tcstockview.newItem)
				{
					var data = {};
					data.Stock = _w.tcstockview._prepStockUpdateData();
					data.Context = {endDate: endDate, reservePrice: reservePrice};
					App.API.execTask(
						'createStockAuction', data, {},
						_w.tcstockview._onStockUpdated, _w.taskExecError
					);
				}
				else
				{
					App.API.execTask(
							'updateStock:' + _w.tcstockview.itemId, {"Stock":_w.tcstockview._prepStockUpdateData()}, {},
							function () {
								App.API.getRoute(
										'sendToAuction:' + _w.tcstockview.itemId, 'Stock', 'Stock.SendToAuction', _w.tcstockview.itemId,
										{}, function() {
											var endDate = $('#endDate').val();
											var reservePrice = $('#reservePrice').val();
											App.API.execRoute(
													'sendToAuction:' + _w.tcstockview.itemId, {Context: {endDate: endDate, reservePrice: reservePrice}}, {},
													_w.tcstockview._onStockUpdated, _w.taskExecError
											);
										}, _w.taskContractError
								);
							}, _w.taskExecError
					);
				}
			});

            $('.back-btn').on('click', function(){
                window.history.back();
            });

			if (null != _w.tcstockview.itemData)
			{
				_w.tcstockview._onDataAndTemplate();
			}
		},

		setStockViewFormMeta : function( data )
		{
			var damages = {};
			if (undefined != data)
			{
				for (var i = 0; i < data.damages.length; i++)
				{
					damages['d' + data.damages[i].damage] = data.damages[i].amount;
				}
			}
			else
			{
				data = {};
			}
			_w.tcstockview.formMeta = {
				'vehicleYear' : {
					type        : 'select',
					id          : 'vehicleYear',
					title       : 'Year',
					dataStoreId : 'years',
					value       : data.vehicleYear ? data.vehicleYear : '',
					onChange    : function () {
						if (!App.DataStore.getItem('BuildSelect:vehicleYear', false))
						{
							if (_w.tcstockview.itemData)
							{
								_w.tcstockview.itemData.vehicleYear = $('#vehicleYear').val();
								_w.tcstockview._listMakesModelsTypes(function () {
									if ($('#vehicleYear').val() && $('#vehicleType').val())
									{
										App.API.getTask(
												'TransUnionFromMmCode', 'Stock', 'Utility.TransUnionFromMmCode', null,
												{}, _w.tcstockview._onTuReady, _w.taskContractError
										);
									}
								});
							}
						}
					}
				},
				'category' : {
					type        : 'select',
					id          : 'vehicleCategory',
					title       : 'Category',
					dataStoreId : 'categories',
					value       : data.type ? data.type.category.id : '',
					onChange    : function () {
						if (!App.DataStore.getItem('BuildSelect:vehicleCategory', false))
						{
							if (_w.tcstockview.itemData)
							{
								_w.tcstockview.itemData.type.category.id = $('#vehicleCategory').val();
								_w.tcstockview._listMakesModelsTypes();
							}
						}
					}
				},
				'make' : {
					type        : 'select',
					id          : 'vehicleMake',
					title       : 'Vehicle Make',
					dataStoreId : 'makes',
					value       : data.type ? data.type.model.make.id : '',
					onChange    : function () {
						if (!App.DataStore.getItem('BuildSelect:vehicleMake', false))
						{
							if (_w.tcstockview.itemData)
							{
								_w.tcstockview.itemData.type.model.make.id = $('#vehicleMake').val();
								_w.tcstockview._listMakesModelsTypes();
							}
						}
					}
				},
				'model' : {
					type        : 'select',
					id          : 'vehicleModel',
					title       : 'Vehicle Model',
					dataStoreId : 'models',
					value       : data.type ? data.type.model.id : '',
					onChange    : function () {
						if (!App.DataStore.getItem('BuildSelect:vehicleModel', false))
						{
							if (_w.tcstockview.itemData)
							{
								_w.tcstockview.itemData.type.model.id = $('#vehicleModel').val();
								_w.tcstockview._listMakesModelsTypes();
							}
						}
					}
				},
				'type' : {
					type        : 'select',
					id          : 'vehicleType',
					title       : 'Vehicle Type',
					dataStoreId : 'types',
					value       : data.type ? data.type.id : '',
					onChange    : function () {
						if ('' != $(this).val() && null != $(this).val())
						{
							App.API.getTask(
									'GetMmCode' + $(this).val(), 'Stock', 'Type.GetMmCode', null,
									{id:$(this).val()}, function(response){
										$('#mmCode').html(response.Data.mmCode);
									}, _w.taskContractError
							);
						}
						else
						{
							$('#mmCode').html('');
						}
						if (!App.DataStore.getItem('BuildSelect:vehicleType', false)
							&& $('#vehicleYear').val()
							&& $('#vehicleType').val())
						{
							App.API.getTask(
									'TransUnionFromMmCode', 'Stock', 'Utility.TransUnionFromMmCode', null,
									{}, _w.tcstockview._onTuReady, _w.taskContractError
							);
						}
					}
				},
				'mmCode' : {
					type        : 'input',
					id          : 'mmCode',
					title       : 'MM Code',
					style		: 'disable',
					setAttrib	: 'readonly',
					value       : data.type ? data.type.mmCode : ''
				},
				'stockNumber' : {
					type  		: 'input',
					id    		: 'stockNumber',
					title 		: 'Stock number',
					value 		: data.stockNumber ? data.stockNumber : ''
				},
				'fuelType' : {
					type        : 'select',
					id          : 'vehicleFuelType',
					title       : 'Fuel Type',
					dataStoreId : 'fuelTypes',
					value       : data.fuelType ? data.fuelType : ''
				},
				'transmissionType' : {
					type        : 'select',
					id          : 'vehicleTransmissionType',
					title       : 'Transmission Type',
					dataStoreId : 'transmissionTypes',
					value       : data.transmissionType ? data.transmissionType : ''
				},
				'condition' : {
					type        : 'select',
					id          : 'vehicleCondition',
					title       : 'Condition',
					dataStoreId : 'conditions',
					value       : data.condition ? data.condition : ''
				},
				'exteriorColour' : {
					type        : 'select',
					id          : 'exteriorColour',
					title       : 'Main ext. colour',
					dataStoreId : 'exteriorColours',
					value       : data.exteriorColour ? data.exteriorColour : ''
				},
				'interiorColour' : {
					type  : 'select',
					id    : 'interiorColour',
					title : 'Main int. colour',
					dataStoreId : 'interiorColours',
					value : data.interiorColour ? data.interiorColour : ''
				},
				'upholstery' : {
					type        : 'select',
					id          : 'vehicleUpholstery',
					title       : 'Upholstery',
					dataStoreId : 'upholsteries',
					value       : data.upholstery ? data.upholstery : ''
				},
				'papers' : {
					type        : 'select',
					id          : 'vehiclePapers',
					title       : 'Papers',
					dataStoreId : 'papers',
					value       : data.papers ? data.papers : ''
				},
				'natis' : {
					type        : 'select',
					id          : 'vehicleNatis',
					title       : 'Natis',
					dataStoreId : 'natis',
					value       : data.natis ? data.natis : ''
				},
				'spareKeys' : {
					type        : 'select',
					id          : 'spareKeys',
					title       : 'Spare keys',
					dataStoreId : 'sparekeys',
					value       : undefined != data.spareKeys && null != data.spareKeys
									? (data.spareKeys == true ? "1" : "0")
									: null
				},
				'fullServiceHistory' : {
					type        : 'select',
					id          : 'fullServiceHistory',
					title       : 'Full service history',
					dataStoreId : 'fsh',
					value       : data.fullServiceHistory ? data.fullServiceHistory : ''
				},
				'registrationNumber' : {
					type  : 'input',
					id    : 'registrationNumber',
					title : 'Registration no',
					value : data.registrationNumber ? data.registrationNumber : ''
				},
				'vinNumber' : {
					type  : 'input',
					id    : 'vinNumber',
					title : 'Vin no',
					value : data.vinNumber ? data.vinNumber : ''
				},
				'engineNumber' : {
					type  : 'input',
					id    : 'engineNumber',
					title : 'Eng. no',
					value : data.engineNumber ? data.engineNumber : ''
				},
				'km' : {
					type  : 'input',
					id    : 'km',
					title : 'Kms',
					value : data.km ? data.km : ''
				},
				'fshNotes' : {
					type  : 'textarea-small',
					id    : 'fshNotes',
					title : 'FSH notes',
					value : data.fshNotes ? data.fshNotes : ''
				},
				'damages' : {
					type        : 'damageDetails',
					disabled	: !App.permissions.stockUpdateDamages,
					id          : 'damages',
					dataStoreId : 'damages',
					data        : data.damages ? data.damages : {}
				},
				'damageTotal' : 'R 0.00',
				'damageNotes' : {
					type  : 'textarea-styled',
					disabled	: !App.permissions.stockUpdateDamages,
					id    : 'damageNotes',
					title : 'Damages comments',
					style : 'damages-comments',
					value : data.damageNotes ? data.damageNotes : ''
				},
				'coverReceived' : {
					type  : 'textarea-styled',
					disabled	: !App.permissions.stockUpdateCoverReceived,
					id    : 'coverReceived',
					title : 'Cover Received',
					style : 'cover-received',
					value : data.coverReceived ? data.coverReceived : ''
				},
                'previousRepairsNoted': {
                    type: 'checkbox',
                    id: 'previousRepairsNoted',
                    title: 'Previous repairs',
                    style: 'damages-comments',
                    value: data.previousRepairsNoted ? data.previousRepairsNoted : false
                },
				'previousRepairsNotes' : {
					type  : 'textarea-styled',
					disabled	: !App.permissions.stockUpdateDamages,
					id    : 'previousRepairsNotes',
					title : 'Previous repairs noted',
					style : 'damages-comments',
					value : data.previousRepairsNotes ? data.previousRepairsNotes : ''
				},
				'accessories' : {
					type        : 'checkGroup',
					id          : 'accessories',
					dataStoreId : 'accessories',
					itemName    : 'accessory',
					data        : data.accessories ? data.accessories : {}
				},
				'accessoryNotes' : {
					type      : 'textarea-styled',
					id        : 'accessoryNotes',
					title     : 'Comments',
					style     : 'comment',
					areaStyle : 'comment-text-box',
					value     : data.accessoryNotes ? data.accessoryNotes : ''
				},
				'mainImage' : {
					type  : 'image',
					id    : 'mainImage',
					baseImage : 'main_img_car.jpg',
					view  : !App.permissions.stockUploadPhotos,
					value : data.mainImage ? data.mainImage : ''
				},
				'frontImage' : {
					type  : 'image',
					id    : 'frontImage',
					baseImage : 'front_car.jpg',
					view  : !App.permissions.stockUploadPhotos,
					value : data.frontImage ? data.frontImage : ''
				},
				'leftImage' : {
					type  : 'image',
					id    : 'leftImage',
					baseImage : 'left_car.jpg',
					view  : !App.permissions.stockUploadPhotos,
					value : data.leftImage ? data.leftImage : ''
				},
				'rightImage' : {
					type  : 'image',
					id    : 'rightImage',
					baseImage : 'right_car.jpg',
					view  : !App.permissions.stockUploadPhotos,
					value : data.rightImage ? data.rightImage : ''
				},
				'backImage' : {
					type  : 'image',
					id    : 'backImage',
					baseImage : 'back_car.jpg',
					view  : !App.permissions.stockUploadPhotos,
					value : data.backImage ? data.backImage : ''
				},
				'interiorImage' : {
					type  : 'image',
					id    : 'interiorImage',
					baseImage : 'interior_car.jpg',
					view  : !App.permissions.stockUploadPhotos,
					value : data.interiorImage ? data.interiorImage : ''
				},
				'engineImage' : {
					type  : 'image',
					id    : 'engineImage',
					baseImage : 'engine_car.jpg',
					view  : !App.permissions.stockUploadPhotos,
					value : data.engineImage ? data.engineImage : ''
				},
				'natisImage' : {
					type  : 'image',
					id    : 'natisImage',
					baseImage : 'copy_of_natis_car.jpg',
					view  : !App.permissions.stockUploadPhotos,
					value : data.natisImage ? data.natisImage : ''
				},
				'clubs' : {
					type        : 'select',
					id          : 'clubs',
					title       : 'Select clubs',
					dataStoreId : 'clubs',
					multiple    : true,
					value       : ''
				},
				'endDate' : {
					type  : 'date',
					id    : 'endDate',
					title : 'Auction end date',
					dtopt : {startDate: "+1d", endDate:"+" + App.serverConfig.auctionMaxDays + "d", daysOfWeekDisabled: [0], beforeShowDay: function(date) {
						if (date.getDay() == 6 && !App.openDays[App.Util.formatDate(date, 'yyyy-mm-dd')])
						{
							return false;
						}
						for (var i = 0; i < _w.tcstockview.dates.length; i++)
						{
							if (_w.tcstockview.dates[i] == date.toDateString())
							{
								return false;
							}
						}
						return true;
					}},
					value : ''
				},
				'reservePrice' : {
					type  : 'input',
					id    : 'reservePrice',
					title : 'Reserve price',
					value : ''
				},
				'retailAmountRequired' : {
					type  : 'input',
					id    : 'retailAmountRequired',
					title : 'Minimum retail price',
					value : data.retailAmountRequired ? data.retailAmountRequired : ''
				},
				'print': {
					constructor: 'Button',
					items: {
						Export: {
							preset: 'Print',
							id: 'printStockPdf',
							handler: _w.tcstockview.printStockPdf
						}
					}
				},
                'printAuction': {
                    constructor: 'Button',
                    items: {
                        Export: {
                            preset: 'Print',
                            id: 'printStockAuctionPdf',
                            handler: _w.tcstockview.printStockAuctionPdf
                        }
                    }
                },
 				'complaint' : {
 					type  : 'textarea-styled',
 					id    : 'complaint',
 					title : 'Complaint',
 					value : '',
 					areaStyle : 'span12',
 					style : 'span10'
 				},
				'loadedOnPriceGuide': data.loadedOnPriceGuide,
				'numberOfOffers': data.numberOfOffers,
				'highestOffer': 'R ' + data.highestOffer,
				'timesListed': data.timesListed,
				'highestBid': 'R ' + data.highestBid,
				'referenceNumber': data.referenceNumber,
				'jobState': data.auction
				&& (
					data.auction.jobState == 'Undone'
					|| data.auction.jobState == 'Relist'
				)
					? 'Relist'
					: data.jobState,
				'tradePrice': data.tradePrice ? 'R ' + data.tradePrice : 'R 0.00',
				'retailPrice': data.retailPrice ? 'R ' + data.retailPrice : 'R 0.00',
                'listPrice': data.listPrice ? 'R ' + data.listPrice : 'R 0.00'
			};
		},

		printStockPdf : function()
		{
			App.API.getTask(
					'printStock:' + _w.tcstockview.itemId, 'Stock', 'Pdf.Print', _w.tcstockview.itemId,
					{}, function() {
						App.API.execTask(
								'printStock:' + _w.tcstockview.itemId, {}, {},
								function () {}, _w.taskExecError,
								'EXPORT', true
						);
					}, _w.taskContractError
			);
		},
        printStockAuctionPdf : function()
        {
            App.API.getTask(
                'printStock:' + _w.tcstockview.itemId, 'Auction', 'Pdf.PrintPortal', _w.tcstockview.itemData.auction.id,
                {}, function() {
                    App.API.execTask(
                        'printStock:' + _w.tcstockview.itemId, {}, {},
                        function () {}, _w.taskExecError,
                        'EXPORT', true
                    );
                }, _w.taskContractError
            );
        },
		_listMakesModelsTypes : function( callback )
		{
			if (!_w.tcstockview.itemData.vehicleYear)
			{
				return;
			}
			if (_w.tcstockview.itemData.type
					&& _w.tcstockview.itemData.type.category
					&& _w.tcstockview.itemData.type.category.id)
			{
				App.DataStore.loadSelectListData(
						'makes', false, 'Stock', 'Utility.ListMakes', null,
						{"Filter": {
							"category" : _w.tcstockview.itemData.type.category.id,
							"year" : _w.tcstockview.itemData.vehicleYear
							}}
						);
				if (_w.tcstockview.itemData.type
						&& _w.tcstockview.itemData.type.model
						&& _w.tcstockview.itemData.type.model.make
						&& _w.tcstockview.itemData.type.model.make.id)
				{
					App.DataStore.loadSelectListData(
							'models', false, 'Stock', 'Utility.ListModels', null,
							{"Filter": {
								"make" : _w.tcstockview.itemData.type.model.make.id,
								"category" : _w.tcstockview.itemData.type.category.id,
								"year" : _w.tcstockview.itemData.vehicleYear
								}}
							);
					if (_w.tcstockview.itemData.type.model.id)
					{
						App.DataStore.loadSelectListData(
								'types', false, 'Stock', 'Utility.ListTypes', null,
								{"Filter": {
									"model" : _w.tcstockview.itemData.type.model.id,
									"category" : _w.tcstockview.itemData.type.category.id,
									"year" : _w.tcstockview.itemData.vehicleYear
									}}, {}, callback
								);
					}
				}
			}
		},

		_onDataAndTemplate : function ()
		{
			_w.tcstockview.relistReservePrice = _w.tcstockview.itemData.auction
												&& _w.tcstockview.itemData.auction.reservePrice
				? _w.tcstockview.itemData.auction.reservePrice
				: '';
			$('#reservePrice').val(_w.tcstockview.relistReservePrice);
			var total = 0.00;
			$.each($.find('.rand-input'), function(i, input) {
				total += parseFloat($(input).val());
			});
			$('#' + _w.tcstockview.ti.tid + '_damageTotal').html('R ' + total);
			$('#retailPrice').val(_w.tcstockview.itemData.retailPrice);
			$('#tradePrice').val(_w.tcstockview.itemData.tradePrice);
            $('#listPrice').val(_w.tcstockview.itemData.listPrice);
			if ('Archived' == _w.tcstockview.itemData.jobState)
			{
				true == App.permissions.stockUnarchive ? $('#btnUnarchive').show() : $('#btnUnarchive').hide();
			}
			if ('Retail' == _w.tcstockview.itemData.jobState)
			{
				console.log('in status RETAIL');
				console.log(App.permissions.stockReclaimRetail);
				true == App.permissions.stockReclaimRetail ? $('#btnReclaimFromRetail').show() : $('#btnReclaimFromRetail').hide();
			}
			console.log(_w.tcstockview.itemData);
			if ('Sold' == _w.tcstockview.itemData.jobState
				&& true == _w.tcstockview.itemData.auction.Within30DaysOfEnd
				&& App.companyData.id == _w.tcstockview.itemData.auction.company)
 			{
 				$('#btnDispute').show();
 				$('#btnLogDispute').click(function() {
 					var comp = $('#complaint').val();
 					if ('' == comp)
 					{
 						alert('Please specify the complaint.');
 						return;
 					}
 					var data = {
 							Dispute : {
 								againstCompany : _w.tcstockview.itemData.auction.soldToCompany,
 								auction        : _w.tcstockview.itemData.auction.id,
 								complaint      : comp
 							}
 					};
 					App.API.getTask(
 							'createDispute', 'Dispute', 'Dispute.Create',
 							null, {}, function(){
 								App.API.execTask(
 										'createDispute', data, {},
 										function() {
 											alert('Dispute logged.');
 											$('#dropDsp').slideToggle();
 										}, function() {}
 								);
 							}, _w.taskContractError
 						);
 				});
 			}

			/*
			 * Permissions
			 */
			if ('Trade Center' == _w.tcstockview.itemData.jobState || _w.tcstockview.newItem)
			{
				if (true == App.permissions.stockRouteAuction)
				{
					$('#optSendToAction').show();
				}
				else
				{
					$('#optSendToAction').hide();
				}
				$('#btnSendToDealer').show();
				true == App.permissions.stockUpdate ? $('#btnUpdate').show() : $('#btnUpdate').hide();
			}
			true == App.permissions.stockPrint ? $('#printStockPdf').show() : $('#printStockPdf').hide();
			true == App.permissions.stockB4cReport ? $('#btnB4cAccidentReport').show() : $('#btnB4cAccidentReport').hide();
			true == App.permissions.stockBmw ? $('#btnBwmAccidentReport').show() : $('#btnBwmAccidentReport').hide();

			if (!App.permissions.pgPage && !App.permissions.auctionPage)
			{
				$('.pg-a-data-wrapper').hide();
			}
			if (true == App.permissions.pgPage) { $('.price-guide-info').show(); };
			if (true == App.permissions.auctionPage) { $('.auction-info').show(); };
			if (_w.tcstockview.newItem)
			{
				$('.info-block').hide();
				$('#optSendToPg').hide();
				$('#printStockPdf').hide();
				$('#btnArchive').hide();
			}

            if ('Sold' == _w.tcstockview.itemData.jobState)
            {
                $('.printStockPdf').addClass('hide');
                $('.printStockAuctionPdf').removeClass('hide');
            }

			_w.tcstockview._setupValidation();
		},

		_onStockViewDataReceived : function( response )
		{
			_w.tcstockview.itemId = response.Data.id;
			_w.tcstockview.itemData = response.Data;
			_w.tcstockview._listMakesModelsTypes();
			_w.tcstockview.setStockViewFormMeta(response.Data);
			_w.tcstockview.ti.hydrate(_w.tcstockview.formMeta);
			if (_w.tcstockview.ti.published)
			{
				_w.tcstockview._onDataAndTemplate();
			}
		},

		_setupValidation : function ()
		{
			App.DataStore.listen('regValidation', 'damages', function(id, damages) {
				var rules = {
					mainImage: "required",
					vehicleYear: "required",
					vehicleCategory: "required",
					vehicleMake: "required",
					vehicleModel: "required",
					vehicleType: "required",
					vehicleFuelType: "required",
					vehicleTransmissionType: "required",
					registrationNumber: "required",
					km: { required: true, digits: true }
				};
				for (var i = 0; i < damages.length; i++)
				{
					rules['damage' + damages[i].value + 'Amount'] = {number: true};
				}

				$('#frmStockView').validate({
					"rules": rules,
					messages: {
						mainImage : "This field is required.",
						vehicleYear : "This field is required.",
						vehicleCategory : "This field is required.",
						vehicleMake : "This field is required.",
						vehicleModel : "This field is required.",
						vehicleType : "This field is required.",
						vehicleFuelType : "This field is required.",
						vehicleTransmissionType : "This field is required.",
						registrationNumber : "This field is required.",
						km : {required: "This field is required."}
					},
					invalidHandler: function(event, validator) {
					    var errors = validator.numberOfInvalids();
					    if (0 < _w.tcstockview.validations && errors)
					    {
						      var message = errors == 1
						        ? 'You missed 1 field. It has been highlighted'
						        : 'You missed ' + errors + ' fields. They have been highlighted';
						      alert(message);
						}
					    _w.tcstockview.validations++;
					},
					submitHandler: function( form ) {
						$('#btnUpdate').prop('disabled', true);
						var data = _w.tcstockview._prepStockUpdateData();
						if (_w.tcstockview.newItem)
						{
							App.API.execTask(
									'createStock', {"Stock":data}, {},
									_w.tcstockview._onStockUpdated, _w.taskExecError
									);
						}
						else
						{
							App.API.execTask(
									'updateStock:' + _w.tcstockview.itemId, {"Stock":data}, {},
									_w.tcstockview._onStockUpdated, _w.taskExecError
									);
						}
					}
				});
				$('#btnUpdate').prop('disabled', false);
				try {
					_w.tcstockview.validations = 0;
					$('#frmStockView').valid();
				} catch(err) {}
				$('label.error').remove();
				$('.valid').removeClass('valid');
			});
		},

		_onTuReady : function ()
		{
			App.API.execTask(
					'TransUnionFromMmCode', {
						Filter : {
							vehicleYear : parseInt($('#vehicleYear').val()),
							type : parseInt($('#vehicleType').val())
						}
				}, {},
				_w.tcstockview._onTuReceived, function(){alert('There were no trade and retail from TransUnion');}
			);
		},

		_onTuReceived : function ( response )
		{
			if ('Success' != response.Data.Status)
			{
				alert(response.Data.Status);
				return;
			}
			var vals = response.Data.VehicleDetails[0].Value;
      $('#retailPrice').val(vals.RetailPrice + '.00');
			$('#tradePrice').val(vals.TradePrice + '.00');
            $('#listPrice').val(vals.ListPrice + '.00');
			$('#' + _w.tcstockview.ti.tid + '_retailPrice').html('R ' + vals.RetailPrice + '.00');
			$('#' + _w.tcstockview.ti.tid + '_tradePrice').html('R ' + vals.TradePrice + '.00');
            $('#' + _w.tcstockview.ti.tid + '_listPrice').html('R ' + vals.ListPrice + '.00');
		},

		_prepStockUpdateData : function()
		{
			var data = _w.tcstockview.ti.harvest();
			data.km = '' == data.km
				? 0
				: parseInt(data.km);
			var retailPrice = $('#retailPrice').val();
			var tradePrice  = $('#tradePrice').val();
            var listPrice  = $('#listPrice').val();
			var retailAmountRequired  = $('#retailAmountRequired').val();
			data.retailPrice = ('' == retailPrice)
				? 0.00
				: parseFloat(retailPrice);
			data.tradePrice = ('' == tradePrice)
				? 0.00
				: parseFloat(tradePrice);
            data.listPrice = ('' == listPrice)
                ? 0.00
                : parseFloat(listPrice);
			data.retailAmountRequired = ('' == retailAmountRequired)
				? 0.00
				: parseFloat(retailAmountRequired);
			delete data.damageTotal;
			if ('' == data.mainImage)
			{
				delete data.mainImage;
			}
			if ('' == data.leftImage)
			{
				delete data.leftImage;
			}
			if ('' == data.backImage)
			{
				delete data.backImage;
			}
			if ('' == data.engineImage)
			{
				delete data.engineImage;
			}
			if ('' == data.frontImage)
			{
				delete data.frontImage;
			}
			if ('' == data.rightImage)
			{
				delete data.rightImage;
			}
			if ('' == data.interiorImage)
			{
				delete data.interiorImage;
			}
			if ('' == data.natisImage)
			{
				delete data.natisImage;
			}
			delete data.clubs;
			return data;
		},

		_onStockUpdated : function( response )
		{
			window.location.hash = '/tcstock';
		}

	};

})();